/***********************************************************************
<t@C>	afactmsg.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
	Ver.2.0 for MI-500
***********************************************************************/

/***********************************************************************
		APMvbZ[W`
***********************************************************************/
#ifndef _AFACTMSG_H_INCLUDED
#define	_AFACTMSG_H_INCLUDED
#include <apmlib.h>
#include <winlib.h>

typedef UCHAR DATAPATH;
#define	VIA_BOARD			1	/* Nbv{[hoR */
#define	HAVE_U_BYTE_VALUE	2	/* PoCgl */
#define	HAVE_S_BYTE_VALUE	3	/* PoCgl */
#define	HAVE_U_WORD_VALUE	4	/* QoCgl */
#define	HAVE_S_WORD_VALUE	5	/* QoCgl */
#define	HAVE_U_LONG_VALUE	6	/* SoCgl */
#define	HAVE_S_LONG_VALUE	7	/* SoCgl */
#define	VIA_MSG_BOARD		8	/* ` */
#define	DIRECT_INDEX_NO		9	/* DTMf[^w`̃CfbNXԍ */
#define	DIRECT_CARD_ID		10	/* DTMf[^w`̃J[hID */
#define	ZAS_INDEX_NO		11	/* ZAS^f[^w`̃CfbNXԍ */
#define	ZAS_CARD_ID			12	/* ZAS^f[^w`̃J[hID */
#define	ZAS_NUMBER_ID		13	/* ZAS^f[^w`̃ItZbg */
#define	VIA_ZAS_BUF			14	/* zasBufoR */

/* ZASf[^ʔԍ(8bytes) */
typedef struct ZAS_DATA_NO {
	APLID		AplName;		/* f[^LAvP[V */
	UCHAR		VolumeNo;		/* {[ԍ */
	UCHAR		DataType;		/* f[^ */
	USHORT		DataNo;			/* f[^ԍ */
} ZAS_DATA_NO;

typedef struct ZAS_BOARD {
	UCHAR		DataBoard;
	UCHAR		CtrlBoard;
} ZAS_BOARD;

/* ZASbZ[Wp[^(8bytes) */
typedef union ZAS_DATA {
	ZAS_BOARD	Board;			/* Nbv{[hԍ */
	USHORT		MsgBoardName;	/* ` */
	UCHAR		ucValue;
	char		cValue;
	USHORT		usValue;
	short		sValue;
	ULONG		ulValue;
	long		lValue;
	UCHAR		zasBuf[8];		/* ̒lɒӁI */
	ZAS_DATA_NO	ZASDataNo;
} ZAS_DATA;

/* ZASbZ[W(24bytes) */
typedef struct ZAS_INFO {
	APLFILTER	AplFilter;		/* ΏۃAvtB^ */
	USHORT		ServiceID;		/* T[rXID */
	USHORT		ServiceParam;	/* p[^ */
	UCHAR		Version;		/* o[W */
	DATAPATH	DataPath;		/* f[^oH */
	APLID		DestAplName;	/* ΏۃAv */
	APLID		SenderAplName;	/* MAv */
	ZAS_DATA	ZASData;		/* f[^ */
} ZAS_INFO;

struct APPLI_ZAS_COMMON_MSG {
	USHORT		MessageID;
	USHORT		OccuredTime;
	ZAS_INFO	ZASInfo;
};

/* ZASbZ[W */
struct APPLI_ZAS_MESSAGE
{
	USHORT		MessageID;			/* AppliZASMessageID */
	USHORT		OccuredTime;
	ZAS_INFO	ZASInfo;
};

/* ZASԓbZ[W */
struct APPLI_ZAS_ANSWER
{
	USHORT		MessageID;			/* AppliZASAnswerID */
	USHORT		OccuredTime;
	ZAS_INFO	ZASInfo;
};

/* EBhEĕ\v */
struct APPLI_WIN_REDISP {
	USHORT		MessageID;			/* AppliWinRedispID */
	USHORT		OccuredTime;		/*   */
	ZAS_INFO	ZASInfo;
	void		(*RedispFunc)();
	void		*RFArg;
	WINDOWHD	WnHandle;
};

/* vƂȂ蓾郁bZ[W */
struct	APPLI_END_REQ		/*  Avvintsvj  */
{
	USHORT		MessageID;		/*  AppliEndReqID  */
	USHORT		OccuredTime;	/*    */
	APLFILTER	AplFilter;		/*  Av̎w  */
	APLID		AplName;		/*  w̃Avio  */
};

struct  APPLI_STARTUP_REQ	/*  AvNv  */
{
	USHORT	MessageID;		/*  AppliStartupReqID  */
	USHORT	OccuredTime;	/*    */
	USHORT	StartCondition;	/*  N  */
	USHORT	ExecCondition;	/*    */
	APLID	ExecAppliName;	/*  NAvio  */
};

struct	APPLI_SERV_EXEC_REQ		/* AvP[VT[rXv */
{
	USHORT		MessageiD;			/* AppliServExecReqID */
	USHORT		OccuredTime;
	ZAS_INFO	ZASInfo;
	UCHAR		IsSticky;			/* 풓[hł̋NH */
};

struct	APPLI_SERV_END_REQ		/* AvP[VT[rXIv */
{
	USHORT		MessageID;		/* AppliServEndReqID */
	USHORT		OccuredTime;
	ZAS_INFO	ZASInfo;
};

struct APPLI_RE_EXEC_REQ		/* AvP[VEXECv */
{
	USHORT	MessageID;			/* AppliReExecReqID */
	USHORT	OccuredTime;
	USHORT	StartCondition;		/*  N  */
	USHORT	ExecCondition;		/*    */
	APLID	ExecAppliName;		/*  NAvio  */
};

#endif
