/***********************************************************************
<t@C>	apltool.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
	Ver.2.0 for MI-500
***********************************************************************/

/***********************************************************************
		ROCKET-OSpAvP[Vʊ֐pwb_t@C
***********************************************************************/
#ifndef _APL_TOOL_H_DEFINED

#include <sharpgen.h>
#include <timelib.h>
#include <alert.h>
#include <button.h>
#include <c_file.h>
#include <zdrawlib.h>
#include <drfio.h>

/* t@NVԍ */
#define	PIM_MAIN			0x41
#define	FRM_EVENT_HDL		0x42
#define	MOVE_FRAME_MSG		0x43
#define	RESIZE_FRAME_MSG	0x44
#define	GET_STR_LINE_NUM	0x45
#define	GET_LINE_TOP_ADR	0x46
#define	YMD_TEXT_TO_TIME	0x47
#define	HM_TEXT_TO_TIME		0x48
#define	TIME_TO_YMD_TEXT	0x49
#define	TIME_TO_HM_TEXT		0x4a
#define	ALERT_EXEC			0x4b
#define	ENTER_TO_NULL		0x4c
#define	FRM_DEF_REDISP		0x4d
#define	APL_RFILE_DIALOG	0x4e
#define	ALERT_EXEC_STR		0x4f
#define	FRM_CALL_ICON_MENU	0x50
#define	IS_SELECT_BUF		0x51
#define	GET_TIME_STAMP_DAY	0x52
#define	GET_TIME_STAMP_TIME	0x53
#define	DRAW_FRAME			0x54
#define	DRAW_STR			0x55
#define	DRAW_CARVED_LINE	0x56
#define	LIST_LINE_DELETE	0x57
#define	STR_WORD			0x58
#define	CHANGE_LINK_INFO	0x59
#define	DRAW_IMAGE_RES		0x5a
#define	DRAW_ICON_RES		0x5b
#define	DISP_STATUS_BAR		0x5c
#define	DRAW_STR_RES		0x5d
#define	SET_GUIGLOBAL		0x5e	/* ɓƂ낪Ȃ̂... */
#define	DISP_BATTERY_STATUS	0x5f
#define	COMSCR_CARD			0x60
#define	COMSCR_BUFFER		0x61
#define	GET_EXPORT_FNAME	0x62
#define	SER_POSTED_EXPORT	0x63
#define	OPEN_CONV_INFO_FILE	0x64
#define	GET_CONV_INFO_ITEM	0x65
#define	CLOSE_CONV_INFO_FILE	0x66
#define	SET_UP_CONV_INFO		0x67
#define	APPEND_CONV_INFO_ITEM	0x68
#define	CREATE_CONV_INFO_FILE	0x69
#define	GET_IMPORT_INFO			0x6a
#define	PIM_SETUP_VOLUME		0x6b
#define	PIM_DISABLE_VOLUME		0x6c
#define	APL_SET_RESUME_INFO		0x6d
#define	APL_GET_RESUME_INFO		0x6e
#define	APL_SET_SEARCH_DATA		0x6f
#define	APL_GET_SEARCH_DATA		0x70
#define	CATEGORY_BIN_TO_TEXT	0x71
#define	CATEGORY_TEXT_TO_BIN	0x72
#define	DELETE_CONV_INFO_FILE	0x73
#define	EXTRACT_ARCHIVE_DL		0x74
#define	GET_APL_ID_FROM_HEADER	0x75
#define	GET_APL_NAME_STRING		0x76
#define	DELETE_APPLICATION		0x77
#define	DRAW_APL_DATE			0x78
#define	IS_VALID_DATE_STR		0x79
#define	IS_VALID_TIME_STR		0x7a
#define	GET_SYSTEM_INFO			0x7b
#define	DRAW_JPEG_IMAGE			0x7c
#define	IS_DEVELOPER_MODE		0x7d
#define	SET_DEVELOPER_MODE		0x7e
#define	ALERT_EXEC_REPLACE_STR	0x7f
#define	COLOR_SELECTOR			0x80
#define	GET_DEVELOPER_MODE		0x81
#define	SET_OPENING_IMG_FNAME	0x82
#define	GET_OPENING_IMG_FNAME	0x83
#define	SET_OPENING_SND_FNAME	0x84
#define	GET_OPENING_SND_FNAME	0x85
#define	SET_OPENING_APL_NAME	0x86
#define	GET_OPENING_APL_NAME	0x87
#define	CLEAR_OPENING_APL_NAME	0x88
#define	CHANGE_TITLE_STR		0x89
#define	DELETE_FILES_IN_LIST	0x8a
#define	SET_WALLPAPER_FNAME		0x8b
#define	GET_WALLPAPER_FNAME		0x8c
#define	INSTALL_PCDATA_METHOD	0x8d
#define	UNINSTALL_PCDATA_METHOD	0x8e
#define	CALL_PCDATA_METHOD		0x8f
#define	DRAW_GIF_IMAGE			0x90
#define	GET_MENU_PTR_APLFORM	0x91
#define	ANIMATE_IMAGE			0x92
#define	ZFILE_SYS_CHECK			0x93

#define	APLTOOL_LAST_FUNC	ZFILE_SYS_CHECK

typedef USHORT	TTEXTTYPE;
#define	TSEP_NONE		0x0000
#define	TSEP_SLASH		0x0001
#define	TSEP_PERIOD		0x0002
#define	TSEP_KANJI		0x0003
#define	TIMESEP_MASK	0x000f

#define	TIME_USE_SPACE	0x8000

/* YMD`̒` */
#define	YMD_YEAR_BYTES	4
#define	YMD_MONTH_BYTES	2
#define	YMD_DAY_BYTES	2

#define	YMD_BUF_SIZE	(YMD_YEAR_BYTES+YMD_MONTH_BYTES+YMD_DAY_BYTES)

/* HM`̒` */
#define	HM_HOUR_BYTES	2
#define	HM_MINUTE_BYTES	2
#define	HM_SECOND_BYTES	2

#define	HMS_BUF_SIZE	(HM_HOUR_BYTES+HM_MINUTE_BYTES+HM_SECOND_BYTES)

#define	YMD_M_OFS	YMD_YEAR_BYTES
#define	YMD_D_OFS	(YMD_M_OFS+YMD_MONTH_BYTES)
#define	HM_M_OFS	HM_HOUR_BYTES
#define	HM_S_OFS	(HM_M_OFS+HM_MINUTE_BYTES)

/* nCp[eLXgp ʎq */
#define	HYPER_FIRST			0xef
#define	HYPER_SECOND		0xcc
#define	HYPER_TEXT_MARK		{ HYPER_FIRST,HYPER_SECOND }
#define	PICT_MARK			"PICTURE("
#define	POST_IT_MARK		{ 0xef,0xcc,'P','I','C','T','U','R','E','(',0 }
#define	SOUND_MARK			"SOUND("
#define	SOUND_MEMO_MARK		{ 0xef,0xcc,'S','O','U','N','D','(',0 }

#define	PICT_LINK_STR_BYTES		17
#define	PICT_LINK_MARK_BYTES	(PICT_LINK_STR_BYTES+11)

/* ʏꎞ\A[g{bNX̃}N` */
#define	DispTmpAlert(msg,file,id,pos)		\
((msg)->CommonMsg.MessageID = AlboxToolID,	\
 AlertExec(msg,file,id,pos,MESS_SMALL_LETTER))
#define	DispTmpErrAlert(msg,file,id,pos)		\
((msg)->CommonMsg.MessageID = AlboxToolID,	\
 AlertExec(msg,file,id,pos,MESS_SMALL_LETTER+ALB_OPEN_SOUND_CAUTION))

/* ftHgj[s */
#define	MenuExecObj(msg,list,atr,clbkfnc,clbkblk,work)		\
		MenuExecObjRes(msg,list,atr,clbkfnc,clbkblk,work,(UCHAR *)0,(USHORT)0)

/* ftHgItemIconRedisp() */
#define	IconOnlyRedisp(bwork,mwork) \
		ItemIconRedisp(bwork,mwork,(UCHAR (*)())0,(USHORT)0,(UCHAR *)0)
#define	FZ_INVALID_POINTY		-100*4

#define	IsSelectBufOK(buf,len)			IsSelectBuf(buf,len,(UCHAR)0)
#define	IsSelectBufData(buf,len)		IsSelectBuf(buf,len,(UCHAR)1)

/* VXeݒ֘A */
#define	SYSCONF_PREF_FILE		"SYSCONF "		/* vt@Xt@C */
#define	SYSCONF_VER				(UCHAR)1		/* t@Co[W */
#define	SYS_HELP_TAG			"HELP"			/* AVXgݒ */
#define	IS_HELP_ON				0x80
#define	HELP_CHAR_NO_MASK		0x0f

#define	SYS_USER_LEVEL_TAG		"USLV"			/* [Ux */
#define	SYS_MISC_TAG			"MISC"			/* ̑낢 */
#define	SYS_APO_TIME_TAG		"APOT"			/* I[gp[It */
#define	SYS_APO_DEF				720

#define	AP_CUT_BUF			0
#define	AP_SELECT_BUF		2

#define	SYSTEM_ON			1
#define	SYSTEM_RESET		0

/* ^CX^vobt@ */
#define	TIME_STAMP_BUF_LEN		20

/* A[g{bNX */
#define	ALBOX_MESS_LEN	512

#ifndef H2EQU
typedef struct APLALERTWORK {
	ALBOXWORK	AlboxWork;
	UCHAR		AlboxMess[ALBOX_MESS_LEN];
} APLALERTWORK;
#endif H2EQU

#ifndef H2EQU
typedef struct APLBTNWORK {
	BUTTONWORK	ButtonWork;
	BUTTON_DATA	ButtonData;
	USHORT		EndBtnID;
} APLBTNWORK;
#endif H2EQU

/* N^Cg */
#define	LINK_TITLE_LEN		16
#define	LINK_TITLE_BUF_LEN	(LINK_TITLE_LEN+1)

/* ChgTitleStr()  DispState */
#define CT_T_LD		0	/* ^Cg^Nt */
#define	CT_T		1	/* ^Cg */
#define	CT_T_D		2	/* ^Cg^t */

/* ֐` */
void
PIMMain(APLID AplName,USHORT InitLevel,APLRES *MyAplRes);
USHORT
GetStrLineNum(UCHAR *string,USHORT width,USHORT pitch);
UCHAR*
GetLineTopAdr(UCHAR *string,USHORT width,USHORT pitch,USHORT destline);
void
GetResName(RESFNAME ResFile,APLID AplName,RESTYPE ResType,RESFNO ResFNo);
HANDLE
GetAplResource(APLID AplName,RESTYPE ResType,RESFNO ResFNo,RESID ResID);
PTR
GetAplResPtr(APLID AplName,RESTYPE ResType,RESFNO ResFNo,RESID ResID);
USHORT
ReadAplRsrc(APLID AplName,RESTYPE ResType,
			RESFNO ResFNo,RESID ResID,USHORT Size,PTR Dest);
BOOLEAN
YMDTextToTime(TIME *Time,STRING YMDText,TTEXTTYPE TextType);
BOOLEAN
HMTextToTime(TIME *Time,STRING HMText,TTEXTTYPE TextType,HMS_MODE Mode);
BOOLEAN
TimeToYMDText(STRING YMDText,TIME *Time,TTEXTTYPE TextType);
HMS_MODE
TimeToHMText(STRING HMText,TIME *Time,TTEXTTYPE TextType,TIME_MODE Mode);
void
AlertExec(MESSAGE *Message,UCHAR *ResFile,USHORT StrID,
		  UCHAR Pos,USHORT type);
void
EnterToNull(STRING str);
void
AplReadFileDialog(MESSAGE *Message,UCHAR *WildName,UCHAR *DriveName,
				  RESOURCE *TitleStr,RESOURCE *GuideStr,
				  FFILTERFUNC FilterFunc,void *Work);

void
AlertExecStr(MESSAGE *Message,STRING Str,UCHAR Pos,USHORT type);
void
DrawFrame(WINDOWHD WnHandle,POINT *Start,POINT *End,
		  GCTABLE GCTable,GCTABLESET GCTableSet,
		  DOTSIZE DotSize,DF_MODE DFMode,
		  CDSPMODE Mode,RECTANGLE *Mask);
void
DrawStr(WINDOWHD WnHandle,POINT *Where,COLOR *Fg,COLOR *Bg,
		CDSPMODE Mode,PTR Str,short Pitch,
		RECTANGLE *Mask,DS_MODE DSMode);
void
DrawCarvedLine(WINDOWHD WnHandle,POINT *Where,USHORT LineLen,
			   GCTABLE GCTable,GCTABLESET GCTableSet,BOOLEAN IsVertical,
			   CDSPMODE Mode,RECTANGLE *Mask);
BOOLEAN
ChangeLinkInfo(MESSAGE *Message,STRING LinkTitle,TIME *LinkDate,
			   BOOLEAN IsTitleProtect,
			   CBPROC *FilterProc,void *Work,CBPROC *DrawProc);
WINDOWHD
open_sub_window(RESOURCE *WinRes);
void
DrawImageRes(WINDOWHD WnHandle,RECTANGLE *Where,
			 CDSPMODE DispMode,RESOURCE *ImageRes,
			 SCALEMODE Scale,RECTANGLE *Mask);
void
DrawIconRes(WINDOWHD WnHandle,POINT *Where,CDSPMODE DispMode,
			ICONMODE IconMode,GCTABLESET TableSet,
			RESOURCE *IconRes,RECTANGLE *Mask);
void
DrawStrRes(WINDOWHD WnHandle,POINT *Where,COLOR *Fg,COLOR *Bg,
		   CDSPMODE Mode,RESOURCE *StrRes,short Pitch,
		   RECTANGLE *Mask,DS_MODE DSMode);
void
DispStatusBar(MESSAGE *Message);
void
DispBatteryStatus(WINDOWHD WnHandle,POINT *Where);
BOOLEAN
GetExportFileName(FCFNAME ExportFName,STRING SufStr,UINT *Number);
UCHAR*
StrWord(STRING str,USHORT SearchWord,USHORT size);
int
ExtractArchiveDownLoad(UCHAR *ArchName,UCHAR *DriveName);
APLID
GetAplIDFromHeader(FCFNAME AplHFName);
BOOLEAN
GetAplNameString(APLID AplName,UCHAR *AplNameString,USHORT *Len);
BOOLEAN
DeleteApplication(FCFNAME AplHFName);
void
DrawAplDate(WINDOWHD WnHandle,POINT *Where,
			CDSPMODE DspMode,TIME *Time,RECTANGLE *Mask);
BOOLEAN
IsValidDateStr(UCHAR *Buf,BOOLEAN IsAlertDisp);
BOOLEAN
IsValidTimeStr(UCHAR *Buf,BOOLEAN IsAlertDisp);
void
GetSystemInfo(UCHAR *ModelName,ULONG *Version);
void
GetTimeStampDay(STRING buffer);
void
GetTimeStampTime(STRING buffer);
BOOLEAN
IsSelectBuf(UCHAR *buf,USHORT len,UCHAR Mode);
void
DrawJPEGImage(WINDOWHD WnHandle,RECTANGLE *Where,
			  CDSPMODE DispMode,DRFFILE *DrfFile,RECTANGLE *Mask);
void
DrawGIFImage(WINDOWHD WnHandle,RECTANGLE *Where,
			 CDSPMODE DispMode,DRFFILE *DrfFile,RECTANGLE *Mask);
BOOLEAN
IsDeveloperMode(void);
void
SetDeveloperMode(BOOLEAN IsOn);
void
AlertExecReplaceStr(MESSAGE *Message,UCHAR *ResFile,
					RESID StrID,UCHAR Pos,USHORT Type,
					STRING String1,STRING String2,STRING String3);
BOOLEAN
ColorSelector(MESSAGE *Message,COLOR *Color);
UCHAR
GetDeveloperMode(void);
BOOLEAN
SetOpeningImgFName(FCFNAME imageFName);
BOOLEAN
GetOpeningImgFName(FCFNAME imageFName,USHORT readLen);
BOOLEAN
SetOpeningSndFName(FCFNAME soundFName);
BOOLEAN
GetOpeningSndFName(FCFNAME soundFName,USHORT readLen);
BOOLEAN
SetOpeningAplName(APLID aplName,UCHAR priority);
BOOLEAN
GetOpeningAplName(APLID *aplName,UCHAR *priority);
void
ClearOpeningAplName(void);
BOOLEAN
ChangeTitleStr(MESSAGE *message,STRING linkTitle,TIME *linkDate,
			   UCHAR DispState,
			   CBPROC *filterProc,void *work,CBPROC *drawProc);
BOOLEAN
DeleteFilesInList(UCHAR *delFList,UCHAR *driveName);
BOOLEAN
SetWallPaperFName(FCFNAME wPaperFName);
BOOLEAN
GetWallPaperFName(FCFNAME wPaperFName,USHORT readLen);

#define	_APL_TOOL_H_DEFINED
#endif
