/***********************************************************************
<t@C>	apmlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
	Ver.2.0 for MI-500
***********************************************************************/

/***********************************************************************
		AvP[V}l[WCu
***********************************************************************/
#ifndef _APM_LIB_INCLUDED

#include <sharpgen.h>
#include <crystal.h>

#pragma	H2EQU_INCLUDE	"apmproc.seq"

#define	APM_PROC_NAME		'Papm'	/* APMvZX̖O */
#define	APM_QUEUE_NAME		'Qapm'	/* APML[̖O */
#define	APLL_QUEUE_NAME		'Qall'	/* AplLauncherL[̖O */
#define	APM_DEAD_QUEUE_NAME	'Qadi'	/* SʒmL[ */

/* ROMj^֘A̖O */
#define	RMON_PROC_NAME		'Prom'	/* ROMj^vZX */
#define	RMON_CODE_NAME		'Crom'	/* ROMj^R[h */

#define	FOREVER			-1

/* APML[̒P */
#define	APM_QUEUE_SIZE	sizeof(APMMESSAGE)		/*MACRO*/
#define	APM_QUEUE_LEN	10						/* APML[̑傫 */
#define	APL_QUEUE_LEN	1						/* AṽL[̑傫 */

#define	KILL_ME			self_end	/*MACRO*/

/* AvP[V^Cv */
typedef USHORT APLTYPE;

#define	STICKY				0x0001	/* bit0 : 풓Av(1) */
#define	TEMPORARY			0x0002	/* bit1 : ꎞNAv */
#define	ALWAYS_START_APL	0x0100	/* bit8 : ɃvZXN */	
									/*        MOREAvɑ΂Ă̂ݗL */
#define	NEED_PROCEND_MSG	0x0200	/* bit9	: vZXIbZ[Wv */
#define	CANNOT_RESTART		0x0400	/* bit10: ċNłȂAv */
									/* JJ[hȂǃn[hɊ֌W */
#define	DO_NOT_QUICK_LINK	0x0800	/* bit11: ȂČΉȂ */
									/* ZNgobt@𖳏NA */
#define	NEED_SUBLEVEL		0x1000	/* bit12: Tux󂯎 */
#define	NOT_LAUNCHED		0x2000	/* bit13: [`ɌȂ */
#define	QUICK_LINK_THROUGH	0x4000	/* bit14: ȂČ𓧉߂ */
#define	ACTIVE_PEN_MSG		0x8000	/* bit15: ANeBx[gvƂȂ */
									/* ybZ[W󂯎 */

/* AvP[V̏ */
typedef UCHAR APLSTATUS;
#define	NON_EXIST		0		/* e[uo^ */
#define	EXEC			1		/* ANeBu */
#define	OUT				2		/* OUT */
#define	NON_ACTIVE		3		/* ANeBu */
#define	KILLED			4		/* vZXS */
#define	EVENT_EXEC		5		/* Cxgs */
#define	SERVICE_EXEC	6		/* T[rXs */
#define	CHANGE_STATUS	7		/* ԑJڏ */
								/* opalłOUTnւ̑JڂʂĂ */
#define	AS_STOPPED		8		/* vZX~ */
/* AS_STOPPEDKILLED̓vZXԂƂĂ͓~ԂAAS_STOPPED */
/* ͐ɒ~ĂԂʂĕ\ */
#define	APLSTATUS_MASK	0xff

/* AvP[V̏(2) - ͑Sărbg */
typedef UCHAR APLSUBSTAT;
#define	ASS_FORBID_REDISP	1		/* ĕ\֎~ */
#define	ASS_CANNOT_EXEC		2		/* EXECԂւ͈ڍsłȂ */
									/* OUTbZ[W͎󂯂 */

/* xATux󂯎邽߂̃}N */
#ifndef H2EQU
#define	GetAplInitLevel(ILevel)		((ILevel)&0x00ff)
#define	GetAplInitSubLevel(ILevel)	(((ILevel)>>8)&0x00ff)
#endif H2EQU

/* Avwb_o[W */
#define	CRIMSON_APL_HEADER_VER	0x0001
#define	CRIMSON_APL_BETA_VER	0x0002

/* ZAS[h */
#define	ZAS_STICKY		1	/* 풓[hŎs */
#define	ZAS_NORMAL		2	/* ʏ탂[hŎs */
#define	ZAS_INVALID		-1	/* sȂ */

/* AvP[Vw@ */
typedef USHORT	APLFILTER;
#define	AF_ALL_APPLI		0		/* SẴAv */
#define	AF_THIS_APPLI		1		/* ̃Av */
#define	AF_APPOINT_APPLI	2		/* wAv */
#define	AF_NORMAL_APPLI		3		/* SĂ̒ʏAv */
#define	AF_STICKY_APPLI		4		/* SĂ̏풓Av */
/* opalŒǉ */
#define	AF_MORE_APPLI		5		/* SĂMOREAv */

typedef enum AAW_MODE {
	APM_ADD_TOP,
	APM_ADD_BOTTOM
} AAW_MODE;

/* AvP[V𓾂}N */
#define	GetMyAplName()		self_getname()

/* X^bN̈J[lɕԂ}N */
#define	ReleaseStack()		memory_stack_fold(self_get_sp())

typedef void (*APLMAINPROC)(APLID,USHORT,APLRES*,long);

/* hCuő咷 */
#define	APL_DRIVE_NAME_MAX	5

/* NAvw̗Dx */
#define	ON_PRIORITY_MAX		0		/* K */
#define	ON_PRIORITY_ALARM	5		/* A[ON܂ŗL */
#define	ON_PRIORITY_TOUCH	10		/* _CNg^b`ON܂ŗL */
#define	ON_PRIORITY_NONE	0xff	/* ftHĝݗL */

/* ֐錾 */

OBJECT_NAME GetQueueName();
BOOLEAN	APMAddWindow(WINDOWHD WnHandle,AAW_MODE Mode);
BOOLEAN APMDelWindow(WINDOWHD WnHandle);
WINDOWHD GetAPMTopWindow(void);
WINDOWHD GetAPMBottomWindow(void);
WINDOWHD GetNormWindowLevel(void);
int GetAplInfo(APLID AplName,APLTYPE *AplType,APLSTATUS *AplStatus);
int SearchApl(int IndexNo,APLID *AplName,APLTYPE *AplType);
BOOLEAN GetMyLauncherApl(APLID *AplName);
BOOLEAN IsAplDownloaded(APLID AplName);
BOOLEAN GetAplVolumeName(APLID AplName,UCHAR *VolumeName);
void AppliDataErr(APLID AplName,UCHAR *BoxFName);
int GetAplSubstat(APLID aplName,APLSUBSTAT *aplSubstat);
int SetAplSubstat(APLID aplName,APLSUBSTAT aplSubstat);
void DisableAplExec(void);
void EnableAplExec(void);

int	memory_stack_fold(char *);
char *self_get_sp(void);

/* t@NVԍ */
#define	APM_ADD_WINDOW			0x41
#define	APM_DEL_WINDOW			0x42
#define	APM_GET_TOP_WIN			0x43
#define	APM_GET_BOTTOM_WIN		0x44
#define	APM_GET_NORM_WIN_LEVEL	0x45
#define	APM_GET_APL_INFO		0x46
#define	APM_REGISTER_APL		0x47
#define	APM_GET_LAUNCH_APL		0x48
#define	APM_SEARCH_APL			0x49
#define	APM_SET_EVENT_MASK		0x4a
#define	APM_RESET_EVENT_MASK	0x4b
#define	APM_GET_APL_VOLUME_NAME	0x4c
#define	APM_APPLI_DATA_ERR		0x4d
#define	APM_SET_EVENT_MASK_AND	0x4e
#define	APM_SET_EVENT_OCRD_MASK	0x4f
#define	APM_SET_SUBSTAT			0x50
#define	APM_GET_SUBSTAT			0x51

/* ꃊ\[XID` */
#define	APL_INFO_RES_NUMBER		'00'
#define	APL_NAME_STRING_RESID	(USHORT)40000
#define	APL_NAME_STRING_RESTYPE	'DM'
#define	APL_ICON_RESID			(USHORT)40000
#define	APL_ICON_RESTYPE		'IC'
#define	APL_DEL_FLIST_RESID		(USHORT)40000
#define	APL_DEL_FLIST_RESTYPE	'ST'

#define	_APM_LIB_INCLUDED
#endif
