#include <zcppcmn.h>        /* C++ support  99/9/7 */
/* applfunc.h */
#ifndef _APPLFUNC_
#define _APPLFUNC_

#include <apladr.h>
#include <fuprocdef.h>
#include <crystal.h>
#include <msgsvlib.h>
#include <comdvlib.h>
#include <fusion.h>
#include <pppcmn.h>
#include <garbage.h>

/* #include <const.h> */

BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/7 */
#define	ERR			-1

/* Error Code */
/* queue_readERR(-1),QTIMEOUT(-2)`Ă邽-3` */
#define SENDERERR		-3
#define STATUSERR		-4

/* Configuration Define */
#define	AUTHPRO_PAP		0xc023
#define	AUTHPRO_CHAP		0xc223
#define	QUALPRO_LQR		0xc025

/* Configuration Parameter */
#define IPCP_MIN_MAXSLOT	3		/* VJőXbg̍ŏl */
#define IPCP_MAX_MAXSLOT	254		/* VJőXbg̍ől */

#define TIMER_MIN_RESTART	1		/* PPP^CAEgŏl */
#define TIMER_MAX_RESTART	127		/* PPP^CAEgől */
#define TIMER_MIN_RETRYCONF	0		/* Cfg-Reqđŏl */
#define TIMER_MAX_RETRYCONF	15		/* Cfg-Reqđől */
#define TIMER_MIN_RETRYTERM	0		/* Term-Reqđŏl */
#define TIMER_MAX_RETRYTERM	15		/* Term-Reqđől */
#define TIMER_MIN_IDLE		0		/* Idle^CAEgŏl */
#define TIMER_MAX_IDLE		127		/* Idle^CAEgől */

/* Default Configuration Parameter */
#define	DEF_NETMASK		0xFFFFFFFF
#define	DEF_MTU			1500
#define DEF_GETIPADDR		TRUE
#define DEF_GETNETMASK		TRUE

#define	DEF_MYMAXMRU		LCP_MAX_MTU
#define	DEF_MYASYNCTL		0x000A0000L
#define	DEF_MYAUTHPRO		AUTH_NONE
#define	DEF_MYQUALPRO		FALSE
#define	DEF_MYREPORTPERIOD	0
#define	DEF_MYMAGIC		FALSE
#define	DEF_MYMAGICSEED		0x00000000L
#define	DEF_MYPROCOMP		FALSE
#define	DEF_MYADDCOMP		FALSE

#define	DEF_MYCOMPROT		COMP_VANJAC
#define	DEF_MYIPADDRS		NOIPADDR
#define	DEF_MYMAXSLOT		MAX_STATES-1
#define	DEF_MYCOMSLOT		TRUE

#define	DEF_THEIRMAXMRU		LCP_MAX_MTU
#define	DEF_THEIRASYNCTL	0xffffffffL
#define	DEF_THEIRAUTHPRO	AUTH_NONE
#define	DEF_THEIRQUALPRO	FALSE
#define	DEF_THEIRREPORTPERIOD	0
#define	DEF_THEIRMAGIC		FALSE
#define	DEF_THEIRMAGICSEED	0x00000000L
#define	DEF_THEIRPROCOMP	FALSE
#define	DEF_THEIRADDCOMP	FALSE

#define	DEF_THEIRCOMPROT	FALSE
#define	DEF_THEIRIPADDRS	NOIPADDR
/* #define	DEF_THEIRMAXSLOT	0 */
/* #define	DEF_THEIRCOMSLOT	FALSE 1996/07/10 Modyfied */
#define	DEF_THEIRMAXSLOT	MAX_STATES-1
#define	DEF_THEIRCOMSLOT	TRUE

#define	DEF_AUTHSECRET		FALSE

#define	DEF_PPPRESTART		3			/* 3s */

#define	DEF_PPPRETRYTERM	2
#define	DEF_PPPRETRYCONFIG	10
#define	DEF_PPPRETRYFAIL	10

#define DEF_IDLETIMEOUT		0

BEGIN_EXTERN_C              /* C++ support  99/9/7 */
/* PPPAPI Function */
int send_event(int event,OBJECT_NAME resultqueue,int parameter);
int read_pboxevent(QUEUE_PBOX *pbox,int *mangevent,int *parameter);
int read_msgevent(EVENTMESSAGE *msg,int *mangevent,int *parameter);
void init_parameter(void);
int set_device(char * deviceP, COMMDEV * pDev);
int set_tcpipparam(unsigned long ipaddr, unsigned long netmask,
		    int max_socket, int getipaddr , int getnetmask);
int set_authparam(char *userid, char *passwd, int  authsecret);
int set_mypppparam(lcpconfig lcp_def, ipcpconfig ipcp_def,
		    wantflag flag_def);
int set_theirpppparam(lcpconfig lcp_def, ipcpconfig ipcp_def,
		       wantflag flag_def);
int set_timeoutparam(int ppprestart, int pppretryconfigure,
		      int pppretryterminate, int idle_timeout);
int set_commparam(int flow_control, int dcd_flag, int dsr_flag);
unsigned long get_myipaddr(void);
unsigned long get_theiripaddr(void);
void str_move (char *src, char *dest, int count);
unsigned long str_to_dev(char * str);
int manager_create(void);
int manager_create_task(void);
void manager_delete(void);
int add_api_resource(int rtype,unsigned long rname);
int del_api_resource(int rtype,unsigned long rname);
int garbage_collection(int command);
END_EXTERN_C                /* C++ support  99/9/7 */
END_NAMESPACE_ZAURUS        /* C++ support  99/9/7 */
#endif		/* _APPLFUNC_ */
