/***********************************************************************
<t@C>	bcommlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		{COMMT[rX( COMM.BIOS ) Ɋւ`
***********************************************************************/

#ifndef	_BCOMMLIB_H_INCLUDED
#define	_BCOMMLIB_H_INCLUDED

#include <ioercode.h>
#include <comdvlib.h>
#include <crystal.h>
#include <msgsvlib.h>
#include <abort.h>


/*======================================================================
							  R[h							  
======================================================================*/

#define	CODE_EOS	'\0'

#define	CODE_CR		0x0d
#define	CODE_LF		0x0a

#define	CODE_XON	0x11
#define	CODE_XOFF	0x13

#define	CODE_SHIFTIN	0x0e
#define	CODE_SHIFTOUT	0x0f

#define	CODE_EOF	0x1a


/*======================================================================
						SH^ IOCS G[R[h						  
======================================================================*/

#define	EC_BCOM_BAD_WORK_PTR	(BCOMM_EC_BASE+0x00) /* pBComAhX */
#define	EC_BCOM_BAD_PARAM		(BCOMM_EC_BASE+0x01) /* p[^ */
#define	EC_BCOM_WRONG_BCOMMODE	(BCOMM_EC_BASE+0x02) /* BCOMMODE\̓e */
#define	EC_BCOM_WORK_BROKEN		(BCOMM_EC_BASE+0x03) /* pBComeĂ */
#define	EC_BCOM_KERNEL_ERROR	(BCOMM_EC_BASE+0xFE) /* J[lŃG[ */
#define	EC_BCOM_BREAK			(BCOMM_EC_BASE+0xFFFD) /*"f"keyꂽ*/
#define	EC_BCOM_ABORTED			(BCOMM_EC_BASE+0xFFFE) /* A{[gꂽ */
#define	EC_BCOM_GENERAL_ERR		(BCOMM_EC_BASE+0xFFFF) /* LȊÕG[ */


/*======================================================================
								^錾								  
======================================================================*/

typedef int BCOMERR;					/* G[R[hԂ */
typedef unsigned short	BCOMEVENTS;		/* Cxg */

/* crystal.ȟ^`#defineōsȂĂ邽߁Ah2equʂȂ */
/* OBJECT_NAMȆ */
typedef ULONG object_name;


/*======================================================================
								\								  
======================================================================*/

typedef struct BCOMINFO {
	int	Version;	/* o[W */
	int	Rsv3;		/* ̊gp */
	int	Rsv2;		/* ̊gp */
	int	Rsv1;		/* ̊gp */
} BCOMINFO;

/**** BCOMINFO.Rsv? ****/
#define	BCOM_INFO_UNDEF	0


/*--------------------------------------------------------------------*/

typedef struct BCOMMODE{
	char	WorkSize;		/* sizeof(BCOMMODE)ݒ肷 */
	char	ByteSize;		/* DATABIT_7(7)=7bit, DATABIT_8(8)=8bit */	
	char	Parity;			/* PARITY_NONE(0)=Ȃ */
							/* PARITY_ODD(1)=, PARITY_EVEN(2)= */
	char	StopBits;		/* STOPBIT_1(0)=1bit, STOPBIT_1h(1)=1.5bit, */
							/* STOPBIT_2(2)=2bit */
	ULONG	BaudRate;		/* ݒ肳Ă{[[g\l */
	/*  */
	char	fTxCtsLook;		/* true: MCTSM */
	char	fTxDsrLook;		/* true: MDSRM */
	char	fRxDtrDrive;	/* true: MQueueԂDTRM𐧌䂷 */
	char	fRxRtsDrive;	/* true: MQueueԂRTSM𐧌䂷 */
	/*  */
	char	fRxXSend;		/* true: MQueueԂXON/XOFFo͂ */
	char	fTxXLook;		/* true: MXON/XOFFMԂ */
	char	fParity;		/* true: peB`FbNLɂ */
	char	fDoShift;		/* true: VtgIN/OUTsȂ */
	/*  */
	UINT	cStartRxFlow;	/* MQueuechar̒lȉ̎t[X^[g */
	UINT	cStopRxFlow;	/* MQueue̎c肪̒lȉ̎t[Xgbv */
	UINT	cVacantTxQue;	/* MQueuechar̒lȉ̎A󂫂Ɣ肷 */
	/*  */
	char	XonChar;		/* XON ɑMLN^ */
	char	XoffChar;		/* XOFFɑMLN^ */
	char	ShiftInChar;	/* Shift-IN  LN^ */
	char	ShiftOutChar;	/* Shift-OUT LN^ */
	/*  */
	char	fSendFaxMode;	/* true: M荞݂FAXpʎs */
	char	bRsv1;			/* \ */
	char	bRsv2;			/* \ */
	char	bRsv3;			/* \ */
							/* ȏAVer1.0̃o */
} BCOMMODE;

/* BCOMMODE.fAscii */
#define	BCOM_MD_BIN		0
/* #define	BCOM_MD_ASCII	1	BVer.͏ɃoCi[h */

/*--------------------------------------------------------------------*/

typedef	volatile struct BCOMQUE {
	char	*pBuf;			/* L[̐擪AhX */
	int		cCapacity;		/* L[̗e[byte] */
	int		iReadP;			/* ǂ݂|C^ */
	int		iWriteP;		/* ݃|C^ */
	char	fFull;			/* true: L[͖ł */
	char	fShiftIn;		/* true:  Shift-IN Ԃł */
	char	bRsv0;			/* \ */
	char	bRsv1;			/* \ */
} BCOMQUE;

/**** BCOMQUE.cCapacity ****/
#define	BCOM_QUE_CAPA_MAX	256*1024	/* Ŝ */
#define	BCOM_RXQUE_CAPA_MIN	2000		/* ML[̍ŏTCY */
#define	BCOM_TXQUE_CAPA_MIN	1000		/* ML[̍ŏTCY */

/**** BCOMQUE.iReadP/iWriteP ****/
#define	BCOM_QUE_TOP	0

/*--------------------------------------------------------------------*/
/* BCOMReLXg */
/* [U[̍\̓𒼐ړǂݏo^ނƂłւ */
/* sȂꍇ͕̓ۏ؂łȂǍ݊Ȃ */

typedef struct BCOM {
	int			WorkType;		/* [N^Cv */
	int			WorkSize;		/* [NTCY = sizeof(BCOM) */
	COMMDEV		*pDev;			/* LockĂʐMfoCX */
	BCOMMODE	Mode;			/* 샂[h */
	BCOMQUE		RxQue;			/* ML[ */
	BCOMQUE		TxQue;			/* ML[ */
	/*  */
	object_name	PrEventName;	/* event_create()O */
	object_name	PrIntrevName;	/* intrev_create()O */
	/*  */
	ABORTMASK	AbortMask;		/* A{[g}XN */
	ABORTCOND	AbortCond;		/* (AbortMask & LookAbort())̒l */
	/*  */
	BCOMEVENTS	EvSetEvMsgMask;	/* CxgbZ[Wo^ */
	BCOMEVENTS	EvOneShotFlags;	/* CxgbZ[Wo^ One Shot */
	BCOMEVENTS	EvWaitMask;		/* Cxg҂}XN */
	char		fBreak;			/* == BCOM_BREAK: u[NM */
	char		fXoffSent;		/* XOFF𑗐MiM~j*/
	char		fXoffReceived;	/* XOFFMiM~j*/
	char		fRtsActive;		/* RTSM̓ANeBuH */
	char		fDtrActive;		/* DTRM̓ANeBuH */
	char		RxFlowState;	/* Mt[ */
	char		bLastSendChar;	/* ŌɑM̃Rs[for FAX */
	char		fRsv1;			/*  */
	/*  */
	int			Errors;			/* G[R[h */
								/* o^CxgbZ[W */
	EVENTMESSAGE MsgDataArrive;
	EVENTMESSAGE MsgVacantTxQue;
	EVENTMESSAGE MsgRIRinging;
	EVENTMESSAGE MsgDCDOff;
	/* EVENTMESSAGE future	gꍇAɒu */
	/*  */
	/* Ō̃o̓O[hE邱 */
	/* BCOM\̂̌ɎMobt@ƑMobt@mۂ */
} BCOM;


/**** BCOM.WorkTypeiMagic numberj****/
#define	BCOMWORK_TYPE1	0x0000BC01
#define	BCOMWORK_TYPE_INVALID	0	/* [Ne͖ */

/**** BCOM.EvSetEvMsgMask ****/
/**** BCOM.EvOneShotFlags ****/
/**** BCOM.EvWaitMask ****/
#define	BCOM_EVENT_NONE			0x0000 /* vȂ */
#define	BCOM_EVENT_DATA_ARRIVE	0x0001 /* bit0: Mf[^ */
#define	BCOM_EVENT_VACANT_TXQUE	0x0002 /* bit1: ML[ɋ󂫂 */
#define	BCOM_EVENT_RI_RINGING	0x0004 /* bit2: RI(Ăї)Mo */
#define	BCOM_EVENT_DCD_OFF		0x0008 /* bit3: DCDMOFFɂȂ */

#define	BCOM_EVENT_ABORT		0x8000 /* bit15:A{[g([Uws)*/

#define	BCOM_EVENT_ALL			0x000F /* Sv */


/**** BCOM.RxFlowState ****/
#define	BCOM_RXFLOW_STARTED		1	/* Mt[ */
#define	BCOM_RXFLOW_STOP_REQ	0	/* Mt[~v */
#define	BCOM_RXFLOW_STOPPED		-1	/* Mt[~ */

/**** BCOM.Errors ****/
#define	BCOME_NO_ERRORS	0
								/* bit4`18250̃G[Ɠzu */
#define	BCOME_RXOVER	0x0001	/* ML[I[o[t[N(FULLɂȂ) */
#define	BCOME_OVERRUN	0x0002	/* I[o[G[o */
#define	BCOME_RXPARITY	0x0004	/* peB[G[o */
#define	BCOME_FRAME		0x0008	/* FRAMING ERRORo */
#define	BCOME_BREAK		0x0010	/* u[NM */
#define	BCOME_CTSTO		0x0020	/* CTS^CAEg */
#define	BCOME_DSRTO		0x0040	/* DSR^CAEg */
#define	BCOME_DCDTO		0x0080	/* DCD(CD,RLSD)^CAEg */
#define	BCOME_MODE		0x8000	/* T|[głȂ[hw肳ꂽ */

/*--------------------------------------------------------------------*/

typedef struct BCOMSTAT {
	UINT	Status;			/* BCOM̏ */
	int		Sig;			/* ݂̐̏ COMMSIG_xxxx */
	ABORTFLAG AbortCond;	/* A{[g(LookAbort() & pBCom->AbortMask) */
	UINT	cRxQue;			/* ݎML[ɎcĂLN^ */
	UINT	cTxQue;			/* ݑML[... */
	UINT	cRxQueCapacity;	/* ML[̗e */
	UINT	cTxQueCapacity;	/* ML[̗e */
	UINT	Rsv[3];			/* ̂ */
} BCOMSTAT;

/**** BCOMSTAT.Status ****/
#define	BCOMSF_CTSHOLD	0x01	/* CTSMactiveɂȂ܂œ]҂Ă */
#define	BCOMSF_DSRHOLD	0x02	/* DSRMactiveɂȂ܂œ]҂Ă */
#define	BCOMSF_XOFFHOLD	0x08	/* XOFFMߑM҂Ă */
#define	BCOMSF_XOFFSENT	0x10	/* XOFFMiXONMOj*/
#define	BCOMSF_EOF		0x20	/* EOFMiASCII[hj*/
#define	BCOMSF_TXIM		0x40	/* LN^]҂ԂɂȂĂ */

#ifndef H2EQU
#define	cReceiveQue	cRxQue
#endif H2EQU

/*======================================================================
					Cu֐vg^Cv錾					  
======================================================================*/

int	GetBCommInfo( BCOMINFO *pInfo );
int GetDefaultModeBComm( BCOMMODE *pMode );

BCOM *OpenBComm( COMMDEV *pDev, UINT cRcvQueue, UINT cSendQueue );
int CloseBComm( BCOM *pBComm );
int	SetModeBComm( BCOM *pBCom, const BCOMMODE *pMode );
int	GetModeBComm( BCOM *pBCom, BCOMMODE *pMode );
int ReadBComm( BCOM *pBCom, char *pBuf, UINT len );
int WriteBComm( BCOM *pBCom, const char *pSendData, UINT cData );
int SetBreakBComm( BCOM *pBCom );
int ClearBreakBComm( BCOM *pBCom );
int	FlushBComm( BCOM *pBCom, int queueType );
int GetBCommError( BCOM *pBCom );
int LookBCommState( BCOM *pBCom, BCOMSTAT *pStat );
int EscapeFunctionBComm( BCOM *pBCom, int func );
ABORTMASK SetAbortMaskBComm( BCOM *pBCom, ABORTMASK mask );
ABORTMASK LookAbortMaskBComm( BCOM *pBCom );
BCOMEVENTS EnableSetEventMsgBComm( BCOM *pBCom, BCOMEVENTS evMask );
BCOMEVENTS DisableSetEventMsgBComm( BCOM *pBCom, BCOMEVENTS evMask );
int WaitChangeBCommState( BCOM *pBCom, BCOMSTAT *pStat,
						  BCOMEVENTS WaitMask, int TimeOut );
int	ChangeEventMsgBComm( BCOM *pBCom, BCOMEVENTS Event,
						 const EVENTMESSAGE *pMsg );


/* FlushBComm( , xxx )	gw */
#define	BCOM_QUE_RECEIVE	0x10
#define	BCOM_QUE_SEND		0x20

/* EscapeFunctionBComm( , xxx ) */
/* ȉ̂ꂩЂƂ */
#define	CLRDTR	0x31
#define	CLRRTS	0x32
#define	SETDTR	0x33
#define	SETRTS	0x34
#define	SETXOFF	0x35
#define	SETXON	0x36

/* WaitChangeBCommState( ,,, xxx ) */
#define	BCOM_WAIT_FOREVER	-1	/* iɑ҂ */
#define	BCOM_WAIT_1SEC		100	/* Pb҂ */


/*======================================================================
				IOCSt@NVԍ	trapa #BCOMM_IOCS
======================================================================*/

#define	INIT_BCOMM					0x40 /* 						*/
#define	GET_BCOMM_INFO				0x41 /* BCOMM̏(ver)𓾂	*/
#define	GET_DEFAULT_MODE_BCOMM		0x42 /* ftHg̓샂[h𓾂*/
/* #define							0x43 reserved */
#define	OPEN_BCOMM					0x44 /* T[rXI[v		*/
#define	CLOSE_BCOMM					0x45 /* T[rXN[Y		*/
#define	SET_MODE_BCOMM				0x46 /* 샂[hݒ肷		*/
#define	GET_MODE_BCOMM				0x47 /* 샂[hǂݏo		*/
#define	READ_BCOMM					0x48 /* Mf[^ǂ			*/
#define	WRITE_BCOMM					0x49 /* Mf[^		*/
#define	SET_BREAK_BCOMM				0x4a /* u[NM𑗏o		*/
#define	CLEAR_BREAK_BCOMM			0x4b /* u[NM𑗏o~߂	*/
#define	FLUSH_BCOMM					0x4c /* Mobt@tbV*/
#define	GET_BCOMM_ERROR				0x4d /* G[ǂݏo			*/
#define	LOOK_BCOMM_STATE			0x4e /* ݂̏Ԃ			*/
#define	ESCAPE_FUNCTION_BCOMM		0x4f /* g@\s			*/
#define	SET_ABORT_MASK_BCOMM		0x50 /* A{[g}XNݒ肷	*/
#define	LOOK_ABORT_MASK_BCOMM		0x51 /* A{[g}XNǂݏo	*/
#define	ENABLE_SET_EVENT_MSG_BCOMM	0x52 /* Cxgmsgo^	*/
#define	DISABLE_SET_EVENT_MSG_BCOMM	0x53 /* Cxgmsgo^֎~	*/
#define WAIT_CHANGE_BCOMM_STATE		0x54 /* ԕω҂AԂ  */
#define	CHANGE_EVENT_MSG_BCOMM		0x55 /* o^CxgmsgύX*/


#endif	/* _BCOMMLIB_H_INCLUDED */

/* end of bcommlib.h */


