/***********************************************************************
<t@C>	classlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/****************************************************************
	qnbjds[nrpNX`wb_t@C
*****************************************************************/
#ifndef _CLASS_H_DEFINED
#define	_CLASS_H_DEFINED

#include "idxmenu.h"

/* vpeBǂ݂}N */
#define	GetCtrlProperty(parts,ptype,vtype,value,ctrltable,cast)	\
{																\
	MESSAGE GPMsg;												\
	GPMsg.CommonMsg.MessageID = GetPropertyID;					\
	GPMsg.GetProperty.PropertyID = ptype;						\
	ControlCall(parts,ctrltable,&GPMsg);						\
	value = (cast)GPMsg.GetProperty.Value.vtype;						\
}

/* vpeBݒ}N */
#define	SetCtrlProperty(parts,ptype,vtype,value,ctrltable)		\
{																\
	MESSAGE SPMsg;												\
	SPMsg.CommonMsg.MessageID = SetPropertyID;					\
	SPMsg.SetProperty.PropertyID = ptype;						\
	SPMsg.SetProperty.Value.vtype = value;						\
	ControlCall(parts,ctrltable,&SPMsg);						\
}

/* vpeBǂ݂}N() */
#define	GetCtrlItemProperty(parts,ptype,vtype,value,ctrltable,cast,item)	\
{																\
	MESSAGE GPMsg;												\
	GPMsg.CommonMsg.MessageID = GetPropertyID;					\
	GPMsg.GetProperty.PropertyID = ptype;						\
	GPMsg.GetProperty.ItemNo = item;							\
	ControlCall(parts,ctrltable,&GPMsg);						\
	value = (cast)GPMsg.GetProperty.Value.vtype;					\
}

/* vpeBݒ}N() */
#define	SetCtrlItemProperty(parts,ptype,vtype,value,ctrltable,item)		\
{																\
	MESSAGE SPMsg;												\
	SPMsg.CommonMsg.MessageID = SetPropertyID;					\
	SPMsg.SetProperty.PropertyID = ptype;						\
	SPMsg.SetProperty.Value.vtype = value;						\
	SPMsg.SetProperty.ItemNo = item;							\
	ControlCall(parts,ctrltable,&SPMsg);						\
}

/* vpeBݒ}NirbgZbgpj */
/* ݂̏ԂǂݏoORƂăZbg */
#define	SetCtrlPropertyBit(parts,ptype,vtype,value,ctrltable)		\
{																\
	MESSAGE SPMsg;												\
	ULONG tmpvalue;												\
	SPMsg.CommonMsg.MessageID = GetPropertyID;					\
	SPMsg.GetProperty.PropertyID = ptype;						\
	ControlCall(parts,ctrltable,&SPMsg);						\
	tmpvalue = (unsigned long)value | 							\
				(unsigned long)SPMsg.GetProperty.Value.vtype;	\
	SPMsg.CommonMsg.MessageID = SetPropertyID;					\
	SPMsg.SetProperty.PropertyID = ptype;						\
	SPMsg.SetProperty.Value.vtype = tmpvalue;						\
	ControlCall(parts,ctrltable,&SPMsg);						\
}

/* vpeBݒ}NirbgZbgpj */
/* ݂̏ԂǂݏoORƂăZbg */
#define	ResetCtrlPropertyBit(parts,ptype,vtype,value,ctrltable)		\
{																\
	MESSAGE SPMsg;												\
	ULONG tmpvalue;												\
	SPMsg.CommonMsg.MessageID = GetPropertyID;					\
	SPMsg.GetProperty.PropertyID = ptype;						\
	ControlCall(parts,ctrltable,&SPMsg);						\
	tmpvalue = (unsigned long)~value & 							\
				(unsigned long)SPMsg.GetProperty.Value.vtype;	\
	SPMsg.CommonMsg.MessageID = SetPropertyID;					\
	SPMsg.SetProperty.PropertyID = ptype;						\
	SPMsg.SetProperty.Value.vtype = tmpvalue;						\
	ControlCall(parts,ctrltable,&SPMsg);						\
}

/* vpeBݒ}NiڃrbgZbgpj */
/* ݂̏ԂǂݏoORƂăZbg */
#define	SetCtrlItemPropertyBit(parts,ptype,vtype,value,ctrltable,item)		\
{																\
	MESSAGE SPMsg;												\
	ULONG tmpvalue;												\
	SPMsg.CommonMsg.MessageID = GetPropertyID;					\
	SPMsg.GetProperty.PropertyID = ptype;						\
	SPMsg.GetProperty.ItemNo = item;							\
	ControlCall(parts,ctrltable,&SPMsg);						\
	tmpvalue = (unsigned long)value | 							\
				(unsigned long)SPMsg.GetProperty.Value.vtype;	\
	SPMsg.CommonMsg.MessageID = SetPropertyID;					\
	SPMsg.SetProperty.PropertyID = ptype;						\
	SPMsg.SetProperty.Value.vtype = tmpvalue;					\
	SPMsg.SetProperty.ItemNo = item;							\
	ControlCall(parts,ctrltable,&SPMsg);						\
}

/* vpeBݒ}NiڃrbgZbgpj */
/* ݂̏ԂǂݏoORƂăZbg */
#define	ResetCtrlItemPropertyBit(parts,ptype,vtype,value,ctrltable,item)	\
{																\
	MESSAGE SPMsg;												\
	ULONG tmpvalue;												\
	SPMsg.CommonMsg.MessageID = GetPropertyID;					\
	SPMsg.GetProperty.PropertyID = ptype;						\
	SPMsg.GetProperty.ItemNo = item;							\
	ControlCall(parts,ctrltable,&SPMsg);						\
	tmpvalue = (unsigned long)~value & 							\
				(unsigned long)SPMsg.GetProperty.Value.vtype;	\
	SPMsg.CommonMsg.MessageID = SetPropertyID;					\
	SPMsg.SetProperty.PropertyID = ptype;						\
	SPMsg.SetProperty.Value.vtype = tmpvalue;					\
	SPMsg.SetProperty.ItemNo = item;							\
	ControlCall(parts,ctrltable,&SPMsg);						\
}

/* {^DISABLEENABLE͓ʂɃ}N */
#define SetButtonDisable(parts,ctrltable,item)					\
{																\
	SetCtrlItemPropertyBit(parts,BUTTON_MODE_PID,usValue,		\
						   DISABLE_BUTTON,ctrltable,item);		\
}
#define SetButtonEnable(parts,ctrltable,item)					\
{																\
	ResetCtrlItemPropertyBit(parts,BUTTON_MODE_PID,usValue,		\
							 DISABLE_BUTTON,ctrltable,item);	\
}

/****************************************************************
	{^NX
*****************************************************************/

/* {^[N */
typedef struct BASICBUTTONWK{
	BUTTONWORK	Button;
	BUTTON_DATA	BtnData[1];		/* ϒ */
} BASICBUTTONWK,*BASICBUTTONWKPTR,**BASICBUTTONWKHD;

#define	MAX_BTN_NUM			200		/* {^ő吔 */

/* NbN{^[N */
typedef struct CLICKBUTTONWK{
	BASICBUTTONWKHD	MyBtnHd;	
	USHORT		KeyCode;
} CLICKBUTTONWK,*CLICKBUTTONWKPTR,**CLICKBUTTONWKHD;

/* g{^[N */
typedef struct CHARFRAMEBUTTONWK{
	BASICBUTTONWKHD	MyBtnHd;	
	USHORT		KeyCode;
	HANDLE 		DispStringHd;
	COLOR		StrFgColor;
	COLOR		StrBgColor;
	CBPROC*		MyCallBack;
	short 		CharPitch;
	short 		LinePitch;
} CHARFRAMEBUTTONWK,*CHARFRAMEBUTTONWKPTR,**CHARFRAMEBUTTONWKHD;

/* NbN{^[N */
/* typedef struct CLICKBUTTONINIT{ */
/*	BUTTONWORK	Button;
	BUTTON_DATA	BtnData;
	USHORT		NullID;
	USHORT		KeyCode;
} CLICKBUTTONINIT,*CLICKBUTTONINITPTR,**CLICKBUTTONINITHD; */

/* `FbN{^ */
typedef struct CHECKBUTTONWK {
	short				PosX;
	short				PosY;
	BOOLEAN			IsChecked;
	UCHAR			LCDMode;
	RESOURCE		IconOn;
	RESOURCE		IconOff;
	RESOURCE		BtnStr;
	/* ^Cgp */
	UCHAR			TitleStrCdspMode;
	COLOR			TitleStrFgColor;
	COLOR			TitleStrBgColor;
	BASICBUTTONWKHD	MyBtnHd;	
} CHECKBUTTONWK,*CHECKBUTTONWKPTR,**CHECKBUTTONWKHD;

/* ZNg{^ */
typedef struct SELECTBUTTONWK {
	short			TopBtnPosX;
	short			TopBtnPosY;
	short			FramePosX;
	short			FramePosY;
	USHORT			FrameWidth;
	USHORT			FrameHeight;
	UCHAR			Which;
	UCHAR			Type;
	/* ^Cgp */
	UCHAR			TitleStrCdspMode;
	HANDLE			TitleStrHd;
	COLOR			TitleStrFgColor;
	COLOR			TitleStrBgColor;
	BASICBUTTONWKHD	MyBtnHd;	
} SELECTBUTTONWK,*SELECTBUTTONWKPTR,**SELECTBUTTONWKHD;

/* ZNg{^[N */
typedef struct SELECTBUTTONINIT {
	short			TopBtnPosX;
	short			TopBtnPosY;
	short			FramePosX;
	short			FramePosY;
	USHORT			FrameWidth;
	USHORT			FrameHeight;
	UCHAR			Which;
	UCHAR			Type;
	USHORT			BtnNum;
	/* ^Cgp */
	UCHAR			TitleStrCdspMode;
	RESOURCE		TitleStrRes;
	COLOR			TitleStrFgColor;
	COLOR			TitleStrBgColor;
/*	RESOURCE		BtnRes[1]; */
} SELECTBUTTONINIT,*SELECTBUTTONINITPTR,**SELECTBUTTONINITHD;

/* Q{^ */
typedef DBUTTONWORK TABLEBUTTONWK,*TABLEBUTTONWKPTR,**TABLEBUTTONWKHD;

/****************************************************************
	̑NX
*****************************************************************/

/* XN[o[tXg */
typedef struct BARLISTWORK {
/*	LISTWORKHD	BLListHd; */
/*	BARWORKHD	BLBarHd; */
	LISTWORKHD	BLListHd; 
	BARWORKHD	BLBarHd; 
	METHODTBHD	BLListMethodTBHd;
	METHODTBHD	BLBarMethodTBHd;
} BARLISTWORK,*BARLISTWORKPTR,**BARLISTWORKHD;


/* yXNv^ */
typedef struct PENSCRIPTORWK {
	BOOLEAN		IsArrowPageScrl;		/* {^̓ */
	UCHAR		PenAttr;				/* y_ẼAgr[g */
} PENSCRIPTORWK,*PENSCRIPTORWKPTR,**PENSCRIPTORWKHD;

#define	PSBAR_VISIBLE	0x01
#define	PSBAR_LEFT		0x02

#define	BarList_List	0
#define	BarList_Bar		1

#define	LISTPTR(ctrltbl)			\
	MCP(BarList_List,LISTWORK**,ctrltbl)

#define	BARPTR(ctrltbl)			\
	MCP(BarList_Bar,BARWORK**,ctrltbl)

#define	MYDIALOG	((DIALOGWORKPTR)AplForm->AppliWorkPtr)

/* _CAONX */
typedef struct DIALOGWORK {
	UCHAR WnHandle;
	BOOLEAN IsSet;
	PTR MyWork;
	RESOURCE WindowRes;
	RESOURCE DialogFormRes;
} DIALOGWORK,*DIALOGWORKPTR,**DIALOGWORKHD;

#define	WITH_SCALE		0x01		/* ڐ̗L */

/* GARg[ */
typedef struct AREAWORK {
	UCHAR	WnHandle;
	POINT	Pos;
	UPOINT	Size;
} AREAWORK,*AREAWORKPTR,**AREAWORKHD;

/* CfbNX */
typedef struct INDEXINITWORK {
	UCHAR	IdxWindowNo;
	short		IdxStartPosX;
	short		IdxStartPosY;
	USHORT	IdxStartSizeX;
	USHORT	IdxStartSizeY;
	USHORT	IdxPosX;
	USHORT	IdxPosY;
	UCHAR	IdxMode;
	UCHAR	IdxTackNum;
	UCHAR	IdxTackStrMode;
	short		IdxTackSpace;
	GUICOLOR	IdxTackColor;
	USHORT		IdxTackWidth;
	USHORT		IdxTackHeight;

/*	IDX_TACK_STRC	IdxTackStrc[4]; */
	RESOURCE	TackStrRes;
} INDEXINITWORK,*INDEXINITWORKPTR,**INDEXINITWORKHD;

/* eL[Rg[ */
typedef struct TKEYWORK {
	POINT 			Pos;			/* W */
	DISPOBJHD 		Image;			/* pbhC[W */
	BASICBUTTONWKHD Button;			/* eL[{^ */
} TKEYWORK,*TKEYPTR,**TKEYHD;

/* ֐` */
#ifdef ESRL

USHORT StrWidth();

#else

USHORT StrWidth(PTR ,USHORT ,UCHAR);

#endif

#endif
