/***********************************************************************
<t@C>	dtmlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
			cslCu`
***********************************************************************/
#ifndef	_DTM_LIB_DEFINED
#define	_DTM_LIB_DEFINED
#include <sharpgen.h>
#include <file.h>

#ifndef H2EQU
#define	CardWrite	CardWriteNew  /* CardWriteɃoOCardWriteNewɒu */
#endif H2EQU

/* lXȌ^` */
typedef	HANDLE	BOXHANDLE;
typedef	UCHAR	DTMFNAME[16];	/* DTMt@C */
typedef ULONG	DATALEN;		/* DTMf[^CardRead/Writê */
typedef	USHORT	CARDID;			/* CardID */
typedef CARDID	INDEXNO;		/* IndexNo */
typedef	UCHAR	ITEMNAME[4];	/* ڎʖ */
typedef UCHAR	ITEMTITLE[38];	/* ڃ^Cg */
typedef USHORT	DTMERR;			/* DTMG[ */
typedef UCHAR	VOLUMENAME[3];	/* {[ */
typedef UCHAR	DTMFSTAT;		/* DTMt@C */
typedef	UCHAR	CATEGORYID;		/* JeS[ID */

/* f[^ID */
typedef UCHAR DATATYPE;
typedef UCHAR CONVTYPE;
#define	DATA_ID_CODE		0x01	/*  */
#define	DATA_ID_IMAGE		0x02	/* C[Wf[^ */
#define	DATA_ID_HTEXT		0x03	/* nCubheLXg */
#define	DATA_ID_TIME		0x04	/*  */
#define	DATA_ID_JIKAN		0x05	/*  */
#define	DATA_ID_BIT			0x06	/* rbg */
#define	DATA_ID_WEEK		0x07	/* Tj */
#define	DATA_ID_UINT		0x08	/* unsigned short */
#define	DATA_ID_BINARY		0x09	/* oCiubN */
#define	DATA_ID_UINT_GS		0x0a	/* SڃT[`ΏۂUINT */
#define	DATA_ID_UCHAR		0x0b	/* unsigned char */
#define	DATA_ID_BARRAY		0x0c	/* PoCgz */
#define	DATA_ID_COLOR		0x0d	/* J[f[^ */

#define	DATA_ID_WORD		DATA_ID_UINT
#define	DATA_ID_WORD_GS		DATA_ID_UINT_GS

#ifndef H2EQU
/* ʍڎʖ */
#define	SYS_CTGR_ITEM_NAME	(const char*)"CTGR"	/* JeS[ */
#define	SYS_ATTR_ITEM_NAME	(const char*)"ATTR"	/* Agr[g */
#define	SYS_TPID_ITEM_NAME	(const char*)"TPID"	/* VNԍ */
#define	SYS_MDTM_ITEM_NAME	(const char*)"MDTM"	/* C */
#define	SYS_MISC_ITEM_NAME	(const char*)"MISC"	/* pim script  */
#define	SYS_LKIF_ITEM_NAME	(const char*)"LKIF"	/* N */
#define	SYS_LKDT_ITEM_NAME	(const char*)"LKDT"	/* Nt */
#endif H2EQU

/* Ro[gID */
typedef enum CONVID {
	CONV_ID_UNKNOWN = 0,	/* ̋@ł͈Ȃ` */
	CONV_ID_WZTEXT,		 	/* iʏ퉢ĔWIZARD/ZAURUSeLXgj*/
	CONV_ID_SJIS1,		 	/* SJIS1iʏ{ZAURUS S-JISeLXgj*/
	CONV_ID_SJIS2,			/* SJIS2 Tu"MEM1:"t ʌ݊̂߁j*/
	CONV_ID_SJIS3,			/* SJIS3 PigpɐLj*/
	CONV_ID_CHKMARK,		/* SJIS4 ~ */
	CONV_ID_TIME,			/* 	Nbij*/
	CONV_ID_WEEK,			/* Tj	NTj */
	CONV_ID_CATEGORY,		/* JeS */
	CONV_ID_ALARMSW,		/* "ATTM"ialarm onj*/
	CONV_ID_ATTRIB,			/* "ATTR"isecretȂǁj*/
	CONV_ID_3TO4,			/* ϒoCi RtoSiTCYAǂj*/
	CONV_ID_BAHEX2,			/* ϒoCi PoCgQ16i */
	CONV_ID_1BHEX2,			/* PoCg(8bit) Q16i */
	CONV_ID_1WHEX4,			/* P[h(16bit)S16i */
	CONV_ID_1LHEX8,			/* PO(32bit)W16i */
    CONV_ID_IGNORE = 255    /* O֏o͂Ȃ^͎Aǂݎ̂Ă */
} CONVID;

/*	ʏVڂ쐬ꍇAʂȎiߋ̋@Ƃ̌݊
	ێȂǁjȂ

	oCi̍ڂɂ CONV_ID_3TO4
	eLXg̍ڂɂ CONV_ID_SJIS1i{ij
					   CONV_ID_WZTEXTiČij
	Ԃ̍ڂɂ CONV_ID_TIME

	p邱ƁB
*/


/* CARD\ */
typedef struct CARD {
	CARDID		CardID;
	ITEMNAME	ItemName;
} CARD;

/* ڏ` */
typedef	struct ITEMDATA {
 	DATATYPE	DataID;
 	CONVTYPE	ConvID;
 	ITEMNAME	ItemName;
 	ITEMTITLE	ItemTitle;
} ITEMDATA;

/* CfNXt@C^Cv */
typedef UCHAR	IDXFTYPE;
#define	MASTER_INDEX		0x11
#define	TEMP_INDEX		0x12

/* CfNXt@C */
typedef USHORT IDXINFOTYPE;
#define	BOX_NAME		(USHORT)0x01
#define	SORT_EXPRS		(USHORT)0x02
#define	SEARCH_EXPRS	(USHORT)0x03

/* ֐` */

DTMERR		BoxCreate(DTMFNAME *BoxFName, APLID AplName);
DTMERR		BoxDelete(DTMFNAME *BoxFName);
DTMERR		BoxItemAppend(DTMFNAME *BoxFName, ITEMDATA *ItemData,
						  USHORT ItemNum, BOOLEAN  *IsNewItemAdded);

DTMERR		BoxCardTotal(DTMFNAME *BoxFName, ULONG *BoxSize, USHORT *CardNum);
DTMERR		BoxItemDelete(DTMFNAME *BoxFName, ITEMNAME ItemName);
DTMERR		BoxItemModify(DTMFNAME *BoxFName, ITEMNAME ItemName,
						  ITEMDATA *ItemData);
DTMERR		BoxItemRead(DTMFNAME *BoxFName, ITEMNAME ItemName,
						ITEMDATA *ItemData, USHORT *Len);
BOXHANDLE	BoxOpen(DTMFNAME *BoxFName);
DTMERR		BoxClose(BOXHANDLE BoxFHd);

DTMERR		CardCreate(BOXHANDLE BoxFHd, CARDID *NewCardID);
DTMERR		CardCopy(BOXHANDLE BoxFHd, CARDID SrcCardID, CARDID *DestCardID);
DTMERR		CardDelete(BOXHANDLE BoxFHd, CARDID DelCardID);
DTMERR		CardWrite(BOXHANDLE BoxFHd, CARD *Card, PTR Data, DATALEN Len);
DTMERR		CardRead(BOXHANDLE BoxFHd, CARD *Card, PTR Data, DATALEN *Len);
DTMERR		CardAllDelete(BOXHANDLE BoxFHd,
						  UCHAR AttrMask, UCHAR AttrCond, UCHAR AttrFlag);

DTMERR		IndexCreate(DTMFNAME *IdxFName, IDXFTYPE Type);
DTMERR		IndexDelete(DTMFNAME *IdxFName);
DTMERR		IndexInfoWrite(DTMFNAME *IdxFName, IDXINFOTYPE IType,
						   PTR Info, USHORT Len);

DTMERR		IndexInfoRead(DTMFNAME *IdxFName, IDXINFOTYPE IType,
						  PTR Info, USHORT *Len);
DTMERR		IndexInfoDelete(DTMFNAME *IdxFName, IDXINFOTYPE IType);

DTMERR		IndexNoDelete(DTMFNAME *IdxFName, INDEXNO DelIdxNo);
DTMERR		IndexNoAppend(DTMFNAME *IdxFName,BOXHANDLE BoxFHd,
						  CARDID AddCardID, INDEXNO *AddedIndexNo);
DTMERR		IndexNoToCardID(DTMFNAME *IdxFName,
							INDEXNO IndexNo, CARDID *CardID);
DTMERR		CardIDToIndexNo(DTMFNAME *IdxFName,
							CARDID CardID, INDEXNO *IndexNo);
DTMERR		NextIndexNo(DTMFNAME *IdxFName,
						UCHAR AttrMask, UCHAR AttrCond, UCHAR AttrFlag,
						INDEXNO *IndexNo);
DTMERR		PrevIndexNo(DTMFNAME *IdxFName,
						UCHAR AttrMask, UCHAR AttrCond, UCHAR AttrFlag,
						INDEXNO *IndexNo);
DTMERR		IndexGroup(DTMFNAME *SrcIdxFName, DTMFNAME *DestIdxFName,
					   BOXHANDLE BoxFHd);
DTMERR		IndexUnGroup(DTMFNAME *IdxFName,BOXHANDLE BoxFHd);
DTMERR		IndexSearch(DTMFNAME *IdxFName,BOXHANDLE BoxFHd,
						PTR SearchCond, UCHAR Direction,
						UCHAR AttrMask, UCHAR AttrCond, UCHAR AttrFlag,
						INDEXNO StartIndexNo, INDEXNO *FoundIndexNo);
DTMERR		IndexSort(DTMFNAME *IdxFName,BOXHANDLE BoxFHd);

DTMERR		DTMFileCheck(DTMFNAME *DTMFName);

DTMERR		IndexCount(DTMFNAME *IdxFName, BOXHANDLE BoxFHd,
					   PTR SearchCond, UCHAR Direction,
					   UCHAR AttrMask, UCHAR AttrCond, UCHAR AttrFlag,
					   INDEXNO StartIndexNo, INDEXNO *FoundIndexNo,
					   USHORT *CountNo);
DTMERR		NumberToIndexNo(DTMFNAME *IdxFName,
							UCHAR Direction,
							UCHAR AttrMask, UCHAR AttrCond, UCHAR AttrFlag,
							INDEXNO	*IndexNo, USHORT Number);
DTMERR		IndexNoToNumber(DTMFNAME *IdxFName,
							UCHAR AttrMask, UCHAR AttrCond, UCHAR AttrFlag,
							INDEXNO IndexNo1,INDEXNO IndexNo2,USHORT *Number);
DTMERR		MoveIndexNo(DTMFNAME *IdxFName, INDEXNO SIndexNo, INDEXNO *TIndexNo);
DTMERR		GetItemName(DTMFNAME *BoxFName, USHORT, UCHAR *);
DTMERR		DTMFileCheckLevel(DTMFNAME *DTMFName, UCHAR Level);

/* CrimsonŒǉꂽt@NV */
DTMERR  	CardAppendBArray(BOXHANDLE BoxFHd,CARD *Card,CATEGORYID Data);
DTMERR		CardDeleteBArray(BOXHANDLE BoxFHd,CARD *Card,CATEGORYID Data);
DTMERR		CardClearBArray(BOXHANDLE BoxFHd,CARD *Card);
DTMFSTAT	DTMGetFileStatus(DTMFNAME *DTMFName);
DTMERR		DTMSetFileStatus(DTMFNAME *DTMFName,DTMFSTAT FStat);
DTMERR		BoxItemReadHeap(BOXHANDLE BoxFHd,ITEMNAME ItemName,
							ITEMDATA *ItemData,USHORT *Len);
DTMERR		CardOffsetRead(BOXHANDLE BoxFHd,CARD *Card,PTR Data,
						   DATALEN *Len,DATALEN ReadOffset);
DTMERR		CardOffsetWrite(BOXHANDLE BoxFHd,CARD *Card,PTR Data,
							DATALEN Len,DATALEN WriteOffset);
UCHAR		GetItemNum(BOXHANDLE BoxFHd) ;
DTMERR		WriteSyncBit(BOXHANDLE box_handle , CARDID cardID ,UCHAR syncbit ,UCHAR onoff);
DTMERR		GarbageCollect(DTMFNAME *BoxFName);
UINT		ReadGarbageSize(UCHAR DriveNo);
DTMERR		GarbageCollectAll(UCHAR DriveNo);
UCHAR		GarbageCheck(UCHAR DriveNo);
BOXHANDLE	BoxOpenEx(DTMFNAME *BoxFName);
DTMERR		WriteSystemcardSize(DTMFNAME *BoxFName,UCHAR size);
DTMERR		BoxSyncClear(DTMFNAME *BoxFName);
DTMERR		BoxSyncStart(DTMFNAME *BoxFName);
DTMERR		CardDeletePMSC(BOXHANDLE BoxFHd, CARDID DelCardID);
DTMERR		CalcGarbageSize(UCHAR DriveNo);

/* Agr[giQoCgj͂oh[SOOO			*/
/* SrbgU[uB̋@łɊg		*/
/* Kvꍇ͂cslt@C̃o[W	*/
/* ύXāAAgr[g̃oCg𑝂₷B			*/


/* Agr[g */
#define	ATTR_DELETE			0x40	/* 폜f[^ */
#define	ATTR_MARK			0x80	/* V[Nbg */

/* G[hc */
#define	DTM_NO_ERR		0x00

#define	S_PRT_DRV		0x20	/* PROTECT_CARD_ERROR */
#define	S_DRV_NF		0x21	/* NO_CARD_ERROR */

#define	S_FILE_NF		0x40	/* BLOCK_NOT_FOUND_ERROR */
#define	S_PRT_FILE		0x41	/* PROTECT_BLOCK_ERROR */
#define	S_DATA_NF		0x42	/* DATA_NOT_FOUND_ERROR */
#define	S_SAME_FILE		0x43	/* SAME_BLOCK_EXIST_ERROR */
#define	S_MEM_ERR		0x44	/* NO_ENOUGH_SIZE_ERROR */

#define	S_BAD_FORM		0x45	/* ̌ */
#define	S_BUF_FULL		0x46	/* ԃobt@TCYI[o[ */
#define S_STACK_OVR		0x47	/* X^bNI[o[ */
#define	S_SAME_DATA		0x48	/* ځAf[^ */
#define	S_BAD_NAME		0x49	/* ʖȂ܂ł */

#define	S_RNG_OVR		0x23	/* OUT_OF_RANGE_ERROR */
#define	S_QUIT_ERR		0xfe	/* low_battery_error f */
#define	S_SYS_ERR		0xff	/* SYSTEM_ERROR */

#define	S_PNT_ERR		0xe0
#define	S_EMP_ERR		0xe1

/* DTMFileCheckpG[R[h */
#define	DTM_VERSION_ERR		0x80	/*o[WقȂ*/
#define	DTM_SIZE_ERR		0x81	/*memory_block̃TCYɖ*/
#define	DTM_STRUCT_ERR		0x82	/*|C^̍\ɖ*/
#define	DTM_ITEM_STRUCT_ERR	0x83	/* ڑS̏̈̍\ */
#define DTM_CARD_STRUCT_ERR	0x84	/* J[ḧ̍\ */
#define	DTM_INFO_STRUCT_ERR	0x85	/* CfbNẌ悪 */
#define DTM_ID_TABLE_ERR	0X86	/* CfbNXJ[hID̈悪 */
		/* Boxt@COffsetTableꍇɂgp by matty */

#define	DTM_INDEX_NO_ERR	0xb1 	/*J[hhce[uCfNX00*/
#define	DTM_NO_IDX_ERR		0xb2	/*QƂĂIndext@C*/


/* DTMFileCheck`FbNx */
#define DTM_CHECK_FULL		0x00 	/*Ƃ`FbNx*/
#define DTM_CHECK_HARD		0x02 	/*`FbNx*/
#define DTM_CHECK_NORMAL	0x03 	/*ʏ̂₩ȃ`FbN*/


/* \[gAT[``x */

#define	INDEX_FIRST_BYTE	0xfe

/*------ \[g */

#define	INDEX_SHOUJUN		0x80	/* \[g */
#define	INDEX_KOUJUN		0x81	/* ~ */
#define	INDEX_CODE_SHOUJUN	0x82	/* oCi\[g */
#define	INDEX_CODE_KOUJUN	0x83	/* ~ */

/*------ T[` */

/* p */
#define	INDEX_ONAJI		0x90	/* Sv */
#define	INDEX_SENTOU	0x91	/* 擪܂ */
#define	INDEX_FUKUMU	0x92	/* Ɋ܂ */
#define	INDEX_IJOU		0x98	/* 擪rāAȏ */
#define	INDEX_CHOUKA	0x99	/* 擪rāA */
#define	INDEX_IKA		0x9a	/* 擪rāAȉ */
#define	INDEX_MIMAN		0x9b	/* 擪rāA */

/* AԁATjp */
#define	INDEX_ONAJI		0x90	/* Sv */
#define	INDEX_IJOU		0x98	/* ȏ */
#define	INDEX_CHOUKA	0x99	/*  */
#define	INDEX_IKA		0x9a	/* ȉ */
#define	INDEX_MIMAN		0x9b	/*  */

/* rbgf[^p */
#define	INDEX_BIT_TRUE		0x88
#define	INDEX_BIT_FALSE		0x89

/* dp */
#define	INDEX_SAME_DATA		0x94

/*------ ړq */

#define	INDEX_DATA_AND		0x84
#define	INDEX_DATA_OR		0x85

/*------ ڊԌq */

#define	INDEX_ITEM_AND		0x86
#define	INDEX_ITEM_OR		0x87

/*------ r[h */

#define	INDEX_BINARY_STR	0x95

/* VXeJ[h */
#define	DTM_SYSTEM_CARD_ID		0xff00	/* e|VXeJ[h */
										/* ΂ɎgȁII */
#define	RESUME_SYSTEM_CARD_ID	0xff10	/* W[p */

/* t@C */
#define	DTM_FILE_LEN		16

/*  */
#define	DTM_SEARCH_FORWARD	0
#define	DTM_SERACH_BACKWARD	1		/* XyԈႢ */
#define	DTM_SEARCH_BACKWARD	1

/* Agr[gtO */
#define	EQUAL_IS_TRUE		0
#define	UNEQUAL_IS_TRUE		1

#endif
