/***********************************************************************
<t@C>	editmsg.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_EDITMSG_H_INCLUDED
#define	_EDITMSG_H_INCLUDED
/*  GfB^bZ[W  */
#include <sharpgen.h>

/*  @GfB^AGfB^AtH[}bgGfB^AGfB^       ̔bZ[W  */

struct	EDITOR_CORE_CLEAR
{
	USHORT	MessageID;	/*  EditorCoreClearID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_GET_TABLE_SIZE
{
	USHORT	MessageID;	/*  EditorGetTableSizeID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_GET_MAX_COLUMN
{
	USHORT	MessageID;	/*  EditorGetMaxColumnID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_GET_MAX_LINE
{
	USHORT	MessageID;	/*  EditorGetMaxLineID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_GET_FRAME_SIZE_X
{
	USHORT	MessageID;	/*  EditorGetFrameSizeXID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_GET_FRAME_SIZE_Y
{
	USHORT	MessageID;	/*  EditorGetFrameSizeYID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_GET_LINE_PITCH
{
	USHORT	MessageID;	/*  EditorGetLinePitchID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_GET_DISP_LINE
{
	USHORT	MessageID;	/*  EditorScrollUpID  */
	USHORT	OccuredTime;	/*    */
	USHORT	Start;
	USHORT	End;
};

struct	EDITOR_GET_ALL_LINE
{
	USHORT	MessageID;	/*  EditorGetAllLineID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_SCROLL_LEFT_CURSOR
{
	USHORT	MessageID;	/*  EditorScrollLeftCursorID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_SCROLL_RIGHT_CURSOR
{
	USHORT	MessageID;	/*  EditorScrollRightCursorID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_GET_CHR_ADDRESS
{
	USHORT	MessageID;	/*  EditorGetChrAddressID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_GET_CHR_POSITION
{
	USHORT	MessageID;	/*  EditorGetChrPositionID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_MOVE_CURSOR
{
	USHORT	MessageID;	/*  EditorMoveCursorID  */
	USHORT	OccuredTime;	/*    */
	USHORT	X;
	USHORT	Y;
};

struct	EDITOR_MOVE_FRAME
{
	USHORT	MessageID;	/*  EditorMoveFrameID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_DISP_TOP
{
	USHORT	MessageID;	/*  EditorDispTopID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_DISP_CHR_ADDRESS
{
	USHORT	MessageID;	/*  EditorDispChrAddressID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_DISP_CHR_POSITION
{
	USHORT	MessageID;	/*  EditorDispChrPositionID  */
	USHORT	OccuredTime;	/*    */
	USHORT	X;
	USHORT	Y;
	USHORT	Fx;
	USHORT	Fy;
	USHORT 	Mode;
};

struct	EDITOR_DISP_CURSOR_TOP
{
	USHORT	MessageID;	/*  EditorDispCursorTopID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_DISP_CURSOR_ADDRESS
{
	USHORT	MessageID;	/*  EditorDispCursorAddressID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_DISP_CURSOR_POSITION
{
	USHORT	MessageID;	/*  EditorDispCursorPositionID  */
	USHORT	OccuredTime;	/*    */
	USHORT	X;
	USHORT	Y;
	USHORT	Fx;
	USHORT	Fy;
	UCHAR 	Mode;
};

struct	EDITOR_GET_DRAW_POINT
{
	USHORT	MessageID;	/*  EditorGetDrawPointID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_CLEAR_LINE_SPACE
{
	USHORT	MessageID;	/*  EditorClearLineSpaceID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_GET_TOUCH_POSITION
{
	USHORT	MessageID;	/*  EditorGetTouchPositionID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_CURSOR_OFF
{
	USHORT	MessageID;	/*  EditorCursorOffID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_DATA_SET
{
	USHORT	MessageID;	/*  EditorDataSetID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_TEXT_APPEND
{
	USHORT	MessageID;	/*  EditorTextAppendID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_CURSOR_ON
{
	USHORT	MessageID;	/*  EditorCursorOnID  */
	USHORT	OccuredTime; 	/*    */
};


/*  @GfB^AGfB^AtH[}bgGfB^AGfB^       ̔bZ[W  */

struct	EDITOR_CHANGE_ACTIVE_FRAME
{
	USHORT	MessageID;	/*  EditorChangeActiveFrameID  */
	USHORT	OccuredTime;	/*    */
	short	TopMove; 	/*  t[̈ړhbg  */
	short	BottomMove; 	/*  t[̈ړhbg  */
};

struct	EDITOR_SCROLL_UPDATE
{
	USHORT	MessageID;	/*  EditorScrollUpdateID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_SCROLL_UP
{
	USHORT	MessageID;	/*  EditorScrollUpID  */
	USHORT	OccuredTime;	/*    */
	short	Move;		/*  ړhbg  */
};

struct	EDITOR_SCROLL_DOWN
{
	USHORT	MessageID;	/*  EditorScrollDownID  */
	USHORT	OccuredTime; 	/*    */
	short	Move;		/*  ړhbg  */
};

struct	EDITOR_SCROLL_LEFT
{
	USHORT	MessageID;	/*  EditorScrollLeftID  */
	USHORT	OccuredTime; 	/*    */
	short	Move;		/*  ړhbg  */
};

struct	EDITOR_SCROLL_RIGHT
{
	USHORT	MessageID;	/*  EditorScrollRightID  */
	USHORT	OccuredTime; 	/*    */
	short	Move;		/*  ړhbg  */
};

struct	EDITOR_AUTO_SCROLL_UPDATE
{
	USHORT	MessageID;	/*  EditorAutoScrollUpdateID  */
	USHORT	OccuredTime;	/*    */
	USHORT	AllDataNo;	/*@Sf[^s  */
	USHORT	DispDataNo;	/*  \\f[^s  */
	USHORT	DispOffset;	/*  \Jnf[^s  */
};

struct	EDITOR_AUTO_SCROLL_UP
{
	USHORT	MessageID;	/*  EditorAutoScrollUpID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_AUTO_SCROLL_DOWN
{
	USHORT	MessageID;	/*  EditorAutoScrollDownID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_AUTO_SCROLL_LEFT
{
	USHORT	MessageID;	/*  EditorAutoScrollLeftID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_AUTO_SCROLL_RIGHT
{
	USHORT	MessageID;	/*  EditorAutoScrollRightID  */
	USHORT	OccuredTime;	/*    */
};

struct	EDITOR_CURSOR_DATA_TOP
{
	USHORT	MessageID;	/*  EditorCursorDataTopID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_CURSOR_DATA_END
{
	USHORT	MessageID;	/*  EditorCursorDataEndID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_CURSOR_UP_OVER
{
	USHORT	MessageID;	/*  EditorCursorUpOverID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_CURSOR_LOW_OVER
{
	USHORT	MessageID;	/*  EditorCursorLowOverID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_PRESS
{
	USHORT	MessageID;	/*  EditorPressID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_SELECT
{
	USHORT	MessageID;	/*  EditorSelectID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_DISP_OVER
{
	USHORT	MessageID;	/*  EditorDispOverID  */
	USHORT	OccuredTime; 	/*    */
	USHORT	ErrorCode;	/*  G[R[h  */
};

struct	EDITOR_TEXT_SELECT
{
	USHORT	MessageID;	/*  EditorTextSelectID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_TEXT_NORMAL
{
	USHORT	MessageID;	/*  EditorTextSelectID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_TEXT_CUT
{
	USHORT	MessageID;	/*  EditorTextCutID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_TEXT_COPY
{
	USHORT	MessageID;	/*  EditorTextSelectID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_ITEM_MOVE
{
	USHORT	MessageID;	/*  EditorItemMoveID  */
	USHORT	OccuredTime; 	/*    */
	UCHAR	OldItem;	/*  ړڔԍ  */
	UCHAR	NewItem;	/*  ړ捀ڔԍ  */
};

struct	EDITOR_CHAR_ERROR
{
	USHORT	MessageID;	/*  EditorCharErrorID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_ALREADY_CLEAR
{
	USHORT	MessageID;	/*  EditorAlreadyClearID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_NEXT_ITEM
{
	USHORT	MessageID;	/*  EditorNextItemID  */
	USHORT	OccuredTime; 	/*    */
};

struct	EDITOR_PREV_ITEM
{
	USHORT	MessageID;	/*  EditorPrevItemID  */
	USHORT	OccuredTime; 	/*    */
};

struct	FEDIT_CHECK_STATUS
{
	USHORT	MessageID;	/*	FEditCheckStatusID */
	USHORT	OccuredTime;	/*		*/
	UCHAR	*Work;
};

/****************************************/
/*@GfB^bZ[Whc̒`	*/
/*	͈́F@QSOO`QSXX	*/
/*	͈́F@QTOO`QTXX	*/
/****************************************/

	/*@bZ[W@*/
#define	EditorCoreClearID		2400
#define	EditorGetTableSizeID		2401
#define	EditorGetMaxColumnID		2402
#define	EditorGetMaxLineID		2403
#define	EditorGetFrameSizeXID		2404
#define	EditorGetFrameSizeYID		2405
#define	EditorGetLinePitchID		2406
#define	EditorGetDispLineID		2407
#define	EditorGetAllLineID		2408
#define	EditorScrollLeftCursorID	2409
#define	EditorScrollRightCursorID	2410
#define	EditorGetChrAddressID		2411
#define	EditorGetChrPositionID		2412
#define	EditorMoveCursorID		2413
#define	EditorMoveFrameID		2414
#define	EditorDispTopID			2415
#define	EditorDispChrAddressID		2416
#define	EditorDispChrPositionID		2417
#define	EditorDispCursorTopID		2418
#define	EditorDispCursorAddressID	2419
#define	EditorDispCursorPositionID	2420
#define	EditorGetDrawPointID		2421
#define	EditorClearLineSpaceID		2422
#define	EditorGetTouchPositionID	2423
#define	EditorCursorOffID		2424
#define	EditorDataSetID			2425
#define	EditorTextAppendID		2426
#define	EditorCursorOnID		2427



	/*@bZ[W@*/
#define	EditorChangeActiveFrameID	2500
#define	EditorChangeTextFrameID		2500
#define	EditorScrollUpdateID		2501
#define	EditorScrollUpID		2502
#define	EditorScrollDownID		2503
#define	EditorScrollLeftID		2504
#define	EditorScrollRightID		2505
#define	EditorAutoScrollUpdateID	2506
#define	EditorAutoScrollUpID		2507
#define	EditorAutoScrollDownID		2508
#define	EditorAutoScrollLeftID		2509
#define	EditorAutoScrollRightID		2510
#define	EditorCursorDataTopID		2511
#define	EditorCursorDataEndID		2512
#define	EditorCursorUpOverID		2513
#define	EditorCursorLowOverID		2514
#define	EditorPressID			2515
#define	EditorSelectID			2516
#define	EditorDispOverID		2517
#define	EditorTextSelectID		2518
#define	EditorTextNormalID		2519
#define	EditorTextCutID			2520
#define	EditorTextCopyID		2521
#define	EditorItemMoveID		2522
#define EditorCharErrorID		2523
#define EditorAlreadyClearID		2524
#define EditorNextItemID		2525
#define EditorPrevItemID		2526
#define	FEditCheckStatusID		2527

#endif
