/***********************************************************************
<t@C>	evthndl.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/
#include <zcppcmn.h>        /* C++ support  99/9/8 */
/****************************************************************
	`ckCxgnhO[``wb_t@C
*****************************************************************/
#ifndef _EVTHNDL_H_DEFINED
#define	_EVTHNDL_H_DEFINED

#ifndef H2EQU

#include <sharpgen.h>
#include <winlib.h>
#include <eventmsg.h>
#include <iconmenu.h>
#include <setjmp.h> //990927
/* #include <adl_cpu.h> */

BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/12/8 */

/* \bhe[u` */
typedef struct METHODTABLE {
	USHORT ControlEvent;			/* Rg[Cxghc */
	CBPROC MethodProc;			/* \bh֐|C^ */
} METHODTABLE,*METHODTBPTR,**METHODTBHD;

/* L[e[u` */
typedef struct KEYTABLE {
	USHORT KeyCode;				/* L[R[h */
	USHORT Event;					/* bZ[Whc */
	CBPROC MethodProc;			/* \bh֐|C^ */
} KEYTABLE,*KEYTBPTR,**KEYTBHD;

/* Rg[` */
typedef struct CONTROL {
	USHORT ControlNo;				/* Rg[ԍ */
	RESOURCE ControlRes;		/* RXgNg\[Xhc */
	HANDLE ControlHandle;		/* q[v̈ւ̃nh */
	USHORT MTResID;				/* \bhf[u\[X */
	METHODTBHD MethodTable;		/* \bhf[unh */
} CONTROL,*CONTROLPTR,**CONTROLHD;

/* AvP[VǗptH[ */
/* Jp */
typedef struct APLFORM {
	WINDOWHD	FormWnHandle;		/* EBhEnh */
	PTR			UserWork;			/* [U[N */
	BOOLEAN 	IsExit;				/* ʂ𔲂邩ǂ̃tO */
	PTR			AppliWorkPtr;		/* AvP[V[N */
	CONTROLHD 	Control;			/* eRg[nh */
	UCHAR		ControlNum;			/* Rg[̐ */
	USHORT		FormType;
	EVENTMSGMASK	FormEventMask;	/* GetMessage()}XNl */
	ICONMENUHDL	IconMenuHd;			/* t[eBOj[nh */
} APLFORM,*APLFORMPTR,**APLFORMHANDLE;

/* Rg[` */
typedef struct C_CONTROL {
/* public: */
	HANDLE ClassHd;					/* NXŗL̃[Nnh */
	CONTROLHD Control;				/* eRg[nh */
/* private: */
	USHORT ControlResID;				/* Rg[񃊃\[X */
	CBPROC CC_Construct;			/* [U[Nݒp֐ */
	CBPROC CC_SetUp;				/* [U[Nݒp֐ */
	CBPROC CC_AllMethod;			/* ̑̃\bh֐ */
	CBPROC CC_Destruct;				/* tH[[N֐ */
} C_CONTROL,*C_CONTROLPTR,**C_CONTROLHD;

/* Rg[\[X */
typedef struct C_CONTROLINT {
	RESOURCE	C_ControlRes;		/* Rg[Lq\[X */
	RESOURCE	C_ControlInitRes;	/* NX\[X */
	RESOURCE	MyWorkRes[1];		/* eRg[\[X */
} C_CONTROLINT,*C_CONTROLINTPTR,**C_CONTROLINTHD;

/* Rg[ANZX}N (MyControlPtr) */
#define	MCP(parts,type,ctrltbl)						\
	(*((type)(*ctrltbl)[parts].ControlHandle))


/* O}N */
#define	TRY										\
		{	jmp_buf	_reg;						\
			if(!setjmp(_reg)){

#define	CATCH									\
			}else{

#define	ENDTRY									\
			}									\
		}

#define	FAIL_PROC								\
			longjmp(_reg,1)

/* GetMenuPtrAplForm()̑P */
typedef enum GMP_PARAM {
	GMP_LIST,
	GMP_ATTR
} GMP_PARAM;

/* j[Xg擪AhX擾}N */
#define	GetMenuListAplForm(af)	((*(af)->IconMenuHd)->MenuList)

/* j[擪AhX擾}N */
#define	GetMenuAttrAplForm(af)	GetMenuPtrAplForm(GMP_ATTR,(af))
/* #define	GetMenuAttrAplForm(af)	((*(af)->IconMenuHd)->MenuAtr) */

/* ֐` */
BEGIN_EXTERN_C              /* C++ support  99/9/8 */
HANDLE ControlCall(int Parts,CONTROLHD CtrlTbl,MESSAGE *Message);
HANDLE ClassObj(USHORT,MESSAGE *,HANDLE);
void FormEventHandling(MESSAGE *,RESOURCE *,PTR,WINDOWHD,void*);
void FormDefRedisp(APLFORMPTR AplForm,WINDOWHD wh);
UCHAR *GetMenuPtrAplForm(GMP_PARAM param,APLFORMPTR aplForm);
END_EXTERN_C                /* C++ support  99/9/8 */
END_NAMESPACE_ZAURUS		/* C++ support  99/12/8 */

#endif H2EQU

BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/12/8 */
/* tH[l(gpėǂ͉̂ʂPoCĝ) */
#define	WITH_MENU				0x0001
#define	WITH_SMENU				0x0002
#define	WITH_HELP				0x0004
#define	NOT_CLEAR				0x0008	/* ŏ̕\ł̓NAsv */
#define	MODAL_GET_MESSAGE		0x0010	/* GetModalMessage()Ă */
#define USE_SLIM_MENU			0x0020  /* WITH_MENUƂƂɎg */
                                                /* Xj[gݒ */
#define USE_STRING_MENU			0x0040  /* WITH_MENUƂƂɎg */
                                        /* EX1V[Y̕񃁃j[ */

/* ʂPoCg */
#define	FORM_FIRST_DISP			0x8000	/* ŏ̕\ */
#define	FORM_ERR_OCCURRED		0x4000	/* G[ */
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif
