/***********************************************************************
<t@C>	inputpad.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/*
;;****************************************************************
;	̓pbh structure
;;****************************************************************
*/

#ifndef	_INPUTPAD_INCLUDED
#define	_INPUTPAD_INCLUDED

#ifndef H2EQU
#include	<editor.h>
#include	<scroll.h>
#endif H2EQU

/************************/
/*	萔̒`	*/
/************************/

#define	KC3_CHOUONN			(0xb0)		/*  */
#define	KC3_DAKUON_HENKAN	(0x0fff)	/* ϊ	*/
#define	KC_CHOUONN			KC3_CHOUONN
#define	KC_DAKUON_HENKAN	KC3_DAKUON_HENKAN

/*------------------------------------------------------*/
/*	ʕ̓ǂ݃obt@i[U[pӂj	*/
/*------------------------------------------------------*/
#define	PAD_YOMI_MAX		(40)
	/* ʕ̓ǂ݂̍ő啶 */
#define	PAD_YOMI_MAX_SIZE	(PAD_YOMI_MAX*2)
	/* ʕ̓ǂ݂̍őTCY */
#define	PAD_YOMI_BUF_SIZE	(PAD_YOMI_MAX_SIZE+2)
	/* ʕ̓ǂ݃obt@̃TCY */

/*------------------------------------------------------*/
/*	ʕobt@i[U[pӂj	*/
/*------------------------------------------------------*/
#define	PAD_MOJI_MAX		(PAD_YOMI_MAX+5)
	/* ʕ̍ő啶 */
	/* iőAǂݕ{SɂȂ邪]Tā{TƂj */
#define	PAD_MOJI_MAX_SIZE	(PAD_MOJI_MAX*2)
	/* ʕ̍őTCY */
#define	PAD_MOJI_BUF_SIZE	(512)
	/* ʕobt@̃TCY */


/*--------------------------------------*/
/*	GfB^obt@[PadEditBuf]	*/
/*--------------------------------------*/
#define	PAD_EDIT_MAX		PAD_YOMI_MAX
	/* GfB^̈ő啶 */
#define	PAD_EDIT_MAX_SIZE	(PAD_EDIT_MAX*2)
	/* GfB^̈őTCY */
#define	PAD_EDIT_BUF_SIZE	(PAD_EDIT_MAX_SIZE+2)
	/* GfB^obt@̃TCY */

/*------------------------------*/
/*	Fpbhobt@	*/
/*------------------------------*/
#define	PAD_NSK_MAX		20
	/* F̍ő啶 */
#define	PAD_NSK_MAX_SIZE	(PAD_NSK_MAX*2)
	/* F̍őTCY */
#define	PAD_NSK_BUF_SIZE	(PAD_NSK_MAX_SIZE+2)
	/* Fobt@̃TCY */

/*------------------------------*/
/*	R[h̒`		*/
/*------------------------------*/
#define	CodeKireme	(0x4221)		/* Aߕϊʂ̐؂ڃ}[N a  */

#define	NSK_HALF_MARK_CODE_R		(0x4cfb)	/*@p}[N[FB4CH]̋t]@*/
#define	NSK_SPACE_MARK_CODE_R		(0xf284)	/*@SpXy[X}[N[84F2H]̋t]@*/
#define	NSK_HALF_SPACE_MARK_CODE_R	(0x4bfb)	/*@pXy[X}[N[FB4BH]̋t]@*/
#define	SPACE_CODE			(0x8140)	/*@SpXy[X[8140H]@*/
#define	SPACE_CODE_R		(0x4081)	/*@SpXy[X[8140H]̋t]@*/
#define	HALF_SPACE_CODE		(0x20)		/*@pXy[X@*/

#define	Chr12Width		(24)		/* PQhbg̕sb` */
#define	KouhoDispStartX	(7*4)		/* \̈捶[xW */
#define	KouhoDispStartY	(5*4)		/* \̈捶[yW */
#define	KouhoDispEndX	(127*4-1)	/* \̈E[xW */
#define	KouhoDispEndY	(17*4-1)	/* \̈E[yW */


/*------------------------------*/
/*	ߋ؂̈ړ	*/
/*------------------------------*/
#define	Right		(0x00)		/* E */
#define	Left		(0x01)		/*  */
#define	ChgFocus	(0x02)		/* ϊΏە߂ς */

/*------------------------------*/
/*	ϊ̎		*/
/*------------------------------*/

#define	BunsetuHenkanID	(0)	/* ߕϊ */
#define	OnkunHenkanID	(1)	/* Pϊ */

/********************************/
/*	Pϊp[N	*/
/********************************/

#define	SIZE_ONKEKKA	(1024)			/* ʃobt@̃TCY */
#define	SIZE_KANABF		(MAX_MOJI+1)	/* obt@̃TCY */
#define	Onk1sui			(0)				/* P݂̂Ō */
#define	Onk2sui			(1)				/* Q܂߂Č */
#define	KanaJisH		(0x24)			/* ȂihrR[h̏ʃoCg */

/************************/
/*	ݒl̒`		*/
/************************/

	/*----------------------------*/
	/* wKpbh̑	 	  */
	/*----------------------------*/
#define	PAD_STUDY_NUM	(5)

	/*--------------------*/
	/* pbhID [PadID] */
	/*--------------------*/
#define AUTO_PAD_ID		(0x00)	/* 菑F/QWERTY/SHARP玩 */
/*@͈̑ȉ[PadType]Ɠl@*/

	/*----------------------------------------*/
	/* pbh̐؂ւړ͈͎w [PadType] */
	/*----------------------------------------*/
#define	NINSHIKI_PAD_ID		(0x001)		/* 菑F */
#define	QWERTY_PAD_ID		(0x002)		/* QWERTY */
#define	SHARP_PAD_ID		(0x004)		/* SHARP */
#define	TIME_PAD_ID			(0x008)		/*  */
#define	SYMBOL_PAD_ID		(0x010)		/* L */
#define	CODE_PAD_ID			(0x020)		/* _ */
#define	USER_PAD_ID			(0x040)		/* [U */
#define	OCR_PAD_ID			(0x080)		/* nfBOCR */
#define	OPTION_SMALL_PAD_ID	(0x080)		/* IvVL[{[hij */
#define	OPTION_LARGE_PAD_ID	(0x8000)	/* IvVL[{[hij */
#define	HIRA_PAD_ID			(0x100)		/* TO */
#define	DEFWORD_PAD_ID		(0x200)		/* p */

#define	KUSEJI_PAD_ID		(0x400)		/*  */
#define	INK_PAD_ID			(0x1000)	/* CN̓pbh */
#define	CLIP_PAD_ID			(0x800)		/* Nbvpbh */
#define	INK_RECOG_PAD_ID	(0x2000)	/* CNFpbh */
#define	EI_MINI_PAD_ID		(0x4000)	/* p͗p~jpbh */

#define	ALL_PAD_TYPE		(0x7fff)	/* Spbh̃^Cv */

/* ʏ̃AvP[Vw肷pbh^Cv */
/* #define	NORM_APPLI_PADTYPE	(NINSHIKI_PAD_ID+QWERTY_PAD_ID+SHARP_PAD_ID+TIME_PAD_ID+SYMBOL_PAD_ID+CODE_PAD_ID+USER_PAD_ID+HIRA_PAD_ID+DEFWORD_PAD_ID+CLIP_PAD_ID); */
#define	NORM_APPLI_PADTYPE	(0x0b7f)

/* wK̑ΏۂƂȂpbh̃^Cv */
#define	STUDY_PADTYPE_MASK	(NINSHIKI_PAD_ID+QWERTY_PAD_ID+SHARP_PAD_ID+HIRA_PAD_ID)

/* pbh؂ւ{^oȂpbh̃^Cv */
#define	NO_CHG_BTN_PADTYPE	(KUSEJI_PAD_ID+INK_RECOG_PAD_ID+EI_MINI_PAD_ID)


	/*-----------------------------------*/
	/*@pbh̃[hwԁmPadModen*/
	/*-----------------------------------*/
#define	HANKAKU_STATE		(0x01)	/* p */
#define	CAPS_STATE			(0x02)	/*  */
#define	HIRA_STATE			(0x04)	/* Ђ */
#define	KATA_STATE			(0x08)	/* J^*/
#define	EI_STATE			(0x10)	/* p */
#define	SYMBOL_STATE		(0x20)	/* L */
#define	HALF_SYMBOL_STATE	(0x40)	/* pL */
#define	PICTURE_STATE		(0x80)	/* GL */

	/*--------------------------------------*/
	/* board ؂ւ̏ԕ\ [PopUpMod]  */
	/*--------------------------------------*/
#define	POPMODE_DEF		0		/* ftHgl */
#define	BOARD_MEMU_OFF_STAGE	(0xfe)	/* ؂ւj[ off */
#define	BOARD_MEMU_ON_STAGE		(0x01)	/* ؂ւj[\ */
#define SYMBOL_DE_KA_ON			(0x02)	/* ŁA@Lɂ */
#define STRING_NO_EDIT			(0x04)	/* pbhGfB^ʂȂ */
#define	OPT_KEYPAD_SMALL	(0x08)	/* IvVL[{[hpbhij̗p */
#define	TAB_KEY_ON			(0x10)	/* ^uL[*/

	/*-----------------------*/
	/*  QWERTY  [PadState] */
	/*-----------------------*/
#define	EDIT_STAGE			(1)	/* GfB^ */
#define	HENKAN_STAGE		(2)	/* Aߌ\ */
#define	HENKAN_FREE_STAGE	(3)	/* ߒύX̌\ */
#define	ONKUN_STAGE			(4)	/* Pϊ\ */
#define	JINMEI_STAGE		(5)	/* lnϊ\ */
#define	SAIYOU_STAGE		(6)	/* F́usvu̗pvúv҂ */
#define	DELETE_STAGE		(7)	/* F́uށvu폜v҂ */
#define	GAKU_STAGE			(8)	/* F́uwKv҂ */

	/*-------------------------*/
	/*@o[̎ԐmBarModen*/
	/*-------------------------*/
#define	TIMEPAD_24_BAR		(0x00)	/* QSԐ */
#define	TIMEPAD_12_BAR		(0x01)	/* PQԐ */

#define	TIMEPAD_AM_BAR		(0x00)	/* AM0:00(0:00)\ */
#define	TIMEPAD_PM_BAR		(0x01)	/* PM11:00(23:00)܂ł\ */

/* F̊e{^̃rbgtO */
#define	NSK_RECOG_BTN_NON		(0x00)
#define	NSK_RECOG_BTN_HENKAN	(0x01)
#define	NSK_RECOG_BTN_SAIYOU	(0x02)
#define	NSK_RECOG_BTN_DELETE	(0x04)
#define	NSK_RECOG_BTN_GAKUSYU	(0x08)

/* button id of pad for application */
#define	InputBtnID	((USHORT)40048)		/* enter (qw_entrID) */


/************************************/
/* pbhEBhẼTCY			*/
/************************************/
#define	PadWinSizeX			(320*4-1)	/* size x */
#define	PadWinSizeYNormal	(87*4-1)	/* size y  ʏ̃EBhE */
#define	PadWinLocYNormal	(153*4)		/* loc y */
#define	PadWinSizeYInkRecog	(36*4-1)	/* size y  CNFpEBhE */
#define	PadWinLocYInkRecog	(204*4)		/* loc y */
#define	PadWinSizeYInkPad	(69*4-1)	/* size y  CNpbhpEBhE */
#define	PadWinLocYInkPad	(171*4)		/* loc y */
#define	PadWinSizeYMiniPad	(48*4-1)	/* size y  p~jpbhpEBhE */
#define	PadWinLocYMiniPad	(192*4)		/* loc y */


/************************/
/*	vg^Cv錾	*/
/************************/
void PadObj(MESSAGE *,void *,...);



/* ------------------------------ `I ------------------------------ */
#endif

