/****************************************************************
 <jpegapi.h>
							V[v
							Sharp Corporation

		JPEGxAPI`

		1998/04/14	created fR[ĥ
*****************************************************************/
#ifndef	_JPEGAPI_H_INCLUDED

#include <sharpgen.h>
#include <drfio.h>
#include <winlib.h>

/* G[R[h */
typedef enum JPEGERR {
	JPEGERR_NONE = 0,
	JPEGERR_IO,				/* o̓G[ */
	JPEGERR_DATA,			/* JPEGf[^̃G[ */
	JPEGERR_NOT_STRETCH,	/* L̓T|[gĂȂ */
	JPEGERR_QUALITY,		/* ʎqxs */
	JPEGERR_SMPL_RATE,		/* TvO䂪s */
	JPEGERR_SIZE_OVER,		/* JPEG摜̃TCY傫 */
	JPEGERR_NOT_SCROLL,		/* wꂽɂ̓XN[łȂ */
	JPEGERR_NOT_SUPPORT,	/* T|[gĂȂJPEG/JFIFt@C */
	JPEGERR_MEMORY = -1,	/* s */
	JPEGERR_BAD_PARAM = -2,	/* ̑p[^s */
	JPEGERR_ALREADY_DECODING = -3,	/* łɃfR[fBO */
	JPEGERR_THREAD_NOTRUN = -4,	/* fR[hXbhNłȂ */
	JPEGERR_THREAD_DEATH = -5,	/* fR[hXbhS */
	JPEGERR_THREAD_BREAKED = -6	/* fR[hXbhf */
} JPEGERR;

typedef UCHAR JPEGSTAT;
#define	JDPS_INIT		0
#define	JDPS_EXEC		1
#define	JDPS_STOPPED	2

/*======================================================================
		JPEGxAPI
======================================================================*/
JPEGERR
JpegGetSize(DRFFILE *drfFile,USHORT *width,USHORT *height);
JPEGERR
JpegDecode(const DRFFILE *drfFile,const RECTANGLE *srcRect,
		   WINDOWHD osHandle,const RECTANGLE *dstRect,BOOLEAN isBlocking);
JPEGSTAT
JpegGetDecodeProcStatus(JPEGERR *jpegErr);
JPEGERR
JpegStopDecode(void);

#define	_JPEGAPI_H_INCLUDED
#endif	/* _JPEGAPI_H_INCLUDED */
