/***********************************************************************
<t@C>	keycode.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_KEYCODE_H_INCLUDED
#define	_KEYCODE_H_INCLUDED
/***********************************************************************
		L[R[h`
		KeyDown CxgbZ[W KeyCode o[̒l
***********************************************************************/


/* attribute */

#define	KEY_ATTR_CTRL		0x04

/*	bit 2 = 0	@\L[͉ĂȂB	*/
/*	      = 1	@\L[ĂB	*/

/* PoCgR[h */

#define	KC_NULL			0x00		/* dummy key code */

#define	KC_BREAK		0x03		/* f */
#define	KC_BS			0x08		/* ar */
#define	KC_TAB			0x09		/* TAB */
#define	KC_PAGE			0x0c		/* y[W */
#define	KC_ENTER_MARK		0x0d		/* s */

#define	KC_C 			0x1a		/* b */
#define	KC_CURSOR_RIGHT		0x1c
#define	KC_CURSOR_LEFT 		0x1d
#define	KC_CURSOR_UP  	 	0x1e
#define	KC_CURSOR_DOWN 		0x1f

#define	KC_DEL			0x7f		/* 폜	*/


/* QoCgR[h */

#define	KC_INSERT_SW		0x01FF		/* }[h؂ւ */
#define	KC_ENTER		0x02FF		/* ́ieL[pbhłgpj */
#define	KC_DECIDE		0x03FF		/*  */

#define	KC_OFF			0x20FF		/*  */
#define	KC_ITAIJI		0x2fFF		/* ّ̎	*/

#define	KC_APL_PIM		0x3bFF		/* UEXPIM(fC[v) */
#define	KC_APL_SCHEDULE		0x3cFF		/* XPW[ */
#define	KC_APL_NOTE		0x3eFF		/* m[g^|[g */

#define	KC_CARD			0x40FF		/* J[h */
#define	KC_APL_CLOCK		0x41FF		/* v */
#define	KC_APL_CALC		0x42FF		/* d */
#define	KC_APL_ADDRESS		0x43FF		/* AhX */
#define	KC_APL_PAINT		0x44FF		/* tHg[ */

#define	KC_HELP			0x51FF		/* AVXg */
#define	KC_APL_FILER		0x52FF		/* BOOK */
#define	KC_APL_MAIL		0x58FF		/* [ */
#define	KC_APL_WWW		0x59FF		/* vvv */
#define	KC_APL_WORD_PRO		0x5aFF		/* [v */
#define	KC_HARDCOPY		0x5fFF		/* n[hRs[(bZ[WT[ogp) */

#define	KC_APL_PCLINK		0x60FF		/* obN*/
#define	KC_APL_SPSHEET		0x61FF		/* XvbgV[g */
#define	KC_APL_DATABASE		0x62FF		/* p[\if[^x[X */
#define	KC_APL_SETLAUNCHER	0x63FF		/* ݒ(MT-200)CfbNX̂P */
#define	KC_BACK			0x64FF		/* ߂ */
#define	KC_MENU			0x65FF		/* j[ */
#define	KC_PREV			0x66FF		/* t */
#define	KC_NEXT			0x67FF		/*  */
#define	KC_SEND			0x69FF		/* Mij*/
#define	KC_RECEIVE		0x6aFF		/* Mij*/
#define	KC_LIGHT		0x6bFF		/* tgCg */
#define	KC_APL_BLAUNCHER	0x6cFF		/* {CfbNX */
#define	KC_APL_MLAUNCHER	0x6dFF		/* MORECfbNX */
#define	KC_APL_NET		0x6eFF		/* UEXʐM */
#define	KC_APL_LAUNCHER		0x6fFF		/* CfbNX(MI-300ł̓IWiCfbNX) */

#define KC_EXPAND_DSP		0x70FF		/* ʊg */
#define KC_CHAR_SIZE		0x71FF		/* TCY̕ύX */
#define	KC_2ndF			0x74FF		/* @\ */

/* AvxŎgpL[R[h */

#define	KC_SEND_MAIL		0x75FF		/* [M */
#define	KC_RECV_MAIL		0x76FF		/* [M */
#define	KC_NEW_ENTRY		0x77FF		/* VK */
#define	KC_EDIT			0x78FF		/* C */
#define	KC_REGIST		0x79FF		/* o^ */
#define KC_HOME			0x7aff		/* HOME */
#define	KC_INTNET_SEARCH	0x7bFF		/* C^[lbgL[ */
#define	KC_HOME_MENU		0x7cFF		/* HOME L[ MENU J̃L[R[h */

/* ƖL[ 0x80FF - 0x8FFF ̂PU */

#define	KC_APL_BUSINESS1	0x80FF		/* ƖP */
#define	KC_APL_BUSINESS2	0x81FF		/* ƖQ */
#define	KC_APL_BUSINESS3	0x82FF		/* ƖR */
#define	KC_APL_BUSINESS4	0x83FF		/* ƖS */
#define	KC_APL_BUSINESS5	0x84FF		/* ƖT */
#define	KC_APL_BUSINESS6	0x85FF		/* ƖU */
#define	KC_APL_BUSINESS7	0x86FF		/* ƖV */
#define	KC_APL_BUSINESS8	0x87FF		/* ƖW */
#define	KC_APL_BUSINESS9	0x88FF		/* ƖX */
#define	KC_APL_BUSINESS10	0x89FF		/* ƖPO */
#define	KC_APL_BUSINESS11	0x8AFF		/* ƖPP */
#define	KC_APL_BUSINESS12	0x8BFF		/* ƖPQ */
#define	KC_APL_BUSINESS13	0x8CFF		/* ƖPR */
#define	KC_APL_BUSINESS14	0x8DFF		/* ƖPS */
#define	KC_APL_BUSINESS15	0x8EFF		/* ƖPT */
#define	KC_APL_BUSINESS16	0x8FFF		/* ƖPU */


/* L[{[hϊp̃L[R[h */

#define	KC_SYMBOL		0xa0FF		/* L */
#define	KC_CAPS			0xa1FF		/* CAPS */
#define	KC_HANKAKU		0xa2FF		/* p */
#define	KC_ALPHNUM		0xa3FF		/* p */
#define	KC_HIRA			0xa4FF		/* Ђ */
#define	KC_KANA			0xa5FF		/*  */
#define	KC_HIRA_KANA		0xa6FF		/* Ђ^Ji */
#define	KC_ROME			0xa7FF		/* [} */
#define	KC_ONKUN		0xa8FF		/* P */
#define	KC_PREV_XFER		0xa9FF		/* O */
#define	KC_XFER			0xaaFF		/* ϊ */
#define	KC_UNDO			0xabFF		/*  */
#define	KC_APLY			0xacFF		/* ̗p */


#define	KC_AM   			0xc0fc
#define	KC_PM   			0xc1fc

#endif
/* end of keycode.h */
