/**
 * libmail.h PowerZaurus[APIwb_t@C
 * Copyright (C) 1998 1999 V[v
 * 쐬 V[vЏVXeƖ{SIZpZ^[
 */
#include <zcppcmn.h>        /* C++ support  99/9/8 */
#if !defined(LIBMAIL_H)

#include <popsmtp.h>
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
/***************************************************************************/

/*
 * MɊւLq
 */

/*
 * Yt̃fR[h\ő吔`
 */
#define MAX_ATTACH_NUM 10

/*
 * Mobt@\̒`iCugpj
 */
struct Pop3Buffer {
    char rbuf[MAX_LINE + 1];
    int rsize;
    char wbuf[MAX_CMD_LINE + 1];
    int wsize;
    char respbuf[MAX_LINE + 1];
    int respsize;
#ifdef  __cplusplus			/* C++ support  99/9/10*/
    int (*abortfunc)(...);
#else
    int (*abortfunc)();
#endif
};

/*
 * G[^`
 */
typedef enum {
    NO_ERR,
    INIT_SYS_ERR,
    GET_INFO_ERR,
    GET_MSG_ERR,
    DISCONN_ERR,
    CLEAR_SYS_ERR,
    NO_MEM,
    NO_MSG,
    MIME_DECD_ERR,
    DEL_MSG_ERR,
    TOO_LARGE_MSG,
    JIS_CONV_ERR,
    FILE_ERR,
    PARAM_ERR,
    CONN_ERR = -1001,    /* Pop3CallHost()  */
    GET_HEAD_ERR = -1002 /* Pop3GetHeader() */
} RMailErr;

/* 1999/9/27 added  */
typedef enum {
    RMAIL_NO_ERR,
    RMAIL_FILE_OPEN_ERR,
    RMAIL_POP3_GET_MSG_ERR,
    RMAIL_FILE_WRITE_ERR
} RMAIL_GET_MSG_ERR_T; 
/* 1999/9/27 added ܂ */

/*
 * Oϐ錾
 */
extern int Pop3FuncErr;
extern RMAIL_GET_MSG_ERR_T RMailGetMsgErr; /* 1999/9/27 added */

/*
 * ֐vg^Cv錾
 */
BEGIN_EXTERN_C              /* C++ support  99/9/8 */
RMailErr RMailGetInfo(char *hostname, char *userid,
		      char *password, POP3MSGINFO **MsgInfo, int *NumOfMsgs);
RMailErr RMailGetOneHeader(char *hostname, char *userid, char *password,
			   POP3MSGINFO *MsgInfo, char *hdrfile);
RMailErr RMailGetOneMessage(char *hostname, char *userid, char *password,
			    POP3MSGINFO *MsgInfo, char *msgfile, 
			    int attachnum, char **attachfiles, int delflag,
			    void (*callback)(int AllSize, int RecvSize));
/* add 99/07/26 */
int RcvMailSockOpen(void);
int RcvMailPopConnect(char* hostname, char* userid, char* password);
int RcvMailPopDisconnect(void);
int RcvMailSockClose(void);
RMailErr RcvMailGetInfo(POP3MSGINFO** MsgInfo, int* NumOfMsgs);
RMailErr RcvMailGetOneHeader(POP3MSGINFO *MsgInfo, char *hdrfile);
RMailErr RcvMailGetOneMessage(POP3MSGINFO *MsgInfo, char *msgfile,
                        int attachnum, char **attachfiles, int delflag,
                        void (*callback)(int AllSize, int RecvSize));
END_EXTERN_C                /* C++ support  99/9/8 */
/*
 * ܂ŎMɊւLq
 */

/**************************************************************************/

/*
 * 瑗MɊւLq
 */
#define TAG_ERR			-1 /** ^O̎ʖ܂ **/
#define DOUBLE_DEFINE_TO        -2 /** Qd`G[ To: **/
#define DOUBLE_DEFINE_CC	-3 /** Qd`G[ Cc: **/
#define DOUBLE_DEFINE_BCC	-4 /** Qd`G[ Bcc: **/
#define DOUBLE_DEFINE_XMAILER	-5 /** Qd`G[ X-Mailer: **/
#define DOUBLE_DEFINE_FROM	-6 /** Qd`G[ From: **/
#define DOUBLE_DEFINE_SUBJECT	-7 /** Qd`G[ Subject: **/
#define DOUBLE_DEFINE_SENDER	-8 /** Qd`G[ Sender: **/
#define DOUBLE_DEFINE_REPLY	-9 /** Qd`G[ Reply-to: **/
#define DOUBLE_DEFINE_MESSAGEID	-10 /** Qd`G[ Message-Id: **/
#define DOUBLE_DEFINE_IN_REPLY_TO -11 /** Qd`G[ In-Reply-To: **/
#define NOTHING_TO		-12 /** To:ڂ܂B **/
#define NOTHING_FROM		-13 /** From:ڂ܂B **/
#define NOTHING_NODE		-14 /** Node܂ **/
#define NOTHING_ATTACH_FILE	-15 /** Ytt@C݂܂ **/
#define ATTACH_FILE_OVER10	-16 /** Ytt@CPO𒴂Ă܂B**/
#define NOTHING_TEXT		-17 /** {̃t@C܂B͎w肳Ă܂B**/
#define MEM_ALLOCATE_ERR	-20 /** [AP[gG[ **/
#define SMAIL_DERR_ABORT	-80 /* (fL[)*/
#define SMAIL_DERR_PPP		-81 /* (oooڑ)*/
#define SMAIL_DERR_OFF		-82 /* (dre/OFF)*/
#define SMAIL_DERR_SVR		-83 /* T[o[ňُ킪̓T[o[SMTPT[oɐڑłȂ*/
#define SMTPCALLHOST_ERR        -1001 /* SmtpCallHost()ŃG[ */
#define SMTPMAILCMD_ERR         -1002 /* SmtpMailCmd()ŃG[  */
#define SMTPPUTMESSAGE_ERR      -1003 /* SmtpPutMessage()ŃG[ */

/* To:tB[h`FbNG[l 1999/5/26 added by Kamii */
#define TOO_LONG_TO      -201
#define TOO_LONG_CC      -202
#define TOO_LONG_BCC     -203
/* 1999/5/26 ܂ */

/* Oϐ錾 */
extern int SmtpFuncErr; /**SMTP֐̃G[ **/

/* ֐vg^Cv錾 */
BEGIN_EXTERN_C              /* C++ support  99/9/8 */
int	SendMail(char *node, unsigned char *mailhead[], char *mfile, char *appfiles[], void (*callback)(int all_size, int send_size));
END_EXTERN_C                /* C++ support  99/9/8 */
/*
 * ܂őMɊւLq
 */

#define LIBMAIL_H 1
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif
