#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _MAILDEFH_
#define _MAILDEFH_

BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
#ifndef _MSDOS_
 #define atol(c)	asciiToLong(c)
 #define ltoa(i, c, r)  longToAscii(i, c)
 #define strchr(s, c) 	StrChar(s,c)
#endif



/* pseudo keywords */

/*
#ifdef u16
  #undef u16
  #define u16 int
#else 
  #define u16 int
#endif
*/

#define boolean         int
#define true            1
#define false           0

#define import          extern
#define export
#define fallthru
#define skip
#define forever         for(;;)
#define until(cond)     while(!(cond))
#define unless(cond)        if(!(cond))
#define ifnot(cond)     if(!(cond))


#ifndef NULL
  #define NULL (void *)(0)
#endif

#ifndef	MAX_LINE
/* max text line */
#define	MAX_LINE		256			/* ?? FIT to RFC !! */
#endif

#define MAX_CMD_LINE	256			/* ?? FIT to RFC !! */


/* 
#ifndef	MAX_READ_BUFSIZE
#define	MAX_READ_BUFSIZE	2048	 
#endif 
*/

#ifdef Debug
  #define ASSERT(i)
#else
  #define ASSERT(i)
#endif


#define TICKS	64

#define NSELECT_TIMELIMIT 200	/* timelimit for blocking mode nselect in msec */
#define DEFAULT_TIMELIMIT 120	/* default timelimit for each mail func in sec */


#define	INVALID_SOCKET		   -1	/* Invalid socket ID */
#define CONNECTION_CLOSED 		0	/* Connection closed by remote host */

/* Pop3 & Smtp common error code */

#define SESSION_ABORTED		   -2	/* Execution aborted 96.06.13 */
#define SOCKET_ERROR		   -1	/* Connection corrupted */
#define	BAD_PARAMETER			1
#define	SOCKET_NOT_AVAILABLE	2	/* No available socket ? */
#define	COULD_NOT_GET_CONNECTION 3 /* Could not establish TCP connection */
#define HOST_NOT_CONNECTED		4	/* Failed to send or receive data because
									   TCP connection has not been established. */

#define	NO_DNS_SERVER			11	/* No response from DNS server */

/* Error code for Pop3 */
#define	POP3_OPEN_FAILED		23	/*  */
#define	BAD_USERID				24	/* Bad user id */
#define BAD_PASSWORD			25	/* Bad password */


/* Error code for Smtp */
#define	SMTP_OPEN_FAILED		31
#define	RSET_CMD_FAILED			32
#define FAILED_TO_INIT_SESSION	RSET_CMD_FAILED
#define	MAIL_CMD_FAILED			32
#define	RCPT_CMD_FAILED			33
#define TOO_MANY_RCPTS			34


#define	M_CLIENT		  0
#define	M_SERVER		  1


#define	POP3_PROTOCOL "pop3"
#define	Smtpd "smtpd"

#define MAKEWORD( a, b )	(WORD)(((unsigned char)a << 8) + (unsigned char)b)

#define ALL_OK		0
#ifdef ERR
  #undef ERR
  #define ERR 		-1
#else
  #define ERR	-1
#endif

/* End of typedef.h */
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* _MAILDEFH_ */
