/***********************************************************************
<t@C>	mblock.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_MBLOCK_H_INCLUDED
#define	_MBLOCK_H_INCLUDED
/***********************************************************************
		ubN֘A̒`t@C
***********************************************************************/


/***********************************************************************
  hCum
***********************************************************************/

#define MAIN_RAM			0x00	/* S1 {̂q`l				 */
#define MAIN_ROM			0x01	/* S5 {̂qnl				 */
#define CARD_RAM			0x02	/* S2 J[hq`l				 */
#define CARD_ROM			0x03	/* S3 J[hqnl				 */
#define MAIN_EX1			0x04	/* S4 {̊gqnli\[Xj */
#define CARD_EX1			0x05	/* S6 J[hg				 */
#define MAIN_RAMB			0x06	/* S7 {̂q`lp[eBVa */

#define MAX_MB_DRIVE_NUM	MAIN_RAMB	/* ubÑhCu */

/***********************************************************************
  G[m
***********************************************************************/

#define PROTECT_CARD_ERROR			0x20	/* veNgJ[hł */
#define NO_CARD_ERROR				0x21	/* J[hGA݂Ȃ */
#define OUT_OF_RANGE_ERROR			0x23	/* p[^l͈͂zĂ */
#define SYSTEM_ERROR				0x0ff	/* uCNꂽ */

#define BLOCK_NOT_FOUND_ERROR		0x40	/* wubNȂ */
#define PROTECT_BLOCK_ERROR			0x41	/* veNgubNł */
#define DATA_NOT_FOUND_ERROR		0x42	/* f[^Ȃ (DTMp̌) */
#define SAME_BLOCK_EXIST_ERROR		0x43	/* ÕubN */
#define NO_ENOUGH_SIZE_ERROR		0x44	/* Ȃ */
#define NO_PHYSICAL_MEMORY_ERROR	0x45	/* Ȃ */

/***********************************************************************
  J[h̃wb_\
***********************************************************************/

#define CARD_HEADER_MARK			0x1210
#define CARD_SIZE					2
#define CARD_VERSION				4
#define CARD_TYPE					5
#define CARD_NAME					6
#define CARD_ATR					0x11
#define BLOCK_HEADER_PTR			0x12
#define RAM_AREA_PTR				0x16

#define CARD_HEADER_SIZE			0x20

/***********************************************************************
  J[h^Cv
***********************************************************************/

#define WITH_BANK_AREA		0x80	/* oN܂ރJ[h */
#define SET_NOT_USE			0x40	/* {̃AvgȂJ[h */
#define PAIR_CARD			0x02	/* {̂ƘAĎgJ[h */
#define SINGLE_CARD			0x01	/* ĂJ[h */

/* ------ J[h̑` */

#define ARCH_CARD			0x20	/* A[JCuv */
#define SYSTEM_CARD			4		/* VXep */
#define HIDDEN_CARD			2		/* Ȃ */
#define PROTECT_CARD		1		/* ݋֎~ */

/***********************************************************************
  ubÑwb_\ 

  ӁII
  ATR,TIME,DATEAToCgɂȂĂƂ
  vOĂƂ낪
  (: in mb_fc.s		grep caution-align ̏o͂̒̂Ps)
**********************************************************************/

#define BLOCK_HEADER_CODE			0
#define BLOCK_NAME					1		/* KPł邱 łȂƃoO */
#define BLOCK_ATR					0x0c
#define BLOCK_TIME					0x0d
#define BLOCK_DATE					0x0f	/* TIME,DATE͂̏Ԃ邱 łȂƃoO */
#define BLOCK_SIZE					0x11
#define FREE_PTR_TOP				0x17
#define FREE_PTR_BOTTOM				0x1b
#define BLOCK_CODE					0x27
#define FILE_HEADER					BLOCK_CODE
#define FILE_TOP					(FILE_HEADER+4)
#define PTR1_TOP					(FILE_HEADER+4)

#define BLOCK_HEADER_SIZE			0x27

/***********************************************************************
  wb_R[h
***********************************************************************/

#define BLOCK_HEADER_MARK			0x0fb
#define BLOCK_END_MARK				0x0ff
#define BLOCK_SECTION_MARK			0x0fc

/***********************************************************************
  ubN̑
***********************************************************************/

#define ARCH_BLOCK				0x20	/* A[JCuv */
#define SYSTEM_BLOCK			4	/* VXep */
#define HIDDEN_BLOCK			2	/* Ȃ */
#define PROTECT_BLOCK			1	/* ݋֎~ */

#define BLOCK_ATR_MASK	(SYSTEM_BLOCK+HIDDEN_BLOCK+PROTECT_BLOCK)	/* eXg}XN */
#define NOT_MOVE_BLOCK	(SYSTEM_BLOCK+HIDDEN_BLOCK+PROTECT_BLOCK)	/* ړłȂubN */
#define OUT_SIDE_BLOCK	(SYSTEM_BLOCK+HIDDEN_BLOCK)		/* cTCYɉeȂubN */
#define IN_ROM_BLOCK	(ARCH_BLOCK+PROTECT_BLOCK)		/* qnl̃ubN */

/***********************************************************************
  ZNVύXwb_̍\
***********************************************************************/

#define BLOCK_CHANGE_MARK		0						/* BLOCK_SECTION_MARK ̈ʒu */
#define BLOCK_CHANGE_ADR		(BLOCK_CHANGE_MARK+1)	/* ύX̃AhX */

/***********************************************************************
  eJ[hGÃAhXAptns`
***********************************************************************/


#define MAIN_RAM_DF_QUOTA		0	/* NI^ */


/***********************************************************************
  ̑
***********************************************************************/

#define MAP_WORK_RAM_CE			0x80	/* mapcon_work */
#define ROM_CARD_RAM_AREA_MIN	0x08000	/* qnlJ[ĥq`lGA擪̍ŏl */
#define MINUS_ONE_32BIT			0xFFFFFFFF	/* -1 */
#define MBFILE_MAX_SIZE			0x04000000	/* ubNt@C̍őTCY=64Mbytes */
#define SYSTEM_LEVEL			0x80	/* K[hTCY̏sȂ */
#define FREE_GUARD_SIZE			800		/* ]TTCY */
#endif
