/***********************************************************************
<t@C>	modemlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		<fT[rXIOCS  Cu֘A̒`>
***********************************************************************/

#ifndef _MODEMLIB_H_INCLUDED
#define _MODEMLIB_H_INCLUDED

#include <sharpgen.h>
#include <ioercode.h>
#include <comdvlib.h>
#include <bcommlib.h>
#include <cs_util.h>
#include <file.h>
#include <abort.h>

#ifdef IN_MDM_DRIVER
#include	<crystal.h>	/* self_sleep() */
#endif /* IN_MDM_DRIVER */


/*======================================================================
						SH^ IOCS G[R[h
======================================================================*/

#define	EC_MDM_UNSUPPORTED		(MDM_EC_BASE+0x00) /* `FuncĂ */
#define	EC_MDM_MALLOC_FAILED	(MDM_EC_BASE+0x01)	/* sys_malloc()Ɏs */
#define	EC_MDM_OPEN_FAILED		(MDM_EC_BASE+0x02)	/* OpenMDM()s */
#define	EC_MDM_SEND_CMD_FAILED	(MDM_EC_BASE+0x03)	/* AT cmdMs */
#define EC_MDM_BAD_ECHOBACK		(MDM_EC_BASE+0x04)	/* R}h̃GR[obNԂĂȂ */
#define	EC_MDM_NO_REPLY			(MDM_EC_BASE+0x05)	/* f̉Ȃ */
#define	EC_MDM_UNEXPECTED_REPLY	(MDM_EC_BASE+0x06)	/* 񂪂 */
#define	EC_MDM_LOST_LF			(MDM_EC_BASE+0x07)	/* CŘLF */
#define	EC_MDM_DRV_NOT_EXIST	(MDM_EC_BASE+0x08)	/* fhCoȂ */
#define	EC_MDM_INVALID_MODE		(MDM_EC_BASE+0x09)	/* [h */
#define	EC_MDM_BAD_MDM_PTR		(MDM_EC_BASE+0x0a)	/* pMdmُ͈ */
#define	EC_MDM_BAD_BCOM_PTR		(MDM_EC_BASE+0x0b)	/* pBComُ͈ */
#define	EC_MDM_BAD_PARAM		(MDM_EC_BASE+0x0c)	/*  */
#define	EC_MDM_BAD_ATCMD_TBL	(MDM_EC_BASE+0x0d)	/* ATcmd\ */
#define	EC_MDM_COM_ERROR		(MDM_EC_BASE+0x0e)	/* DTE-DCEԂ̃G[ */
#define	EC_MDM_WONT_CMD_MODE	(MDM_EC_BASE+0x0f)	/* R}h[hɂȂȂ */
#define EC_MDM_ATCMD_TOO_LONG	(MDM_EC_BASE+0x10)	/* R}h񂪒߂ */
#define	EC_MDM_TOO_MANY_DRIVER	(MDM_EC_BASE+0x11)	/* fhCoo^łȂ */
#define EC_MDM_BAD_HEADER		(MDM_EC_BASE+0x12)	/* fwb_̓e */
#define	EC_MDM_WORK_SHORTAGE	(MDM_EC_BASE+0x13)	/* [NsĂ */
#define	EC_MDM_INFO_NOT_EXIST	(MDM_EC_BASE+0x14)	/* w肵͖ */
#define	EC_MDM_REFUSED_FUNC		(MDM_EC_BASE+0x15)	/* OpenMDMFile()ł͎gps\ */

#define	EC_MDM_FRONT_LIGHT_ON		(MDM_EC_BASE+0x16)	/* tgCgONĂ */

#define	EC_MDM_NO_CARRIER		(MDM_EC_BASE+0x1000) /* "NO CARRIER" */
#define	EC_MDM_NO_DIALTONE		(MDM_EC_BASE+0x1001) /* "NO DIALTONE" */
#define	EC_MDM_LINE_BUSY		(MDM_EC_BASE+0x1002) /* b */
#define	EC_MDM_OFFLINE			(MDM_EC_BASE+0x1003) /* ؂Ă */

#define	EC_MDM_ABORT_ERROR		(MDM_EC_BASE+0xfefe) /* A{[g */
#define	EC_MDM_BREAK_ERROR		(MDM_EC_BASE+0xfeff) /*ufvL[ꂽ*/
#define	EC_MDM_ERROR			(MDM_EC_BASE+0xffff) /* ʃG[ */


/*======================================================================
								 萔
======================================================================*/

#define	MDM_TEL_NUM_MAX	50		/* dbԍ̍ő咷[byte] */

#define	MDM_ATCMD_LEN_MAX	40	/* ATR}h̍ő咷 */
#define	MDM_RESULT_LEN_MAX	64	/* ԓ̍ő咷 */

#define	CARDTYPE_FAXMODEM	'FMDM'
#define	CARDTYPE_MODEM		' MDM'	/* ʂWrbg0x20ispacej */
/*define CARDTYPE_VOICEMODEM 'VMDM' */	/* ̂ */


/*======================================================================
							^錾A\
======================================================================*/


/*----------------------------------------------------------------------
		f̑ݏꏊ
----------------------------------------------------------------------*/

typedef enum MDMPLACE_E {
	MDM_PLACE_BUILTIN,		/* {̓ */
	MDM_PLACE_15PIN_EXT,	/* IvV|[g15֐ڑ */
	MDM_PLACE_PCCARD,		/* PC-Card \Pbg֐ڑ */
	MDM_PLACE_NTTIrPPP,			/* {̓IrPPP */
	MDM_PLACE_BUILTIN_PDC,      /* {̓\tgPDC        */
	MDM_PLACE_BUILTIN_PHSNTT,   /* {̓\tgPHSNTT     */
	MDM_PLACE_BUILTIN_PHSDDI    /* {̓\tgPHSDDI     */
} MDMPLACE_E;

/* MI-310 ݊p */
#define MDM_PLACE_BUILTIN_PIAFS MDM_PLACE_BUILTIN_PHSNTT

/*----------------------------------------------------------------------
		UgR[hCfbNX
----------------------------------------------------------------------*/

typedef enum ATRESULTIDX_E {
	ATRESULT_ABORTED = -4,		/* A{[gAf */
	ATRESULT_BREAK = -3,		/* ufvL[Ēf */
	ATRESULT_NONE = -2,			/*iԓ񂪕ԂĂȂj*/
	ATRESULT_UNKNOWN = -1,		/*imȂԓj*/
	ATRESULT_OK = 0,			/* "OK" */
	ATRESULT_CONNECT,			/* "CONNECT xxx" */
	ATRESULT_RING,				/* "RING" */
	ATRESULT_NO_CARRIER,		/* "NO CARRIER" */
	ATRESULT_ERROR,				/* "ERROR" */
	ATRESULT_NO_DIALTONE,		/* "NO DIALTONE" */
	ATRESULT_BUSY,				/* "BUSY" */
	ATRESULT_NO_ANSWER,			/* "NO ANSWER" */
	ATRESULT_HAND_SET_IN_USE,	/* "HAND SET IN USE" */
	ATRESULT_PLUS_FCERROR,		/* "+FCERROR" */
	AT_LAST_RESULT				/* ŏIԍ */
} ATRESULTIDX_E;

/*	UgR[h\	*/

typedef	struct MDMRESULT {
	char			*pResultStr;	/* Ug */
	ATRESULTIDX_E	ResultIdx;		/* UgCfbNXԍ */
	short			Rsv1;			/* gp */
} MDMRESULT;	


/*----------------------------------------------------------------------
		`sR}h\
----------------------------------------------------------------------*/

typedef enum ATCMDIDX_E {
	AT_CMDIDX_END = -2,	/***** CfbNXXgI}[N *****/
	AT_RESERVED = -1,	/* ǉp󂫗̈mۂɗp */
	AT_NULL = 0,		/* ̗vf̓fhCo(Ggׂp) */
	AT_COMMAND_PREFIX,				/* R}h擪"AT" 			*/
	AT_RESET,						/* fHo׏Ԃ			*/
	AT_INIT0,						/* ݒ(0)						*/
	AT_INIT1,						/*         (1)40zꍇ    */
	AT_INIT2,						/*         (2)80zꍇ    */
	AT_ECHO_OFF,					/* R}hechoԂȂ */
	AT_ECHO_ON,						/* R}hechoԂ */
	AT_DIAL = 10,					/* _CA */
	AT_AUTO_ANSWER,					/* M */
	AT_MONITOR,						/* ̉Xs[J[֏o */
	AT_ANSWER,						/* db */
	AT_OFF_HOOK,					/* IttbNԂ					*/
	AT_ON_HOOK,						/* ItbNԂ					*/
	AT_NOT_DETECT_DIAL_TONE = 20,	/* _Cg[oȂ */
	AT_DETECT_DIAL_TONE,			/* _Cg[o */
	AT_TONE,						/* g[_CAɐݒ				*/
	AT_PULSE,						/* pX_CA(W)ɐݒ		*/
	AT_PULSE_10PPS,					/* pX_CA(10pps)ɐݒ		*/
	AT_PULSE_20PPS,					/* pX_CA(20pps)ɐݒ		*/
	AT_SPK_OFF = 30,				/* Xs[J[OFF		*/
	AT_SPK_ON_DIAL,					/* LAo܂ON 	*/
	AT_SPK_ON,						/* ON			 	*/
	AT_SPK_ON_SETUP,				/* _CȊOALAo܂ON*/
	AT_SPKVOL_MIN,					/* Xs[J[ʏ				*/
	AT_SPKVOL_MID,					/* Xs[J[ʒ				*/
	AT_SPKVOL_MAX,					/* Xs[J[ʑ				*/
	AT_DATA_MODE = 40,				/* f[^[hֈڂ				*/
	AT_CMD_MODE,					/* R}h[h					*/
	AT_DSR_ALWAYS_ON = 50,			/* DSRM͏ON */
	AT_DSR_UNDER_V25bis,			/* DSRMV.25bisɏ]ē삷 */
	AT_COMPRESSION_OFF = 60,		/* MNPf[^ksȂȂ */
	AT_COMPRESSION_ON,				/* MNPf[^ksȂ(V42bis,MNP5I) */
	AT_DTE_FLOW_CONTROL_OFF = 70,	/* DTE-modemԂ̃t[Ȃ */
	AT_DTE_FLOW_CONTROL_SOFT,		/* 					   oXON/XOFF */
	AT_DTE_FLOW_CONTROL_HARD,		/* 					   oRS/CS */
	AT_MODEM_FLOW_CONTROL_OFF = 80,	/* modem-modemԃt[Ȃ */
	AT_MODEM_FLOW_CONTROL_ON,		/* 						  XON/XOFF*/
	AT_ERR_CONTROL_OFF = 100,		 /* G[Ȃ */
	AT_ERR_CONTROL_ON,				 /*  */
	AT_ERR_CONTROL_FORCED,			 /* KLAPM or MNPŐڑ */
	AT_ERR_CONTROL_A_CELLULAR,		 /* Analog cellular */
	AT_ERR_CONTROL_A_CELLULAR_FORCED,/* Analog cellularKLAPM or MNPŐڑ */
	AT_ERR_CONTROL_D_CELLULAR,		 /* Digital cellular */
	AT_ERR_CONTROL_D_CELLULAR_FORCED,/* Degital cellularKLAPM or MNPŐڑ */
	AT_CONNECT_SPEED_DEFAULT = 10001, /* ڑxftHg */
	AT_CONNECT_SPEED_1200 = 10012,	/* ڑx  1200[bps]*/
	AT_CONNECT_SPEED_2400 = 10024,	/* ڑx  2400[bps]*/
	AT_CONNECT_SPEED_4800 = 10048,	/* ڑx  4800[bps]*/
	AT_CONNECT_SPEED_9600 = 10096,	/* ڑx  9600[bps]*/
	AT_CONNECT_SPEED_14400 = 10144,	/* ڑx 14400[bps]*/
	AT_CONNECT_SPEED_19200 = 10192,	/* ڑx 19200[bps]*/
	AT_CONNECT_SPEED_24000 = 10240, /* ڑx 24000[bps]*/
	AT_CONNECT_SPEED_28800 = 10288,	/* ڑx 28800[bps]*/
	AT_CONNECT_SPEED_33600 = 10336,	/* ڑx 33600[bps]	PI-EX1` */
	AT_CONNECT_SPEED_36000 = 10360,	/* ڑx 36000[bps] V.90 PI-EX1` */
	AT_CONNECT_SPEED_40000 = 10400,	/* ڑx 40000[bps] V.90 PI-EX1` */
	AT_CONNECT_SPEED_48000 = 10480,	/* ڑx 48000[bps] V.90 PI-EX1` */
	AT_CONNECT_SPEED_52000 = 10520,	/* ڑx 52000[bps] V.90 PI-EX1` */
	AT_CONNECT_SPEED_56000 = 10560,	/* ڑx 56000[bps] V.90 PI-EX1` */
	AT_CONNECT_PDC_9600DATA = 11000,    /* ocb/ 9600bps Data     */
	AT_CONNECT_PDC_9600PACKET,          /* ocb/ 9600bps Packet   */
	AT_CONNECT_PDC_DOPA,                /* ocb/ DoPa             */
	AT_CONNECT_PIAFS_32K,               /* PIAFS/ 32kbps            */
	AT_CONNECT_PIAFS_64K,               /* PIAFS/ 64kbps            */
	AT_CONNECT_ALFADATA,                /* f[^                 */
	AT_FAX_INIT = 20000,			/* FAXp */
	AT_FAX_DATA_MODE,			/* f[^[h */
	AT_FAX_CLASS1,				/* Class1 Fax mode */	
	AT_FAX_CLASS2,				/* Class2 Fax mode */
	AT_FAX_HDLC_TX_V21_300 = 20100,	/* HDLC framingɂf[^M[h̐ݒ */
	AT_FAX_HDLC_TX_V27ter_2400,	
	AT_FAX_HDLC_TX_V27ter_4800,	
	AT_FAX_HDLC_TX_V29_7200,	
	AT_FAX_HDLC_TX_V17_7200_LONG,
	AT_FAX_HDLC_TX_V17_7200_SHORT,
	AT_FAX_HDLC_TX_V29_9600,	
	AT_FAX_HDLC_TX_V17_9600_LONG,	
	AT_FAX_HDLC_TX_V17_9600_SHORT,	
	AT_FAX_HDLC_TX_V17_12000_LONG,	
	AT_FAX_HDLC_TX_V17_12000_SHORT,	
	AT_FAX_HDLC_TX_V17_14400_LONG,	
	AT_FAX_HDLC_TX_V17_14400_SHORT,	
	AT_FAX_HDLC_RX_V21_300 = 20200,	/* HDLC framingɂf[^M[h̐ݒ */
	AT_FAX_HDLC_RX_V27ter_2400,	
	AT_FAX_HDLC_RX_V27ter_4800,	
	AT_FAX_HDLC_RX_V29_7200,	
	AT_FAX_HDLC_RX_V17_7200_LONG,	
	AT_FAX_HDLC_RX_V17_7200_SHORT,	
	AT_FAX_HDLC_RX_V29_9600,	
	AT_FAX_HDLC_RX_V17_9600_LONG,	
	AT_FAX_HDLC_RX_V17_9600_SHORT,	
	AT_FAX_HDLC_RX_V17_12000_LONG,	
	AT_FAX_HDLC_RX_V17_12000_SHORT,	
	AT_FAX_HDLC_RX_V17_14400_LONG,	
	AT_FAX_HDLC_RX_V17_14400_SHORT,	
	AT_FAX_TX_V21_300 = 20300,		/* f[^M[h̐ݒ */
	AT_FAX_TX_V27ter_2400,
	AT_FAX_TX_V27ter_4800,
	AT_FAX_TX_V29_7200,
	AT_FAX_TX_V17_7200_LONG,
	AT_FAX_TX_V17_7200_SHORT,
	AT_FAX_TX_V29_9600,
	AT_FAX_TX_V17_9600_LONG,
	AT_FAX_TX_V17_9600_SHORT,	
	AT_FAX_TX_V17_12000_LONG,	
	AT_FAX_TX_V17_12000_SHORT,	
	AT_FAX_TX_V17_14400_LONG,	
	AT_FAX_TX_V17_14400_SHORT,	
	AT_FAX_RX_V21_300 = 20400,		/* f[^M[h̐ݒ */
	AT_FAX_RX_V27ter_2400,	
	AT_FAX_RX_V27ter_4800,	
	AT_FAX_RX_V29_7200,	
	AT_FAX_RX_V17_7200_LONG,	
	AT_FAX_RX_V17_7200_SHORT,	
	AT_FAX_RX_V29_9600,	
	AT_FAX_RX_V17_9600_LONG,	
	AT_FAX_RX_V17_9600_SHORT,	
	AT_FAX_RX_V17_12000_LONG,	
	AT_FAX_RX_V17_12000_SHORT,	
	AT_FAX_RX_V17_14400_LONG,	
	AT_FAX_RX_V17_14400_SHORT,
	AT_CMDIDX_MAX	/* ATR}hCfbNXől */
} ATCMDIDX_E;


typedef struct ATCMD {
	ATCMDIDX_E		CmdIdx;		/* ATR}hCfbNXԍ */
	char			*pStr;		/* ATR}hւ̃|C^ */
} ATCMD;


/*----------------------------------------------------------------------
		^C~O邽߂̃EFCg
----------------------------------------------------------------------*/

typedef struct MDMWAIT {
	USHORT	ATEchoBack;		/* GR[obN҂ő厞 [sec] */
	USHORT	ATReply;		/* ATR}h̕Ԏ҂ő厞 [sec] */
	USHORT	BeforeSendCmd;	/* R}hMO҂[sec] */
	USHORT	Rsv[7];			/* \ */
} MDMWAIT;


/*----------------------------------------------------------------------
		f\͏iPCMCIA CISQƁj
		fIAvP[VW[ǂAGUI֔f
----------------------------------------------------------------------*/

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

typedef struct INFO_MODEM_IF {
	USHORT	FlowCtrlMethod;		/* T|[gĂt[ */
	USHORT	DCECmdBufSize;		/* ATR}hCobt@̗e[byte] */
	ULONG	DCEtoDTEBufSize;	/* DCE->DTEobt@e(UART FIFO܂܂)*/
	ULONG	DTEtoDCEBufSize;	/* DTE->DCEobt@e(UART FIFO܂܂)*/
} INFO_MODEM_IF;

/**** TPLFE_FC: .FlowCtrlMethod ****/
#define TPLFE_FC_TX_XONXOFF			0x0001	/* DTE->DCEXON/OFFgp\ */
#define TPLFE_FC_RX_XONXOFF			0x0002	/* DTE<-DCEXON/OFF */
#define TPLFE_FC_TX_HW_FLOW_CTRL	0x0004	/* DTE->DCECTSM */
#define TPLFE_FC_RX_HW_FLOW_CTRL	0x0008	/* DTE<-DCEMRTSM */
#define TPLFE_FC_TRANSPARENT		0x0010	/* DCE--DCEԂ̃t[ */

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

typedef	 struct INFO_DATA_MODEM {
	ULONG	MaxBitRate;			/* DTE-UARTō]x[bps] */
	ULONG	ModulationStd;		/* ϒ */		
	UCHAR	ErrCorrection;		/* G[ */	
	UCHAR	Compression;		/* f[^k */
	UCHAR	CommandProt;		/* R}h` */
	UCHAR	Escapes;			/* [hؑւ@ */
	UCHAR	DataEncryption;		/* StandardizedDataEncryption */
	UCHAR	EndUserFeatures;	/* MiscellaneousEndUserFeatureSelection */
								/* X̃Gh[U[p@\ */
	UCHAR	CountryCode;		/* ԍ */
} INFO_DATA_MODEM;


#define	MDM_NO_FEATURE	0	/* @\ĂȂꍇA0ނ */

/**** TPLFE_MS: .ModulationStd	ModulationStandards ****
										/*    [bps]*/
#define	TPLFE_MS_Bell103	0x00000001	/*   300 */
#define	TPLFE_MS_V21		0x00000002	/*   300 */
#define	TPLFE_MS_V23		0x00000004	/*     600/1200[baud]*/
#define	TPLFE_MS_V22AB		0x00000008	/*    1200 */
#define	TPLFE_MS_Bell212A	0x00000010	/*  2400 */
#define	TPLFE_MS_V22bis		0x00000020	/*  2400 */
#define	TPLFE_MS_V26		0x00000040	/*    2400 */
#define	TPLFE_MS_V26bis		0x00000080	/*    2400 */
#define	TPLFE_MS_V27bis		0x00000100	/*    4800/2400 */
#define	TPLFE_MS_V29		0x00000200	/*    9600/7200/4800 */
#define	TPLFE_MS_V32		0x00000400	/*  9600 */
#define	TPLFE_MS_V32bis		0x00000800	/* 14400 */
#define	TPLFE_MS_V34		0x00001000	/* 28800 */
#define	TPLFE_MS_V34PLUS	0x01000000	/* 33600 */
#define TPLFE_MS_V90		0x02000000	/* 56000 */
						/*ʃfŃT|[gĂ */

#define TPLFE_MS_PDCDATA96		0x00010000L
#define TPLFE_MS_PDCPKT96		0x00020000L
#define TPLFE_MS_PDCPKT288		0x00040000L
#define TPLFE_MS_PIAFS32		0x00100000L
#define TPLFE_MS_PIAFS64		0x00200000L
#define TPLFE_MS_ALFADATA		0x00400000L

/**** TPLFE_EM: .ErrCorrection	Error Correction Protocol ****/
#define	TPLFE_EM_MNP		0x01		/* MNP2,MNP3,MNP4 */
#define	TPLFE_EM_V42LAPM	0x02		/* ITU-T(CCITT) */

/**** TPLFE_DC: .Compression	Data Compression Protocol ****/
#define	TPLFE_DC_NONE	0x00		/* Ȃ */
#define	TPLFE_DC_V42bis	0x01		/*  */
#define	TPLFE_DC_MNP5	0x02		/*  */

/**** TPLFE_CM: .CommandProt	Command Protocol ****/
#define	TPLFE_CM_AT1	0x01	/*  */
#define	TPLFE_CM_AT2	0x02	/*  */
#define	TPLFE_CM_AT3	0x04	/*  */
#define	TPLFE_CM_MNP_AT	0x08	/*  */
#define	TPLFE_CM_V25bis	0x10	/*  */
#define	TPLFE_CM_V25A	0x20	/*  */
#define	TPLFE_CM_DMCL	0x40	/*  */
/*						0x80	reserved */

/**** TPLFE_EX: .Escapes		Escape Mechanism ****/
#define	TPLFE_EX_BREAK		0x01	/* WI'BREAK' */
#define	TPLFE_EX_3PLUS		0x02	/* '+++'ŃfR}h[hɂ邱Ƃł */
#define	TPLFE_EX_USER_DEF	0x04	/* [U[`̃GXP[vg */

/**** TPLFE_DY: .DataEncryption ****/
/* Reserved for Future Use */
#define	TPLFE_DY_NULL	0

/**** TPLFE_EF: .EndUserFeatures ****/
#define	TPLFE_EF_CALLER_ID	0x01

/**** TPLFE_CD: CountryCode ****/
#define	COUNTRY_CODE_END		0xFF	/* R[h̏I}[N */
/* #define	COUNTRY_ */

/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

typedef struct INFO_DOCUMENT_FAX {
	ULONG	MaxBitRate;		/* DTE-UARTō]x[bps] */
	UCHAR	ModulationStd;	
	UCHAR	DataEncryption;
	USHORT	FaxFeatures;
	UCHAR	CountryCode;
} INFO_DOCUMENT_FAX;	

/**** TPLFE_FM: .ModulationStd	Modulation Standards ****/
#define	TPLFE_FM_V21C2	0x01	/*    300[bps] */
#define	TPLFE_FM_V27tar	0x02	/*  4800/2400 */
#define	TPLFE_FM_V29	0x04	/*  9600/7200/4800 */
#define	TPLFE_FM_V17	0x08	/*  14.4K/12000/9600/7200 */
#define	TPLFE_FM_V33	0x10	/*    14.4K/12000/9600/7200 */

/**** TPLFE_FY: .DataEncryption ****/
#define	TPLFE_FY_NULL	0x00

/**** TPLFE_FS: .FaxFeatures ****/
#define	TPLFE_FS_T3				0x01	/*  */
#define	TPLFE_FS_T4				0x02	/*  */
#define	TPLFE_FS_T6				0x04	/*  */
#define	TPLFE_FS_EC_MODE		0x08	/*  */
#define	TPLFE_FS_VOICE_REQUEST	0x10	/*  */
#define	TPLFE_FS_POLLING		0x20	/*  */
#define	TPLFE_FS_FILE_TRANSFER	0x40	/*  */
#define	TPLFE_FS_PASSWORD		0x80	/*  */


/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* f */

typedef struct MODEMINFO {	/* on ROM or RAM */
	USHORT				InfoLen;		/* = sizeof(MODEMINFO) */
	USHORT				InfoPresents;	/* ݂̑tO */
	CISINFO_VERS1		*pVerProduct;	/* i */
	INFO_MODEM_IF 		*pModemIF;		/* ModemIF */
	INFO_DATA_MODEM		*pDataModem;	/* DataModem */
	INFO_DOCUMENT_FAX	*pFax;			/* Fax */
	void				*Rsv[4];		/* ̊gp(NULLŖ߂)*/
} MODEMINFO;


/**** .InfoExists ****/
#define	INFOPRES_NONE			0x00	/* ͂Ȃ */
#define	INFOPRES_VER_PRODUCT	0x01	/* bit0: L1VerProductInfoL */
#define	INFOPRES_MODEM_IF		0x02	/* bit1: ModemIfInfo		K{! */
#define	INFOPRES_DATA_MODEM		0x04	/* bit2: DataModemInfo		K{! */
#define	INFOPRES_DOCUMENT_FAX	0x08	/* bit3: DocumentFaxInfo	K{! */


/*----------------------------------------------------------------------
		^C~O
----------------------------------------------------------------------*/

typedef struct MDMTIMING {
	USHORT	DtrActiveWait;		/*x10[ms] DTRMassertA҂ׂ */
	USHORT	DtrInactiveWait;	/*x10[ms] DTRMnegateA҂ׂ */
	USHORT	BeforeSendCmdWait;	/*x1[s] R}hMȎ҂ */
	USHORT	Rsv[13];	/* \ */
} MDMTIMING;


/*----------------------------------------------------------------------
		FAXhCop
----------------------------------------------------------------------*/

typedef struct MDMFAXPARAM {
	USHORT	RespTimer;		/* M^C}			*/
	USHORT	T1Timer_RX;		/* sP^C}JE^		*/
	USHORT	T2Timer_RX;		/* sQ^C}JE^		*/
	USHORT	T3Timer_RX;		/* sR^C}JE^		*/
 	USHORT	DCSTimer;		/* cbr|sbeԃEGCg	*/
 	USHORT	PIXTimer;		/* ohw|dnoԃEGCg	*/
	/* */
	USHORT	TCFRetry;		/* sbegCJE^	*/
	USHORT	ModemTimer;		/* f҂^C}JE^	*/
	USHORT	PIXDelay;		/* f[^MJnÕfBC	*/
	USHORT	RxDISDelay;		/* chrM̃fBC	*/
	/* */
	USHORT	TCFBytes144;	/* sbeMoCgi14400bpsj*/
	USHORT	TCFBytes120;	/* sbeMoCgi12000bpsj*/
	USHORT	TCFBytes96;		/* sbeMoCgi9600bpsj*/
	USHORT	TCFBytes72;		/* sbeMoCgi7200bpsj*/
	USHORT	TCFBytes48;		/* sbeMoCgi4800bpsj*/
	USHORT	TCFBytes24;		/* sbeMoCgi2400bpsj*/
	/* */
	USHORT	TCFByte144min;	/* sbeMKi14400bpsj*/
	USHORT	TCFByte144max;	/* sbeMKi14400bpsj*/
	USHORT	TCFByte120min;	/* sbeMKi12000bpsj*/
	USHORT	TCFByte120max;	/* sbeMKi12000bpsj*/
	USHORT	TCFByte96min;	/* sbeMKi9600bpsj*/
	USHORT	TCFByte96max;	/* sbeMKi9600bpsj*/
	USHORT	TCFByte72min;	/* sbeMKi7200bpsj*/
	USHORT	TCFByte72max;	/* sbeMKi7200bpsj*/
	USHORT	TCFByte48min;	/* sbeMKi4800bpsj*/
	USHORT	TCFByte48max;	/* sbeMKi4800bpsj*/
	USHORT	TCFByte24min;	/* sbeMKi2400bpsj*/
	USHORT	TCFByte24max;	/* sbeMKi2400bpsj*/
	/* */
	USHORT	RxPIXTimer;		/* ohwM^C}JE^	*/
	/* */
	USHORT	DISTimer;		/* lbe|chrԃ^C}	*/
	USHORT	DISDelay;		/* lbeMchr҃fBC	*/
	/* */
	USHORT	CFRTimer;		/* sbe|beqԃ^C}	*/
	/* */
	USHORT	reserved[20];	/* \ */
} MDMFAXPARAM;



/*----------------------------------------------------------------------
		fML^iOjobt@
----------------------------------------------------------------------*/

typedef struct MDMLOGBUF {
	USHORT	LogBufSize;		/* = sizeof(LogBuf) */
	USHORT	iWrite;			/* ɃLN^ވʒu */
	char	LogBuf[64];		/* fԂ郏[N */
	char	SafetyEos[2];	/* Ŝ */
} MDMLOGBUF;


/*----------------------------------------------------------------------
		f̐ݒp[^
----------------------------------------------------------------------*/

/* _Cg[̌o */
typedef enum MDMDETECTDIALTONE_E {
	MDM_NOT_DETECT_DIAL_TONE,	/* oȂ */
	MDM_DETECT_DIAL_TONE		/* o */
} MDMDETECTDIALTONE_E;


/* _C` */
typedef enum MDMDIALTYPE_E {
	MDM_DIALTYPE_TONE,		/* vbV */
	MDM_DIALTYPE_10PPS,		/* pXi10[PPS]j*/
	MDM_DIALTYPE_20PPS		/* pXi20[PPS]j*/
} MDMDIALTYPE_E;


/* Xs[J[XCb` */
typedef enum MDMSPKCTRL_E {
	MDM_SPK_OFF,		/* OFF */
	MDM_SPK_ON_DIAL,	/* LAo܂ON */
	MDM_SPK_ON,			/* ON */
	MDM_SPK_ON_SETUP	/* _CȊOALAo܂ON */
} MDMSPKCTRL_E;

/* Xs[J[ */
typedef enum MDMSPKVOL_E {
	MDM_SPKVOL_MIN,		/* ʏ */
	MDM_SPKVOL_MID,		/* ʒ */
	MDM_SPKVOL_MAX		/* ʑ */
} MDMSPKVOL_E;


/* DSRM̓ */
typedef enum MDMDSRMODE_E {
	MDM_DSR_ALWAYS_ON,		/* DSRM͏ON */
	MDM_DSR_UNDER_V25bis	/* DSRMV.25bisKiɏ]ē삷 */
} MDMDSRMODE_E;


/* DTE-modemԂ̃t[  */
typedef enum MDMDTEFLOWCTRL_E {
	MDM_DTE_FLOW_CONTROL_OFF,	/* DTE-modemԂ̃t[Ȃ */
	MDM_DTE_FLOW_CONTROL_SOFT,	/* 						  oXON/XOFF */
	MDM_DTE_FLOW_CONTROL_HARD	/* 						  oRS/CS */
} MDMDTEFLOWCTRL_E;


/* modem-modemԂ̃t[ */
typedef enum MDMMODEMFLOWCTRL_E {
	MDM_MODEM_FLOW_CONTROL_OFF,		/* modem-modemԃt[Ȃ */
	MDM_MODEM_FLOW_CONTROL_ON		/* 						   */
} MDMMODEMFLOWCTRL_E;


/* MNPk[h̐ݒ */
typedef enum MDMCOMPRESSMODE_E {
	MDM_COMPRESSION_OFF,	/* MNPf[^ksȂȂ */
	MDM_COMPRESSION_ON		/* MNPf[^ksȂ(V42bis,MNP5I)*/
} MDMCOMPRESSMODE_E;


/* G[ */
typedef enum MDMECCMODE_E {
	MDM_ERR_CONTROL_OFF,				/* G[Ȃ */
	MDM_ERR_CONTROL_ON,					/*  */
	MDM_ERR_CONTROL_FORCED,				/* KLAPM or MNPŐڑ */
	MDM_ERR_CONTROL_A_CELLULAR,			/* Analog cellular */
	MDM_ERR_CONTROL_A_CELLULAR_FORCED,	/* Analog cellularKLAPM or MNPŐڑ */
	MDM_ERR_CONTROL_D_CELLULAR,			/* Digital cellular */
	MDM_ERR_CONTROL_D_CELLULAR_FORCED	/* Digital cellularKLAPM or MNPŐڑ */
} MDMECCMODE_E;


/* ڑx */
typedef enum MDMCONNECTSPD_E {
	MDM_CONNECT_SPD_NONE	 = 0,	/* p[^ȗ */
	MDM_CONNECT_SPD_DEFAULT = 1,	/* ftHg */
	MDM_CONNECT_SPD_1200 = 12,		/*  1200[bps] */
	MDM_CONNECT_SPD_2400 = 24,		/*  2400[bps] */
	MDM_CONNECT_SPD_4800 = 48,		/*  4800[bps] */
	MDM_CONNECT_SPD_9600 = 96,		/*  9600[bps] */
	MDM_CONNECT_SPD_14400 = 144,	/* 14400[bps] */
	MDM_CONNECT_SPD_19200 = 192,	/* 19200[bps] */
	MDM_CONNECT_SPD_24000 = 240,	/* 24000[bps] */
	MDM_CONNECT_SPD_28800 = 288,		/* 28800[bps] */
	MDM_CONNECT_SPD_33600 = 336,		/* 33600[bps] */
	MDM_CONNECT_SPD_36000 = 360,		/* 36000[bps] V.90 */
	MDM_CONNECT_SPD_40000 = 400,		/* 40000[bps] V.90 */
	MDM_CONNECT_SPD_48000 = 480,		/* 48000[bps] V.90 */
	MDM_CONNECT_SPD_52000 = 520,		/* 52000[bps] V.90 */
	MDM_CONNECT_SPD_56000 = 560,		/* 56000[bps] V.90 */
    MDM_CONNECT_PDC_9600DATA = 1000,    /* ocb/ 9600bps Data     */
    MDM_CONNECT_PDC_9600PACKET,         /* ocb/ 9600bps Packet   */
    MDM_CONNECT_PDC_DOPA,               /* ocb/ DoPa             */
    MDM_CONNECT_PIAFS_32K,              /* PIAFS/ 32kbps            */
    MDM_CONNECT_PIAFS_64K,              /* PIAFS/ 64kbps            */
    MDM_CONNECT_ALFADATA                /* f[^                 */
} MDMCONNECTSPD_E;


/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */
/* f̐ݒ */
typedef struct MDMSETTINGS {
	USHORT				Type;			/* enum̃TCY */
	USHORT				Size;			/* sizeof(MDMSETTINGS) */
	MDMDETECTDIALTONE_E	DetectDialTone;	/* _Cg[̌o */
	MDMDIALTYPE_E		DialType;		/* _Č` tone/pulse */
	MDMSPKCTRL_E		SpeakerCtrl;	/* Xs[J[XCb` */
	MDMSPKVOL_E			SpeakerVol;		/* Xs[J[ */
	MDMDSRMODE_E		DSRMode;		/* DSRM̓ */
	MDMDTEFLOWCTRL_E	DTEFlowCtrl;	/* DTE-modemԂ̃t[ */
	MDMMODEMFLOWCTRL_E	ModemFlowCtrl;	/* modem-modemԂ̃t[ */
	MDMCOMPRESSMODE_E	Compression;	/* MNPk[h̐ݒ */
	MDMECCMODE_E		ErrorCorrect;	/* G[ */
	MDMCONNECTSPD_E		ConnectSpeed;	/* ڑx */
	int	Rsv[10];	/* \ */
} MDMSETTINGS;


/*----------------------------------------------------------------------
		f`wb_
----------------------------------------------------------------------*/

typedef UCHAR MDMDRIVERNAME[44];

/* fhCogp\ */
typedef UCHAR MDMDRIVERSTATE;

/*** MDMDRIVERSTATE ***/
#define	MDM_STATE_USELESS	 0x00  /* gps\ */
#define	MDM_STATE_AVAILABLE	 0x01  /* bit0:gp\ 薳 hCo  */
#define	MDM_STATE_GENERAL	 0x02  /* bit1:gp\ L/ėphCo */
#define	MDM_STATE_SAME_MAKER 0x04  /* bit2:gp\ L/[J[̃hCo */
#define	MDM_STATE_PREFERABLE 0x08  /* bit3:gp L/phCo */
#define	MDM_STATE_PIAFS		 0x10  /* bit4:PIAFSJ[h */
				       /* bit5`7: reserved */
#define MDM_STATE_PTE_PARAMS 0x10
#define MDM_STATE_USABLE_MASK	0x0f	/* gp\ԃ}XN */
#define MDM_STATE_USAGE_MASK	0xf0	/* J[hʃ}XN */


/* fhCo BFɎgp */
typedef struct MDMDRVFEATURE {
	ULONG		DataModulationStd;	/* f[^ϒ  vȂ̂łǂ */
	int	Rsv[7];
} MDMDRVFEATURE;

/* f֐ */
/* ֐|C^vg^Cv錾͂Psɔ[߂Kvih2equj*/
typedef MDMDRIVERSTATE	(*MDMJUDGEPROC)( MDMDRIVERNAME *pName, const MODEMINFO *pModemInfo, void *pDummy1, void *pDummy2 );

typedef struct MDMHEADER {
	USHORT		HeaderVer;		/* wb_쐬_ł̃fhCoo[W */
	USHORT		HeaderSize;		/* = sizeof(MDMHEADER) */
	MDMPLACE_E	Place;			/* f̑ݏꏊ */
	MDMJUDGEPROC pJudgeProc;	/* f֐̃AhX */
	short		TopProcNo;		/* pProcTbl̐擪t@NVԍ */
	short		LastProcNo;		/* pProcTbl̍Ō		V			*/
	PROC		*pProcTbl;		/*  t@NṼWve[u */
	ATCMD		*pAtCmdTbl;		/*  ATR}h\ */
	MDMRESULT	*pResultTbl;	/*  UgR[h\ */
  	MODEMINFO 	*pModemInfo;	/*  f */
	MDMTIMING	*pTimingInfo;	/* ^C~O */
	MDMSETTINGS	*pDefaultSettings; /*  fݒ̃ftHgl */
	MDMFAXPARAM	*pFaxParam;		/* FAXpp[^ */
	MDMDRVFEATURE	*pMdmDrvFeature;	/*  fhCo MI-50xȍ~ */
	void		*pJudgeWork;		/* pJudgeProc()̑R */
} MDMHEADER;


#define MDM_DEFAULT_PTR ((void*)0)

/*
		MDM_DEFAULT_PTRƋLqƁAW(ROM)̃e[uQƂ

		MDMHEADER.Place != MDM_PLACE_PCCARD ̏ꍇ
			Kf\͏\̂̃AhXLqȂ΂ȂȂ

		MDMHEADER.Place == MDM_PLACE_PCCARD ̏ꍇ
			MDM_DEFAULT_PTR Lqƃf}l[WPC-Card
			CISǂݏof\͏gpB
			CIS񂪖PC-Cardfp̃fhCoł
			Kf\͏\̂pӂÃAhXLq
			΂ȂȂ
*/


/*----------------------------------------------------------------------
		fReLXg
----------------------------------------------------------------------*/

typedef unsigned short MDMDRVNO;

#define MDM_ATCMD_LEN_MAX	40
#define	MDMBUF_MARGIN		2	/* ]T */
/* iӁj̒lA邱Ɓih2eqû߁j*/

typedef	struct MDM {
	short		WorkSize;		/* sizeof(MDM)Ă */
	short		cBuf;			/* ResultBuf, CmdBuf̃TCY[byte] */
	MDMDRVNO	MdmDrvNo;		/* fhCo̔ԍ */
	FILEHD		FileNo;			/* t@Cnh */
	BCOM		*pBCom;			/* OpenMDM()BCOM|C^ */
								/* OpenMDMFile()ɂNULL */
								/* modem_main.cȊOł͎gps\ */
	MDMHEADER	*pMdmHeader;	/* f`wb_̃AhX */
	MDMLOGBUF	*pLogBuf;		/* [U[pӂOobt@ւptr */
	ABORTMASK	AbortMask;		/* A{[g}XN */
	BOOLEAN		IsSpeakerOn;	/* true: Xs[J[ON */
	MDMSETTINGS	Settings;		/* SetSettingMDM()ł̐ݒ */
	MDMWAIT		Wait;			/* EFCg */
	UINT		WaitUnit;		/* EFCgԂ̒P x10[ms] */
	BOOLEAN		IsEchoEnabled;	/* true: GR[obNENABLE */
	int		Rsv1;				/* ̂߂̗\ */
	int		Rsv2;				/* ̂߂̗\ */
	int		Rsv3;				/* ̂߂̗\ */
	char	CmdBuf[40+2];		/* R}hiGR[obNjobt@ */
	char	AnswerBuf[40+2];	/* f̉ێ */
/*					MDM_ATCMD_LEN_MAX + MDMBUF_MARGINiӁj */
} MDM;


/*======================================================================
					Cu֐p̃p[^
======================================================================*/

/* fhCoԍidiag or fT[rXgppIIj*/
#define	BLTIN_MODEM_DRIVER 0


/*----------------------------------------------------------------------
		fT[rX for GetMDMServiceInfo()
----------------------------------------------------------------------*/

typedef struct MDMSVCINFO {
	int	Version;	/* o[W */
	int	Rsv3;		/* ̊gp */
	int	Rsv2;		/* ̊gp */
	int	Rsv1;		/* ̊gp */
} MDMSVCINFO;


/*----------------------------------------------------------------------
		fhCõXg for GetDriverListMDM()
----------------------------------------------------------------------*/

#define	NULL_MODEM_NO	(USHORT)0xFFFF

typedef struct MDMDRVENTRY {
	MDMDRVNO		ModemNo;		/* fhCoԍ OpenMDM()֓n */
	MDMDRIVERSTATE	State;			/* gp\ */
	UCHAR			Devices;		/* fgp\ȒʐMfoCX */
	COMMDEVNAME		CommDevName[3];	/* gp\ȒʐMfoCXiRport܂Łj*/
	MDMDRIVERNAME	DriverName;		/* fhCo̕ */
} MDMDRVENTRY;



/*----------------------------------------------------------------------
		fhCȍ̎ for GetDriverInfoMDM()
----------------------------------------------------------------------*/

typedef enum MDMINFOKIND_E {
	MDMINFO_VERSION,	/* @ʑΉfhCõo[W */
	MDMINFO_MODEM_IF,	/* DTE-DCEC^[tFCX̔\ */
	MDMINFO_DATA_MODEM,	/* f[^f̔\ */
	MDMINFO_FAX_MODEM	/* FAXf̔\ */
} MDMINFOKIND_E;


/*----------------------------------------------------------------------
		fhCȍ̎ for GetDriverInfoMDM()
----------------------------------------------------------------------*/

typedef union MDMDRVINFO {
	USHORT				DrvVersion;	/* MDMINFO_VERSION		*/
	INFO_MODEM_IF		ModemIF;	/* MDMINFO_MODEM_IF		*/
	INFO_DATA_MODEM		DataModem;	/* MDMINFO_DATA_MODEM	*/
	INFO_DOCUMENT_FAX	Fax;		/* MDMINFO_FAX_MODEM	*/
	ULONG	Area[12];	/* ĝ߂̗̈m */
} MDMDRVINFO;


/*----------------------------------------------------------------------
		UART샂[h for SetUartModeMDM()
----------------------------------------------------------------------*/

typedef struct MDMUARTMODE {
	char	ByteSize;	/* DATABIT_7(7)=7bit, DATABIT_8(8)=8bit */	
	char	Parity;		/* PARITY_NONE(0)=Ȃ */
						/* PARITY_ODD(1)=, PARITY_EVEN(2)= */
	char	StopBits;	/* STOPBIT_1(0)=1bit, STOPBIT_1h(1)=1.5bit, */
						/* STOPBIT_2(2)=2bit */
	char	FlowMethod;	/* t[@ */
	ULONG	BaudRate;	/* {[[g\l */
	int		Rsv[2];		/* ̊gp */
} MDMUARTMODE;

/**** MDMUARTMODE.FlowMethod ****/
#define	MDM_UART_FLOW_CTRL_OFF	0	/* t[䂵Ȃ */
#define	MDM_UART_FLOW_CTRL_SOFT	1	/* XON/XOFF */
#define	MDM_UART_FLOW_CTRL_HARD	2	/* RTS/CTS */


/*----------------------------------------------------------------------
		_C̓ for CallTelMDM()
----------------------------------------------------------------------*/

typedef enum MDMCALLMODE_E {
	MDM_CALL_NO_WAIT = 0,	/* R}h[ĥ܂܂Ƀ^[ */
	MDM_CALL_WAIT_CONNECT	/* RlNg܂ő҂ă^[ */
} MDMCALLMODE_E;


/*======================================================================
					Cu֐̖߂l
======================================================================*/

/* CheckEchoMDM()̖߂l */
#define	MDM_ECHOBACK_ENABLED	1
#define	MDM_ECHOBACK_DISABLED	0
/* <0 G[ */


/*======================================================================
					Cu֐vg^Cv錾
======================================================================*/

/* f}l[W  VXe֐ */
int	InitMDMService( int initLevel );
int	IocsActivateMDM( void );

int	GetMDMServiceInfo( MDMSVCINFO *pInfo );

int AddMDM( const MDMHEADER *pMdmHeader );
int	RemoveMDM( const MDMHEADER *pMdmHeader );

/* fIc[p֐ */
int GetDriverListMDM( MDMDRVENTRY aEntryList[], UINT maxEntries );
int GetDriverInfoMDM( MDMDRVNO ModemNo, MDMINFOKIND_E InfoKind,
					  MDMDRVINFO *pInfo );

/* fhCop ჌x֐iAvP[V͎gpȂƁj*/
int TurnOnSpeakerMDM( MDM *pMdm, MDMSPKVOL_E Vol );
int TurnOffSpeakerMDM( MDM *pMdm );
int ReadComMDM( MDM *pMdm, char *pBuf, ULONG Len );			/* hCop */
int WriteComMDM( MDM *pMdm, const char *pBuf, ULONG Len );	/* hCop */
int	FlushComMDM( MDM *pMdm );								/* hCop */

int SendCommandStrMDM( MDM *pMdm, const char *pCmdPtr );
int	WaitAnswerStrMDM( MDM *pMdm, UINT timeout, char *pAnsBuf );
int ATIdxToCmdStrMDM( MDM *pMdm, ATCMDIDX_E atIdx, char *pRetBuf );
ATRESULTIDX_E ResultStrToIdxMDM( MDM *pMdm, const char *pResultStr );
int ExecATCommandMDM( MDM *pMdm, ATCMDIDX_E atId );
ATRESULTIDX_E WaitResultIdxMDM( MDM *pMdm, int timeout );
int CheckEchoMDM( MDM *pMdm );
int DisableEchoMDM( MDM *pMdm );
int EnableEchoMDM( MDM *pMdm );

/* AvP[Vp֐ */
/* int	EnablePostEventMDM(); */
ABORTMASK SetAbortMaskMDM( MDM *pMdm, ABORTMASK Mask );
ABORTMASK GetAbortMaskMDM( MDM *pMdm );

MDM *OpenMDMFile( FILEHD FileNo, MDMDRVNO ModemNo, MDMLOGBUF *pLogBuf,
				  UINT WaitUnit );
MDM *OpenMDM( BCOM *pBCom, MDMDRVNO ModemNo, MDMLOGBUF *pLogBuf );
int	CloseMDM( MDM *pMdm );
int SetUartModeMDM( MDM *pMdm, MDMUARTMODE *pMode );
int GetUartModeMDM( MDM *pMdm, MDMUARTMODE *pMode );
int SetDtrMDM( MDM *pMdm );
int ClearDtrMDM( MDM *pMdm );
int ResetModemMDM( MDM *pMdm );
int InitModemMDM( MDM *pMdm, const char *pInitCmdStr );
int GetDefaultSettingsMDM( MDM *pMdm, MDMSETTINGS *pSettings );
int SetSettingsMDM( MDM *pMdm, MDMSETTINGS *pSettings );
int OffHookMDM( MDM *pMdm );
int OnHookMDM( MDM *pMdm );
int CallTelMDM( MDM *pMdm, const char *pTelNumStr,
			    MDMCALLMODE_E mode, UINT waitTime );
int WaitCallMDM( MDM *pMdm, UINT callCount, UINT timeOut );
int MonitorTelMDM( MDM *pMdm );
int AnswerTelMDM( MDM *pMDM, UINT TimeOut );
int TurnCommandModeMDM( MDM *pMdm );
int TurnDataModeMDM( MDM *pMdm );

int InitFaxMDM( MDM *pMdm );
ATRESULTIDX_E ExecFaxCmdMDM( MDM *pMdm, ATCMDIDX_E CmdNo, UINT TimeOut );
ATRESULTIDX_E WaitFaxResultMDM( MDM *pMdm, UINT TimeOut );
int GetFaxParamMDM( MDM *pMdm, MDMFAXPARAM *pParam );


/*======================================================================
			IOCSt@NVԍ		trapa #MODEM_IOCS
======================================================================*/

/* f}l[W  VXe */
#define	INIT_MDM_SERVICE		 0x40	/*  */
#define	GET_MDM_SERVICE_INFO	 0x41	/* MDMT[rX̏𓾂 */
#define	ADD_MDM					 0x43	/* fhCoǉ */
#define	REMOVE_MDM				 0x44	/* fhCo폜 */

/* fIc[p */
#define	GET_DRIVER_LIST_MDM		 0x46	/* fhCöꗗ𓾂 */
#define	GET_DRIVER_INFO_MDM		 0x47	/* fhCȍ𓾂 */

/* fhCop ჌xt@NV */
#define	TURN_ON_SPEAKER_MDM		 0x4b	/* Xs[JON */
#define	TURN_OFF_SPEAKER_MDM	 0x4c	/* Xs[JOFF */
#define	READ_COM_MDM			 0x4d	/* COMhCoM */
#define	WRITE_COM_MDM			 0x4e	/* COMhCo֑M */
#define	FLUSH_COM_MDM			 0x4f	/* COMhCõL[𐴑| */
#define	SEND_COMMAND_STR_MDM	 0x50	/* ATR}h𑗐M*/
#define	WAIT_ANSWER_STR_MDM		 0x51	/* ԎM */
#define	AT_IDX_TO_CMD_STR_MDM	 0x52	/* ATR}h𓾂 */
#define	RESULT_STR_TO_IDX_MDM	 0x53	/* ATʃR[hCfbNXԍ𓾂 */
#define	EXEC_AT_COMMAND_MDM		 0x54	/* ATR}hs */
#define	WAIT_RESULT_IDX_MDM		 0x55	/* ATR}ȟʂ҂ */

/* AvP[Vp t@NV */
#define	CHECK_ECHO_MDM			 0x5a	/* GR[obNԂǂ */
#define	DISABLE_ECHO_MDM		 0x5b	/* GR[obN֎~ */
#define	ENABLE_ECHO_MDM			 0x5c	/* GR[obN */
#define	ENABLE_POST_EVENT_MDM	 0x5d 	/* CxgbZ[Wo^ */
#define	SET_ABORT_MASK_MDM		 0x5e	/* A{[g}XNݒ肷 */
#define	GET_ABORT_MASK_MDM		 0x5f	/* ݂̃A{[g}XN */

#define	OPEN_MDM_FILE			 0x60	/* fhCogpJn(from FILE) */
#define	OPEN_MDM				 0x61	/* fhCogpJn(from BCOM) */
#define	CLOSE_MDM				 0x62	/* fhCogpI */
#define	SET_UART_MODE_MDM		 0x63	/* UART[hݒ肷 */
#define	GET_UART_MODE_MDM		 0x64	/* ݂UART[h𓾂 */
#define	SET_DTR_MDM				 0x65	/* DTRMON*/
#define	CLEAR_DTR_MDM			 0x66	/* DTRMOFF */
#define	RESET_MODEM_MDM			 0x68	/* fZbg */
#define	INIT_MODEM_MDM			 0x69	/* fݒ肷 */
#define	GET_DEFAULT_SETTINGS_MDM 0x6a	/* ftHg̃fݒ𓾂 */	
#define	SET_SETTINGS_MDM		 0x6b	/* fݒ肷 */	
#define	OFF_HOOK_MDM			 0x6c	/* q */
#define	ON_HOOK_MDM				 0x6d 	/* ؂ */
#define	CALL_TEL_MDM			 0x6e	/* db */
#define	WAIT_CALL_MDM			 0x6f	/* db҂A󂯂 */
#define	MONITOR_TEL_MDM			 0x70	/* qŁARlNgȂ */
#define	ANSWER_TEL_MDM			 0x71	/* db(CONNECT) */
#define	TURN_COMMAND_MODE_MDM	 0x72	/* R}h[hֈڍs */
#define	TURN_DATA_MODE_MDM		 0x73	/* f[^[hֈڍs */

/* FAXhCopt@NV	ʃAvP[Vgp֎~II */
#define	INIT_FAX_MDM			 0x74	/* FAX[hp̏sȂ */
#define	EXEC_FAX_CMD_MDM		 0x75	/* FAXpATR}h𑗂 */
#define	WAIT_FAX_RESULT_MDM		 0x76	/* FAX̃Ug҂ */
#define	GET_FAX_PARAM_MDM		 0x77	/* FAXfp̃p^𓾂 */
/* ȏAFAXhCop̊֐ */


#define	STD_MDM_FUNC_TOP	RESET_MODEM_MDM	
#define	STD_MDM_FUNC_END	GET_FAX_PARAM_MDM
/* STD_MDM_FUNC_TOP`STD_MDM_FUNC_END@ˑt@NV */



/*====================================================================*/
/*								}N								  */
/*====================================================================*/
#ifdef IN_MDM_DRIVER
#define Wait10ms(WaitTime) self_sleep( ((WaitTime)*64)/100 )

/***********************************************************************
y֐z  BOOLEAN IsValidMDMPtr( MDM *pMdm )
y@  \z  pMdm MDM\̂wĂ邩ǂ
yz  pMdm
				MDM\̂ւ̃|C^
y߂lz  true	pMdm ͐
			false	pMdm ͐Ȃ	

***********************************************************************/

#define IsValidMDMPtr(pMdm) ( sizeof(MDM) == (pMdm)->WorkSize )

#endif /* IN_MDM_DRIVER */

/* ͎gpȂƁiRpCG[̂߁j */
#define	WaitATResultMDM(pMdm)	WaitResultIdxMDM((pMdm),(pMdm)->Wait.ATReply)
#define	GetATResultIndexMDM(pMdm)	\
			ResultStrToIdxMDM((pMdm),(pMdm)->AnswerBuf)
#define	GetATCommandMDM(pMdm,atIdx,pRetBuf) \
			ATIdxToCmdStrMDM(pMdm,atIdx,pRetBuf)

#endif /* #ifndef _MODEMLIB_H_INCLUDED */
