/***********************************************************************
<t@C>	msgsvlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		bZ[WT[o[IOCSCũwb_
***********************************************************************/

#ifndef _MSGSVLIB_H_INCLUDED
#define _MSGSVLIB_H_INCLUDED


#include <sharpgen.h>
#include <eventmsg.h>

typedef struct EMSG_COMMON	{
	USHORT	MessageID;	/*  CommonMsgID  */
	USHORT	OccuredTime;	/*    */
} EMSG_COMMON;

typedef	struct EMSG_LCONTENT {
	long	L[5];	/* alignmentTCY(20byte)mۂ̂ */
} EMSG_LCONTENT;

typedef	union EVENTMESSAGE {
	EMSG_COMMON		CmnMsg;
#include	<eventmlt.h>	/*@CxgbZ[W@*/
	EMSG_LCONTENT	LContent;
} EVENTMESSAGE;


#ifndef H2EQU

/*======================================================================
						bZ[WtB^[֐
======================================================================*/

typedef void (*MSGFILTERFUNC)( EVENTMESSAGE * );


/*======================================================================
					VXeR[֐vg^Cv錾
======================================================================*/

typedef	char	MODIFIER;

/* DeletePenEventMsg( xxx ) */
typedef enum DELPENMSGMODE {
	DELETE_ALL_PEN_MSG,	/* SĂPenbZ[W폜 */
	LEAVE_FIRST_PEN_UP	/* ŌÂ"PenUp"͎c */
} DELPENMSGMODE;


int	MsgSvrIOCSActivate( void );								/* 0x3D */
int	MsgSvrInit( int, int );									/* 0x40 */
int	GetEventMsg( EVENTMESSAGE * );							/* 0x41 */
int	LookEventMsg( EVENTMESSAGE * );							/* 0x42 */
int	SetEventMsg( EVENTMESSAGE * );							/* 0x43 */
/* 0x44 p~ */
int	DeleteEventMsg( USHORT );								/* 0x45 */
int	CheckMsgFull( void );									/* 0x46 */
/* 0x47-0x4C p~ */
short ResetQuota( void );									/* 0x4D */
short MoveRelativeQuota( int );								/* 0x4E */
int	LimitedSetEventMsg( EVENTMESSAGE * );					/* 0x4F */
int	LimitedSetEventMsgOnlyOne( EVENTMESSAGE * );			/* 0x50 */
int	MaskableGetEventMsg( EVENTMESSAGE *, EVENTMSGMASK );	/* 0x51 */
int	MaskableLookEventMsg( EVENTMESSAGE *, EVENTMSGMASK );	/* 0x52 */
int	UpdateEventMsg( EVENTMESSAGE * );						/* 0x53 */
int	SetSameEventMsgOnlyOne( EVENTMESSAGE * );				/* 0x54 */ 
int DeleteSameEventMsg( EVENTMESSAGE * );					/* 0x55 */
MODIFIER SetModifier( MODIFIER );							/* 0x56 */
MODIFIER ClearModifier( MODIFIER );							/* 0x57 */
MODIFIER ReverseModifier( MODIFIER );						/* 0x58 */
MODIFIER LookModifier( void );								/* 0x59 */
int	DeletePenEventMsg( DELPENMSGMODE );						/* 0x5A */
ULONG GetSystemTickCount( void );							/* 0x5B */
int	AddMsgFilterFunc( int, MSGFILTERFUNC );					/* 0x5C */
int	RemoveMsgFilterFunc( int, MSGFILTERFUNC );				/* 0x5D */
EVENTMSGMASK CalcMsgMaskFromID( USHORT msgID );				/* 0x5E */
int EnableFastTick( UCHAR Interval );						/* 0x5F */
int DisableFastTick( void );								/* 0x60 */
ULONG GetFastTickCount( void );								/* 0x61 */
int DeleteKeyRepeatMsg( void );								/* 0x62 */

#endif H2EQU


/*======================================================================
				IOCSt@NVԍ	trapa #MSG_SVR_IOCS
======================================================================*/

#define	MSG_SVR_INIT				0x40	/*bZ[WT[o[	*/
#define	GET_EVENT_MSG				0x41	/*bZ[W̎o		*/
#define	LOOK_EVENT_MSG				0x42	/*bZ[W̐ǂ		*/
#define	SET_EVENT_MSG				0x43	/*quota𖳎āAbZ[Wqueue֓o^ */
#define	DELETE_EVENT_MSG			0x45	/*bZ[W폜			*/
#define	CHECK_MSG_FULL				0x46	/*bZ[WL[t𒲂ׂ*/
#define	RESET_QUOTA				0x4d	/* quotaftHgʒu֖߂	*/
#define	MOVE_RELATIVE_QUOTA		0x4e	/* quotaړ			*/
#define	LIMITED_SET_EVENT_MSG	0x4f	/* bZ[Wqueue֓o^iquotaŁj*/
#define	LIMITED_SET_EVENT_MSG_ONLY_ONE 0x50 /*L[ɂPbZ[Wo^*/
#define	MASKABLE_GET_EVENT_MSG	0x51	/* bZ[W̎oimasktj*/
#define	MASKABLE_LOOK_EVENT_MSG	0x52	/* bZ[W̐ǂ݁imasktj*/
#define	UPDATE_EVENT_MSG		0x53	/* L[̃bZ[WXV*/
#define	SET_SAME_EVENT_MSG_ONLY_ONE 0x54 /*ebZ[WPo^*/
#define	DELETE_SAME_EVENT_MSG	0x55	/* ebZ[W폜*/
#define	SET_MODIFIER			0x56	/* modifier bit𗧂Ă('1'ɂ)*/
#define	CLEAR_MODIFIER			0x57	/* modifier bit('0'ɂ)*/
#define	REVERSE_MODIFIER		0x58	/* modifier bit𔽓]('0'<->'1')*/
#define	LOOK_MODIFIER			0x59	/* ݂modifier bitԂ	*/
#define	DELETE_PEN_EVENT_MSG	0x5A	/* queuePenbZ[W폜 */
#define	GET_SYSTEM_TICK_COUNT	0x5B	/* ݂SystemTickJE^l𓾂 */
#define	ADD_MSG_FILTER_FUNC		0x5C	/* tB^[֐o^ */
#define	REMOVE_MSG_FILTER_FUNC	0x5D	/* tB^[֐폜 */
#define	CALC_MSG_MASK_FROM_ID	0x5E	/* bZ[WID}XN𓾂 */
#define	ENABLE_FAST_TICK		0x5F	/* FastTick𔭐Jn */
#define	DISABLE_FAST_TICK		0x60	/* FastTick~ */
#define	GET_FAST_TICK_COUNT		0x61	/* ݂FastTickJEgl𓾂 */
#define	DELETE_KEY_REPEAT_MSG	0x62	/* queueKey(repeat)bZ[W폜 */

/*	AVKt@NVǉꍇ́Aȍ~ɒǉ邱ƁB*/
/*	p~t@NVԍ󂢂Ă邩ƌāAɕʂ  */
/*	t@NV蓖ĂĂ͂ȂȂi펯Ij	*/


/*======================================================================
						Cu֐̖߂l
======================================================================*/


/* 0x46 CHECK_MSG_FULL */

#define	Q_STATE_AVAIL		0
#define	Q_STATE_OVER_QUOTA	1
#define	Q_STATE_FULL		-1


/*======================================================================
								}N
======================================================================*/

#ifndef H2EQU

/***********************************************************************
ymacroz CleanEventMsg( EVENTMESSAGE *pMsg )
y@  \z  CxgbZ[W̒g𐴑|
yz	pMsg	CxgbZ[Wp̂̃AhX
y߂lz  Ȃ

***********************************************************************/

#define CleanEventMsg(pMsg) \
		(pMsg)->LContent.L[0]=0; \
		(pMsg)->LContent.L[1]=0; \
		(pMsg)->LContent.L[2]=0; \
		(pMsg)->LContent.L[3]=0; \
		(pMsg)->LContent.L[4]=0

#endif H2EQU


#endif	/* #ifndef _MSGSVLIB_H_INCLUDED */

/* end of msgsvlib.h */
