/***********************************************************************
<t@C>	pioinfo.h

	Copyright (c) 1995-1999 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-EX1
***********************************************************************/

#ifndef _PIOINFO_H_INCLUDED

#include <sharpgen.h>
#include <timelib.h>
#include <dtmlib.h>

/*======================================================================
		PIOCX^XPIOXL[}
======================================================================*/
/*======================================================================

  f[^Ȃ
  EftHgf[^ꍇ͂g
  EȂꍇ̓G[ƂȂ

  ftHgf[^̋Lq@́H
  Eݎ
  ELҏ

======================================================================*/

/*======================================================================
		{^̒`
======================================================================*/
/*----------------------------------------------------------------------
		PIOo[W
		4bitW[o[WA4bit}Ci[o[W
----------------------------------------------------------------------*/
typedef UCHAR	PIOVERSION;

/*----------------------------------------------------------------------
		PIOf[^x[Xʖ(WoCgp)
----------------------------------------------------------------------*/
#define	PIODBID_LEN		(8)
#ifndef	H2EQU
typedef UCHAR	PIODBID[PIODBID_LEN];		/* f[^x[Xʖ */
#endif	H2EQU

/*----------------------------------------------------------------------
		PIOf[^x[X
----------------------------------------------------------------------*/
#define	PIODBTITLE_LEN	(255)

/*----------------------------------------------------------------------
		PIOf[^x[X
----------------------------------------------------------------------*/
typedef ULONG	PIODBATTR;
#define	PIODBATTR_ALL			0x00000000	/* Ȃ */
#define	PIODBATTR_LANDMARK		0x00000001	/* n}֕\ */
#define	PIODBATTR_PICTURE		0x00000002	/* 摜f[^ */
#define	PIODBATTR_MPF			0x00000004	/* MPF */
#define	PIODBATTR_READONLY		0x80000000	/* ҏWs\ */
#define	PIODBATTR_CANNOTDEL		0x40000000	/* f[^x[X폜s */

/*----------------------------------------------------------------------
		PIOڔԍ
		PIO鍀ڐ255܂
----------------------------------------------------------------------*/
typedef UCHAR	PIOITEMNO;

/*----------------------------------------------------------------------
		e
----------------------------------------------------------------------*/
typedef UCHAR	PIOCODETYPE;
#define	PIO_ICODET_KANJI		0x80	/*  */
#define	PIO_ICODET_SYMBOL		0x40	/* L */
#define	PIO_ICODET_HIRAGANA		0x20	/* Ђ炪 */
#define	PIO_ICODET_KATAKANA		0x10	/* J^Ji */
#define	PIO_ICODET_ALPHABET		0x08	/* At@xbg */
#define	PIO_ICODET_NUMERIC		0x04	/*  */
#define	PIO_ICODET_HANKAKU		0x02	/* p */
#define	PIO_ICODET_ZENKAKU		0x01	/* Sp */
#define	PIO_ICODET_ALL			0xff	/* Ȃ */

/*----------------------------------------------------------------------
		DATA_ID_CODE/PIO_UNKNOWN_TYPE̒ǉ
----------------------------------------------------------------------*/
typedef UCHAR	PIOCODEATTR;
#define	PIO_ICODEA_ONLY_CAND	0x01	/* IȊO̓͋֎~ */
#define	PIO_ICODEA_FORBID_NL	0x02	/* sR[h̓͋֎~ */

/*----------------------------------------------------------------------
		DATA_ID_[BINARY|IMAGE]/PIO_IMAGE_TYPẺ摜tH[}bg
----------------------------------------------------------------------*/
typedef	UCHAR	PIOIMAGETYPE;
#define	PIO_IIMAGEF_ALL			0	/* ׂ(ʁH) */
#define	PIO_IIMAGEF_ZIMAGE		1	/* IMAGEDATA */
#define	PIO_IIMAGEF_ZPM			2
#define	PIO_IIMAGEF_JPEG		3
#define	PIO_IIMAGEF_EXIF		4
#define	PIO_IIMAGEF_GIF			5
#define	PIO_IIMAGEF_PNG			6
#define	PIO_IIMAGEF_ZBITMAP		7	/* PIV[Y݊ */
#define	PIO_IIMAGEF_TMNL		8	/* TlC` */

typedef UCHAR	PIOIMGITEMTYPE;
#define	PIO_IMGITEMT_NATIVE		0
#define	PIO_IMGITEMT_LEGACY		1

/*----------------------------------------------------------------------
		DATA_ID_TIME/PIO_UNKNOWN_TYPȄꍇ̕\`
----------------------------------------------------------------------*/
typedef	UCHAR	PIOTIMETYPE;
#define	PIO_ITIMEF_YMDHM		0	/* ftHg */
#define	PIO_ITIMEF_YMD			1
#define	PIO_ITIMEF_YM			2	/* N */
#define	PIO_ITIMEF_HMS			3
#define	PIO_ITIMEF_HM			4

/*----------------------------------------------------------------------
		DATA_ID_TIME/PIO_UNKNOWN_TYPȄꍇ̕\`
----------------------------------------------------------------------*/
typedef UCHAR	PIOTIMEATTR;
#define	PIO_ITIMEA_NO_WILD		0x01	/* ȗĂ鍀ڂŏl */
										/* BftHg̓ChJ[ */
										/* hɂB  */
#define	PIO_ITIMEA_ALLOW_WILD	0x02	/* ҏWΏۃtB[hɃCh */
										/* J[h:ftHg̓G[  */
										/* ƂĈ*/

/*----------------------------------------------------------------------
		DATA_ID_CODE/PIO_PDBBCD_TYPȄꍇ̑
----------------------------------------------------------------------*/
typedef	UCHAR	PIOIBCDATTR;
#define	PIO_IBCD_COMMA			0x01	/* R} */

/*======================================================================
		PIOgf[^x[XS̏
======================================================================*/
#ifndef H2EQU
typedef struct PIOEXTDBINFO {
	PIODBID		dbId;				/* f[^x[Xʖ('\0'Ȃ) */
	UCHAR		*dbName;			/* f[^x[X('\0'Kv) */
	PIOVERSION	dbVer;				/* f[^x[Xo[W */
	TIME		dbCreateTime;		/* 쐬 */
	ITEMNAME	dbFirstSortKey;		/* P\[gL[ */
	ITEMNAME	dbSecondSortKey;	/* Q\[gL[ */
	UCHAR		isFirstAscendent;	/* (true),~(false) */
	UCHAR		isSecondAscendent;	/* (true),~(false) */
	ITEMNAME	dbTitleItem;		/* ^Cg */
	ULONG		cardMaxLen;			/* PJ[hl */
	PIODBATTR	dbAttr;				/* f[^x[X */
	ITEMNAME	dbIconItem;			/* ACR */
	UCHAR		dbIconResName[9];	/* ACR\[X */
	UCHAR		reserved1;
	UCHAR		reserved2;
	UCHAR		reserved3;
	UCHAR		*dbCreator;			/* f[^x[X݌v */
} PIOEXTDBINFO;
#endif H2EQU

/*======================================================================
		f[^^Cvɉǉ\
======================================================================*/
/*----------------------------------------------------------------------
		DATA_ID_CODE/PIO_UNKNOWN_TYPȄꍇ̒ǉ
----------------------------------------------------------------------*/
#ifndef H2EQU
typedef struct PIOCODEINFO {
	PIOCODETYPE	charType;			/* e镶 */
	PIOCODEATTR	attr;				/* ǉ */
	ITEMNAME	pairItem;			/* ֘A */
	UCHAR		*defData;			/* ftHgf[^ */
	UCHAR		*canData;			/* If[^ */
									/* eڂ'\r'(=0x0d)ŋ؂ */
} PIOCODEINFO;
#endif H2EQU

/*----------------------------------------------------------------------
		DATA_ID_TIME/PIO_UNKNOWN_TYPȄꍇ̒ǉ
----------------------------------------------------------------------*/
#ifndef H2EQU
typedef struct PIOTIMEINFO {
	PIOTIMETYPE	format;				/* \`(*1) */
	PIOTIMEATTR	attr;				/* ǉ(*2) */
	TIME		defData;			/* ftHgf[^ */
	TIME		minTime;			/* ŏl */
	TIME		maxTime;			/* ől */
} PIOTIMEINFO;
#endif H2EQU

/*----------------------------------------------------------------------
		DATA_ID_[WORD|UCHAR]/PIO_UNKNOWN_TYPȄꍇ̒ǉ
----------------------------------------------------------------------*/
#ifndef H2EQU
typedef struct PIONUMBERINFO {
	ULONG		defValue;
	ULONG		minValue;
	ULONG		maxValue;
	UCHAR		*valueIndex;
} PIONUMBERINFO;
#endif H2EQU

/*----------------------------------------------------------------------
		DATA_ID_CODE/PIO_PDBBCD_TYPȄꍇ̒ǉ
		itemExtUval̈ʒu|C^ŃLXgăANZX
----------------------------------------------------------------------*/
#ifndef H2EQU
typedef struct PIOBCDINFO {
	UCHAR		attr;
	UCHAR		reserved1;
	UCHAR		reserved2;
	UCHAR		reserved3;
} PIOBCDINFO;
#endif H2EQU

/*======================================================================
		ڋʊg`
======================================================================*/
/*----------------------------------------------------------------------
		ڕ
----------------------------------------------------------------------*/
typedef ULONG	ITEMATTR;
#define	PIO_IATTR_NECESSARY		0x00000001	/* K{(F߂Ȃ) */
											/* œo^悤Ƃ */
											/* ̓ftHgf[^o^ */
											/* (PIOxŏ) */
#define	PIO_IATTR_UNIQUE		0x00000002	/* d֎~() */
#define	PIO_IATTR_FIXED_BYTES	0x00000004	/* Œ蒷() */
#define	PIO_IATTR_INVISIBLE		0x00000008	/* B */
#define	PIO_IATTR_INPUT_DEFDATA	0x00000010	/* VK͎ɃftHgf[ */
											/* ^o(PICOxŏ) */

/*----------------------------------------------------------------------
		ژ_(prȂȂ)
----------------------------------------------------------------------*/
typedef ULONG	ITEMTYPE;
#define	PIO_ITYPE_UNKNOWN	0
#define	PIO_ITYPE_ZIPC		1		/* X֔ԍ */
#define	PIO_ITYPE_TEL		2		/* dbԍ */
#define	PIO_ITYPE_FAX		3		/* FAXԍ */
#define	PIO_ITYPE_PAGER		4		/* |Pxԍ */
#define	PIO_ITYPE_CPHONE	5		/* gѓdbԍ */
#define	PIO_ITYPE_MAIL		6		/* [AhX */
#define	PIO_ITYPE_ADDR		7		/* Z */
#define	PIO_ITYPE_NAME		8		/* O(ŗL) */
#define	PIO_ITYPE_YOMI		9		/* ǂ */
#define	PIO_ITYPE_URL		10		/* URL */
#define	PIO_ITYPE_BLOOD		11		/* t^ */
#define	PIO_ITYPE_BIRTH		12		/* a */
#define	PIO_ITYPE_PRIORITY	13		/* dvx */
#define	PIO_ITYPE_THUMBNAIL	14		/* TlC */
#define	PIO_ITYPE_POSTIT	17		/* PostIt */
#define	PIO_ITYPE_DATE		18		/* f[^쐬t */
#define	PIO_ITYPE_SYSTEM	19		/* VXe */
#define	PIO_ITYPE_IMAGE		20		/* C[W */
#define	PIO_ITYPE_ICON		21		/* ACR */

#define	PIO_ITYPE_UNSET		0xffffffff	/* gp֎~ - ĂȂ */

/*----------------------------------------------------------------------
		PIOf[^^Cv Tuf[^IDƂĎg(܂ŕtH[}bg)
----------------------------------------------------------------------*/
typedef	UCHAR	PIODATATYPE;
#define	PIO_UNKNOWN_TYPE		0	/* wȂ */
#define	PIO_PDBBCD_TYPE			2	/* PDB BCD` */
#define	PIO_LATITUDE_TYPE		3	/* 9ɂܓx\ */
#define	PIO_LONGITUDE_TYPE		4	/* 10ɂox\ */
#define	PIO_IMAGE_TYPE			5	/* C[W */
#define	PIO_MPF_TYPE			6	/* MPF */

/*----------------------------------------------------------------------
		DATA_ID_[BINARY|IMAGE]/PIO_IMAGE_TYPȄꍇ̒ǉ
		ɊւĂ͍ږɏAf[^x[XƂĈ
		̏Aǂ̍ڂC[WڂȂ̂m
		Ƃł
		tHĝ悤ɍږɃC[WtH[}bg𕪂̂ƁA
		PIOlCeBũf[^x[X̂悤Ɉ̃C[WڂƁA
		̃C[WtH[}bgڂ̂(݂\)B
----------------------------------------------------------------------*/
#ifndef H2EQU
/* Â^CṽC[W */
typedef struct PIOLEGACYIMGITEM {
	PIOIMAGETYPE	format;				/* i[tH[}bg */
	UCHAR			reserved1;
	UCHAR			reserved2;
	UCHAR			reserved3;
	ITEMNAME		itemName;			/* 摜i[ */
} PIOLEGACYIMGITEM;

typedef struct PIOLEGACYIMG {
	UCHAR				formatNum;		/* i[\ȃtH[}bg̐ */
	UCHAR				reserved1;
	UCHAR				reserved2;
	UCHAR				reserved3;
	PIOLEGACYIMGITEM	*imageItems;	/* ꂼ̍ڔz(ϒ) */
	ULONG				reserved4;
} PIOLEGACYIMG;

/* V^CṽC[W */
typedef struct PIONATIVEIMG {
	ITEMNAME		imageItem;		/* 摜f[^i[ */
	ITEMNAME		formatItem;		/* 摜`i[ */
									/* ̍ڂDATA_ID_UCHARłȂ */
									/* ȂȂ */
	ITEMNAME		thumbnailItem;	/* TlC */
} PIONATIVEIMG;

typedef struct PIOIMGITEM {
	PIOIMGITEMTYPE	imageType;		/* V^̃^CvH */
	UCHAR			reserved1;
	UCHAR			reserved2;
	UCHAR			reserved3;
	USHORT			maxWidth;		/* z肳ő啝(hbg) */
	USHORT			maxHeight;		/* z肳ő卂(hbg) */
	union PIOIMGITEMINFO {
		PIOLEGACYIMG	legacy;		/*  */
		PIONATIVEIMG	native;		/* PIOlCeBu */
	} info;
} PIOIMGITEM;

typedef struct PIOIMAGEINFO {
	UCHAR		imageItemNum;		/* DBɊ܂܂C[Wڐ */
	UCHAR		reserved1;
	UCHAR		reserved2;
	UCHAR		reserved3;
	PIOIMGITEM	imageItems[1];		/* C[Wڔz(ϒ) */
} PIOIMAGEINFO;
#endif H2EQU
/*----------------------------------------------------------------------
		DATA_ID_CODE/PIO_[LATITUDE|LONGITUDE]_TYPȄꍇ̒ǉ
		ɊւĂ͍ږɏAf[^x[XƂĈ
		̏
----------------------------------------------------------------------*/
#ifndef H2EQU
typedef struct PIOGEOINFO {
	ITEMNAME	iconItem;		/* ACR񍀖(Ȃ'\0') */
								/* ꂪȂꍇ͊ACR񍀖 */
								/* QƂ */
	UCHAR		iconResName[9];	/* n}ACR\[X */
	UCHAR		reserved1;
	UCHAR		reserved2;
	UCHAR		reserved3;		/* ܂ł16oCg */
	ITEMNAME	ltLtItem;		/* ܓx */
	ITEMNAME	ltLgItem;		/* ox */
	ITEMNAME	rbLtItem;		/* Eܓx(Ȃ'\0') */
	ITEMNAME	rbLgItem;		/* Eox(Ȃ'\0') */
} PIOGEOINFO;
#endif H2EQU

/*======================================================================
  		ڋʊg\
======================================================================*/
#ifndef H2EQU
typedef struct PIOEXTITEMINFO {
	ITEMNAME	itemName;
	DATATYPE	dataId;
	CONVTYPE	convId;
	PIODATATYPE	subDataId;
	UCHAR		reserved1;
	UCHAR		reserved2;
	UCHAR		reserved3;
	ITEMTITLE	itemTitle;
	ITEMATTR	itemAttr;			/* ڕ */
	ITEMTYPE	itemType;			/* ژ_ */
	DATALEN		len;				/* ͍ő咷^Œ蒷 */
	ULONG		itemExtUval;		/* ǉ(SoCgȓ) */
	void		*itemExt;			/* ǉ()ւ̃|C^ */
} PIOEXTITEMINFO;
#endif H2EQU

#ifndef H2EQU
typedef struct PIOEXTITEMINFO_CHUNK {
	ITEMNAME	itemName;
	DATATYPE	dataId;
	CONVTYPE	convId;
	PIODATATYPE	subDataId;
	UCHAR		reserved1;			/* i[̎wɎg... */
	ITEMATTR	itemAttr;
	ITEMTYPE	itemType;
	DATALEN		len;
	ULONG		itemExtUval;		/* ǉ(SoCgȓ) */
} PIOEXTITEMINFO_CHUNK;
#endif H2EQU


#ifndef H2EQU
/* r[Ɋւ */
typedef struct ITEMLISTFORM {
	PIOITEMNO		idx;			/* itemInfõCfbNX(1-) */
	UCHAR			reserved;
	USHORT			column;
} ITEMLISTFORM;

typedef struct ITEMVIEWFORM {
	PIOITEMNO		idx;			/* itemInfõCfbNX(1-) */
	UCHAR			reserved;
} ITEMVIEWFORM;

/* `N̍\() */
typedef struct ITEMLISTFORM_CHUNK {
	ITEMNAME		itemName;
	USHORT			column;
} ITEMLISTFORM_CHUNK;

typedef struct ITEMVIEWFORM_CHUNK {
	ITEMNAME		itemName;
} ITEMVIEWFORM_CHUNK;

typedef struct PIOEXTINFO {
	PIOVERSION		extInfoVer;		/* PIOEXTINFÕo[W */
	UCHAR			reserved1;
	PIOEXTDBINFO	dbInfo;			/* S̏(wb_) */
	PIOITEMNO		itemNum;
	PIOITEMNO		lItemNum;
	PIOITEMNO		vItemNum;
	PIOEXTITEMINFO	*itemInfo;		/* ϒzւ̃|C^ */
	ITEMLISTFORM	*listForm;		/* ϒzւ̃|C^ */
	ITEMVIEWFORM	*viewForm;		/* ϒzւ̃|C^ */
	PIOIMAGEINFO	*imgInfo;		/* C[W */
	PIOGEOINFO		*geoInfo;
	ULONG			reserved2;
	ULONG			reserved3;
} PIOEXTINFO;
#endif H2EQU

/*======================================================================
  		BOXt@Cg
======================================================================*/
typedef enum PIOEXTTAB {
	PIOEXT_TAG_END = 0,
	/* gbvx`N */
	PIOEXT_TAG_ROOT,				/* f[^x[XS̏ */
	PIOEXT_TAG_ITEMS,				/* ڏ(ڐJԂ) */
	PIOEXT_TAG_LISTFORM,			/* XgtH[ */
	PIOEXT_TAG_VIEWFORM,			/* r[tH[ */
	PIOEXT_TAG_IMAGE,				/* C[Wڏ */
	PIOEXT_TAG_GEOINFO,				/* ʒu */
	/* ʃTux`N */
	PIOEXT_TAG_ITEM_NUM = 100,		/* ڂ̐(gp[P]) */
	/* Tux`N */
	PIOEXT_TAG_DBINFO = 150,		/* f[^x[X */
	PIOEXT_TAG_DBNAME,				/* f[^x[X */
	PIOEXT_TAG_DBCREATOR,			/* f[^x[X݌v */
	PIOEXT_TAG_ITEMINFO,			/* ڋʏ */
	PIOEXT_TAG_CODEINFO,			/* DATA_ID_CODEpg */
	PIOEXT_TAG_TIMEINFO,			/* DATA_ID_TIMEpg */
	PIOEXT_TAG_NUMBERINFO,			/* DATA_ID_[UCHAR/WORD] */
	PIOEXT_TAG_DEFAULT,				/* ftHgf[^ */
	PIOEXT_TAG_CANDIDATE,			/* f[^ */
	PIOEXT_TAG_INDEX_TEXT,			/* CfbNXf[^(p) */
	PIOEXT_TAG_IMAGEINFO,
	PIOEXT_TAG_LEGACYIMG,
	PIOEXT_TAG_UNKNOWN = -1
} PIOEXTTAB;

#define	PIOEXT_CHUNK_HEADER_MAGIC	0x12345678

/* BOXt@Cgwb_̍\ */
#define	PIOEXT_HEADER_MAGIC			0
#define	PIOEXT_HEADER_VERSION		(PIOEXT_HEADER_MAGIC+4)
#define	PIOEXT_HEADER_EXTLEN		(PIOEXT_HEADER_VERSION+1)
#define	PIOEXT_HEADER_LEN			(PIOEXT_HEADER_EXTLEN+4)

/* `Nwb_̍\ */
#define	PIOEXT_CHUNK_ID				0
#define	PIOEXT_CHUNK_CHUNKLEN		(PIOEXT_CHUNK_ID+2)
#define	PIOEXT_CHUNK_HEADER_LEN		(PIOEXT_CHUNK_CHUNKLEN+4)

#define	_PIOINFO_H_INCLUDED
#endif	/* _PIOINFO_H_INCLUDED */
