/***********************************************************************
<t@C>	sharpgen.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/****************************************************************
	ł{IȂs錾
*****************************************************************/

#ifndef _SHARP_GENERAL_H_DEFINED
#define	_SHARP_GENERAL_H_DEFINED

#ifndef _UCHAR_DEFINED
typedef unsigned char 	UCHAR;
#define	_UCHAR_DEFINED
#endif

#ifndef	_USHORT_DEFINED 
typedef unsigned short 	USHORT;
#define	_USHORT_DEFINED
#endif

#ifndef	_UINT_DEFINED 
typedef unsigned int 	UINT;
#define	_UINT_DEFINED
#endif

#ifndef	_ULONG_DEFINED
typedef unsigned long	ULONG;
#define	_ULONG_DEFINED
#endif

#ifndef	_POINT_DEFINED
typedef struct POINT {
	short	x;
	short	y;
} POINT;
#define	_POINT_DEFINED
#endif

#ifndef _UPOINT_DEFINED
typedef struct UPOINT {
	USHORT	x;
	USHORT	y;
} UPOINT;
#define	_UPOINT_DEFINED
#endif

#ifndef	_RECTANGLE_DEFINED
typedef struct RECTANGLE {
	short	left;
	short	top;
	USHORT	width;
	USHORT	height;
} RECTANGLE;
#define	_RECTANGLE_DEFINED
#endif

#ifndef TRUE
#define TRUE	1
#endif

#ifndef FALSE
#define FALSE	0
#endif

/* G[` */
#ifndef DONE
#define	DONE	0	/*  */
#endif

#ifndef ERROR
#define	ERROR	1	/* G[ */
#endif

#ifndef DUMMY_AREA_PTR
#define DUMMY_AREA_PTR	((void*)0)
#endif

/* e^ݒ */
typedef enum BOOLEAN {
	false,
	true
} BOOLEAN;
typedef void	(*PROC)();
typedef UCHAR	(*ucPROC)();
typedef ULONG	APLID;			/* ex.'SCDL' */
typedef	ULONG	TOOLID;
typedef USHORT	RESTYPE;		/* ex.'DM' */
typedef USHORT	RESFNO;			/* ex.'00' */
typedef USHORT	RESID;
typedef	UCHAR	RESFNAME[9];
typedef USHORT	KEYCODE;
typedef UCHAR	KEYATTR;

/* EBhEnh */
typedef UCHAR	WINDOWHD;

/* bZ[WID */
typedef USHORT	MESSAGEID;

#ifndef __STDC__
typedef UCHAR	**HANDLE;
typedef UCHAR	*PTR;
#define	INTEGER	register UCHAR	/*MACRO*/
#else
typedef void	**HANDLE;
typedef void	*PTR;
#define	INTEGER	UINT			/*MACRO*/
#endif

typedef	UCHAR	*STRING;

typedef	HANDLE	(*hPROC)();
typedef	PTR 	(*pPROC)();

/* \[X\ */
typedef struct RESOURCE {
	UCHAR	ResFile[9];
	USHORT	ResID;
} RESOURCE;

typedef struct APLRES {
	RESID	ResID;
	RESFNO	ResFNo;
} APLRES;

/* R[obN֐ */
typedef struct CBPROC {
	PROC Proc;
	USHORT Lang;
} CBPROC;

typedef struct ucCBPROC {
	ucPROC Proc;
	USHORT Lang;
} ucCBPROC;

typedef struct hCBPROC {
	hPROC Proc;
	USHORT Lang;
} hCBPROC;

/* \f[^ */
typedef struct CB {
	CBPROC		Func;
	void		*Work;
} CB;

typedef union DISPDATA {
	RESOURCE	ResData;
	CB			CallBack;
	PTR			DataPtr;
} DISPDATA;

/* vpeB */
typedef union PROPERTY_V {
	UCHAR	ucValue;
	USHORT	usValue;
	UINT	uiValue;
	ULONG	ulValue;
	char	cValue;
	short	sValue;
	int		iValue;
	long	lValue;
	PTR		pValue;
	HANDLE	hValue;
	BOOLEAN	blValue;
	PROC	procValue;
} PROPERTY_V;

/* QoCgANZXp}N */
#define	SetWToBArray(Barray,Word)	(*((UCHAR*)(Barray))	= (Word),	\
									 *((UCHAR*)(Barray)+1)	= (Word)>>8)

#define	GetWFromBArray(Barray)			\
		(*((UCHAR*)(Barray))+(*((UCHAR*)(Barray)+1)<<8))

/* SoCgANZXp}N */
#define	SetLToBArray(Barray,LWord)	(*((UCHAR*)(Barray))	= (LWord),		\
									 *((UCHAR*)(Barray)+1)	= (LWord)>>8,	\
									 *((UCHAR*)(Barray)+2)	= (LWord)>>16,	\
									 *((UCHAR*)(Barray)+3)	= (LWord)>>24)

#define	GetLFromBArray(Barray)			\
		(*((UCHAR*)(Barray))+(*((UCHAR*)(Barray)+1)<<8)	\
		 +(*((UCHAR*)(Barray)+2)<<16)+(*((UCHAR*)(Barray)+3)<<24))

/* WCu֐` */
#if !defined(USE_NEWLIB)&&!defined(USE_LOCAL_LIBC)
char *itoa(int val, char *str, int rad);
int strncasecmp(char *src, char *trg, int len);
#define	strcasecmp(s,t)		strncasecmp(s,t,0)
#endif

/* fobOo */
#ifdef FINAL_RELEASE
#define	ZDebugMessage(ignore)
#define	ZDebugWindow(ignore)
#define	ZAssert(ignore)
#else
void ZDebugMessage(STRING str);
void ZDebugWindow(STRING str,STRING str2,int num);
#define	ZAssert(value)	\
((void)((value) || ZDebugWindow(#value,__FILE__,__LINE__)))
#endif

#endif

