/***********************************************************************
 
 <zm_conf.h>

		ZMail Connection Configure Header

***********************************************************************/
#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _ZMCONFH_
#define _ZMCONFH_

#include "mail.h"
#include "mail_prf.h"

BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
#define CONF_TAG_0	1
#define CONF_TAG_1	2
#define CONF_TAG_2	3
#define CONF_TAG_3	4

typedef struct CONNECTCONF
{
	BOOLEAN	IsDefault;
	char	TelNum[SIZE_OF_TELNUM];
	char	ConId[SIZE_OF_CONID];
	BOOLEAN	EveryPasswd;
	char	PassWd[SIZE_OF_PSWD];
	char	PopAc[SIZE_OF_MADR];
	char	PopP[SIZE_OF_PSWD];
	char	SvAdr[SIZE_OF_MADR];
	char	PopSvr[SIZE_OF_MADR];
	char	MlAdr[SIZE_OF_MADR];
	char	*Script;
	ULONG	IpAdr;
	BOOLEAN	IsGetIp;
	ULONG	GateWay;
	ULONG	SubNet;
	char   	DNS1[SIZE_OF_IP];
	char	DNS2[SIZE_OF_IP];
	USHORT	ZPSize;
	USHORT	SPSize;
	BOOLEAN	ZPap;
	BOOLEAN	SPap;
	BOOLEAN	ZPComp;
	BOOLEAN	SPComp;
	BOOLEAN	ZAComp;
	BOOLEAN	SAComp;
	ULONG	ZCMap;
	ULONG	SCMap;
	BOOLEAN	ZTComp;
	BOOLEAN	STComp;

} CONNECTCONF;

END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif _ZMCONFH_
