/***********************************************************************
<t@C>	alert.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
***********************************************************************/
#ifndef ALERT_H_INCLUDED
#define ALERT_H_INCLUDED
#include	<sharpgen.h>
#include	<zdrawlib.h>
#include	<button.h>

/************************************************/
/*	A[g{bNXXgN`錾	*/
/************************************************/

/****************************************/
/*@A[g{bNX{^XgN`@*/
/****************************************/
typedef	struct	AlboxBtnStrc	{
	UCHAR		AlboxBtnFileName[9] ;	/*@{^̃\[Xt@C@*/
	USHORT		AlboxBtnID ;		/*@\[Xhc@{^hc  */
	UCHAR		ButtonMode;		/* {^[h */
	CDSPMODE	CharMode;		/* {^ */
	FRAMEMODE	FrameMode;		/* Eg{^[h */
	GUICOLOR	CharFgColor;	/* {^tHAJ[ */
	GUICOLOR	ButtonBgColor;	/* Eg{^obNJ[ */
} ALBOX_BTN_STRC;


/****************************************/
/*@A[g{bNXXgN`	*/
/****************************************/
typedef	struct	AlboxWork	{
	UCHAR		AlboxFrame ;		/*@EBhEg^Cv̎w@*/
	UCHAR		AlboxPos ;		/*@EBhEI[vʒu@*/
	USHORT		AlboxType ;		/*@A[g{bN̊ew@*/
	USHORT		CallBackBank ;		/*@R[obNoN	*/
	USHORT		(*CallBackAdr)() ;	/*@R[obNAhX@*/
	UCHAR		*CallBackWork ;		/*@R[obNA[Nւ̃|C^@*/
	UCHAR		AlboxBtnNum ;		/*@gp{^@*/
	ALBOX_BTN_STRC	AlboxBtnStrc[3] ;	/*@gp{^XgN`@*/
	COLOR		AlboxWinColor;		/*  A[gWindowJ[  */
	COLOR		AlboxLineColor;		/*  ؂J[  */
	COLOR		AlboxMessColor;		/*  \J[  */
	USHORT		AlboxDummy;			/*@ACg𒲐邽߂̃_~[@*/
	USHORT		AlboxMessLen ;		/*@\̒@*/
     /* UCHAR		AlboxMess[?] ;		/*@\	*/
 } ALBOXWORK ;



	/*@EBhEg^CvmAlboxFramen*/
/*@(bit7)EBhEge̗Lw@*/
#define	ALB_WITH_SHADOW		0x80	/*@et@*/
#define	ALB_NON_SHADOW		0x00	/*@eȂ@*/
/*@(bit5-4) O@*/
/*@(bit3-0)EBhEg̃^Cvw@*/
#define	ALB_NON_FRAME		0x00	/*@gȂ@*/
#define	ALB_SINGLE_FRAME	0x01	/*@Pdg@*/
#define	ALB_DOUBLE_FRAME	0x02	/*@Qdg@*/
#define	ALB_FRAME_MASK		0x07	/*@gw̃}XN@*/

	/*@EBhEI[vʒumAlboxPosn*/
#define ALB_CENTER		0x00		/*@ʒ@*/
#define ALB_CORNER_RIGHT_OVER	0x04		/*@ʉE㖧@*/
#define ALB_CORNER_LEFT_OVER	0x05		/*@ʍ㖧@*/
#define ALB_CORNER_RIGHT_UNDER	0x06		/*@ʉE@*/
#define ALB_CORNER_LEFT_UNDER	0x07		/*@ʍ@*/
#define ALB_RIGHT_OVER		0x08		/*@ʉE@*/
#define ALB_LEFT_OVER		0x09		/*@ʍ@*/
#define ALB_RIGHT_UNDER		0x0a		/*@ʉE@*/
#define ALB_LEFT_UNDER		0x0b		/*@ʍ@*/
#define ALB_OVER_ON		0x14		/*@ʏ㖧@*/
#define ALB_UNDER_ON		0x16		/*@ʉ@*/
#define ALB_OVER_NEAR		0x18		/*@ʏ@*/
#define ALB_UNDER_NEAR		0x1a		/*@ʉ@*/
#define ALB_RIGHT_ON		0x24		/*@ʉE@*/
#define ALB_LEFT_ON		0x25		/*@ʍ@*/
#define ALB_RIGHT_NEAR		0x28		/*@ʉE@*/
#define ALB_LEFT_NEAR		0x29		/*@ʍ@*/


	/*@A[g{bN̊ewmAlboxTypen*/
/*@(bit9,10)TEhw@*/
#define	ALB_OPEN_SOUND_CONFIRM	0x200		/*  mFnm */
#define	ALB_OPEN_SOUND_CAUTION	0x400		/*  xnm */
/*@(bit8)vbVI[vw@*/
#define	ALB_NO_PUSHU_OPEN	0x100	/*@vbVI[vȂ@*/
#define	ALB_PUSHU_OPEN		0x000	/*@vbVI[v@*/
/*@(bit7)^Cgw@*/
#define ALB_TITLE_EXIST		0x80		/*@Psڂ̓^Cg@*/
#define ALB_NON_TITLE		0x00		/*@PsڂbZ[W@*/
/*@(bit6)bZ[WTCYw@*/
#define MESS_NORMAL_LETTER	0x00		/*@^CgƓTCY@*/
#define MESS_SMALL_LETTER	0x40		/*@PNTCY@*/
/*@(bit5){^ʒuw@*/
#define ALB_BTN_CENTERING	0x00		/*@Z^O@*/
#define ALB_BTN_RIGHT_SIDE	0x20		/*@E@*/
/*@(bit4)I[vỎ@*/
#define	ALB_OPEN_SOUND_ON	0x10		/*  I[vnm */
#define	ALB_OPEN_SOUND_OFF	0x00		/*  I[vnee */
/*@(bit3-0){^w@*/
#define NO_BTN			0x00		/*@ݒ{^gp@*/
#define YES_NO_BTN		0x01		/*@͂A@*/
#define ENH_YES_NO_BTN		0x02		/*@͂A@*/
#define JIKKOU_CHUUSHI_BTN	0x03		/*@sA~@*/
#define ENH_JIKKO_CHUUSHI_BTN	0x04		/*@sA~@*/
#define SETTEI_CHUUSHI_BTN	0x05		/*@ݒA~@*/
#define ENH_SETTE_CHUUSHI_BTN	0x06		/*@ݒA~@*/
#define KAKUNIN_CHUUSHI_BTN	0x07		/*@mFA~@*/
#define ENH_KAKUNIN_CHUUSHI_BTN	0x08		/*@mFA~@*/
#define YES_BTN			0x09		/*@͂@*/
#define JIKKOU_BTN		0x0a		/*@s@*/
#define KAKUNIN_BTN		0x0b		/*@mF@*/
#define ENH_KAKUNIN_BTN		0x0c		/*@mF@*/
#define CHUUSHI_BTN		0x0d		/*@~@*/
#define DUMMY_BTN		0x0f		/*@_~[@*/
/*@[DUMMY_BTN]̓{^ȂƂɁAꎞ\^CvɂȂ̂h߂̐ݒlł@*/

	/*@ݒ{^̃{^hc@*/
#define		DefBtnYesID			2000			/* ͂ */
#define		DefBtnNoID			2001			/*  */
#define		DefBtnEmpNoID		DefBtnNoID		/*  */
#define		DefBtnExecID		2003			/* s */
#define		DefBtnBreakID		2004			/* ~ */
#define		DefBtnEmpBreakID	DefBtnBreakID	/* ~ */
#define		DefBtnSetID			2006			/* ݒ */
#define		DefBtnKakuninID		2007			/* mF */
#define		DefBtnEmpKakuninID	DefBtnKakuninID	/* mF */


	/*@uAlboxErrorvbZ[W̃o[uErrorCodev̒liunsigned charj@*/
#define ALBOX_OPEN_ERROR	0x00		/*@EBhEI[vG[@*/
#define ALBOX_ABORT_OCCURE	0x01		/*@A{[g@*/


	/*@R[obN̖߂liunsigned intj@*/
#define ALBOX_CONTINUE		0x0000		/*@s@*/
#define ALBOX_IGNORE		0x0001		/*@bZ[W@*/
#define ALBOX_ABORT		0x0002		/*@I@*/

#endif





