/***********************************************************************
<t@C>	apmmsg.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_APMMSG_H_INCLUDED
#define	_APMMSG_H_INCLUDED
/***********************************************************************
		APMbZ[W`
***********************************************************************/
#include <apmlib.h>
#include <factmsg.h>
#include <fclib.h>

/* APMAvP[Vւ̃bZ[W	  1 -  39 */
/* AvP[VAPMւ̃bZ[W	 40 -  59 */
/* ZASpbZ[W							 60 -  80 */
/* APMbZ[W					  	 90 -  99 */

/* APMAv */
#define	AppliOffID			1	/* Itv - p~ */
#define	AppliStartupCheckID	2	/* AvNmFv */
#define	AppliInID			3	/* hv */
#define	AppliOutID			4	/* nv */
#define	AppliExecID			5	/* dv */
#define	AppliActivateID		6	/* ANeBu^ANeBuؑ֗v */
#define	AppliResumeInfoID	7	/* Čv */
#define	AppliGlobalSearchID	8	/* O[oT[`v */
#define	AppliEventServiceID	9	/* CxgT[rXv */
#define	AppliEventInID		10	/* Cxghv */
#define	AppliEventOutID		11	/* Cxgnv */
#define	AppliProcStartID	12	/* vZXNv */
#define	AbortOccurredID		13	/* A{[g */
								/* A{[g}XNĂGetMessagep */
#define	EventOccurredID		14	/* Cxg */
#define	AppliReExecID		15	/* N[hύXv */
#define	AppliServiceInID	16	/* AvP[VT[rXJn */
#define	AppliServiceOutID	17	/* AvP[VT[rXI */
#define	AppliPowerID		18	/* dON/OFFv */
#define	AppliVolumeUpdateID	19	/* {[XV */
#define	AppliProcEndID		20	/* vZXIv */

/* AvAPM */
#define	AppliEndReqID		40	/* Avvintsvj */
#define	AppliStartupReqID	41	/* AvNv */
#define	GlobalSearchReqID	42	/* O[oT[`Jnv */
#define	DataLinkReqID		43	/* ֘AÂJnv */
#define	AppliEventExecReqID	44	/* Cxgsv */
#define	AppliEventEndReqID	45	/* CxgsIv */
#define	AppliCompleteID		46	/* I */
#define	AppliNotExecID		47	/* ss\ */
#define	AppliPreviousReqID	48	/* PÕAvP[Vɖ߂v */
#define	AppliReExecReqID	49	/* AvP[VEXECv */
#define	AppliProcEndReqID	50	/* AvP[VvZXIv */
#define	AppliProcStartReqID	51	/* AvP[VvZXNv */
#define	AppliServExecReqID	52	/* AvP[VT[rXv */
#define	AppliServEndReqID	53	/* AvP[VT[rXIv */
#define	AppliProcRestartReqID	54	/* AvP[VvZXċNv */

#define	AppliZASMessageID	70
#define	AppliZASAnswerID	71
#define	AppliWinRedispID	72
#define	AppliEmbedEventID	73

/* APMł̂ݎgp郁bZ[W */

#define	AppliInitID			90	/*  */

#define	GlobalSearchEndID	95	/* O[oT[`I */

#define	AppliNameReqID		96	/* p~bZ[W */

/****************************************/
/*	`olbZ[W̒`		*/
/****************************************/

/* `olbZ[WiMj	`olAv */

struct	APPLI_OFF		/*  Itv  */
{
	USHORT	MessageID;		/*  AppliOffID  */
	USHORT	OccuredTime;	/*    */
	USHORT	OffFactor;		/*  Itv  */
};

struct	APPLI_STARTUP_CHECK	/*  AvNmFv  */
{
	USHORT	MessageID;		/*  AppliStartupCheckID  */
	USHORT	OccuredTime;	/*    */
	USHORT	StartCondition;	/*  N  */
	USHORT	ExecCondition;	/*    */
	USHORT	StartFactorMsg;
/*	APM_FACTOR_MSG	StartFactor;	*/	/*  NvbZ[W  */
};

#ifndef H2EQU
struct	APPLI_IN			/*  hv  */
{
	USHORT	MessageID;		/*  AppliInID  */
	USHORT	OccuredTime;	/*    */
	USHORT	StartCondition;	/*  N  */
	USHORT	ExecCondition;	/*    */
	APM_FACTOR_MSG	InFactor;	/*  NvbZ[W  */
};

struct	APPLI_OUT		/*  nv  */
{
	USHORT	MessageID;		/*  AppliOutID  */
	USHORT	OccuredTime;	/*      */
	APLID	ExecAppliName;	/*  vƂȂAvio  */
	APM_FACTOR_MSG	OutFactor;	/*  OUTvbZ[W  */
};
#endif H2EQU

struct	APPLI_EXEC		/*  dv  */
{
	USHORT	MessageID;		/*  AppliExecID  */
	USHORT	OccuredTime;	/*    */
};

#ifndef H2EQU
struct	APPLI_ACTIVATE		/*  ANeBu^ANeBuؑ֗v  */
{
	USHORT		MessageID;			/* AppliActivateID */
	USHORT		OccuredTime;		/*  */
	BOOLEAN		IsActivate;			/* ANeBu^ANeBu */
	APM_FACTOR_MSG	ActiveFactor;	/*  vbZ[W  */
};
#endif H2EQU

struct	APPLI_RESUME_INFO	/*  Čv   */
{
	USHORT	MessageID;		/*  AppliResumeInfoID  */
	USHORT	OccuredTime;	/*    */
};

struct	APPLI_GLOBAL_SEARCH	/*  O[oT[`v  */
{
	USHORT	MessageID;		/*  AppliGlobalSearchID  */
	USHORT	OccuredTime;	/*    */
	UCHAR	SearchDirection;/*    */
};

#ifndef H2EQU
struct  APPLI_EVENT_SERVICE	/*  CxgT[rXv  */
{
	USHORT	MessageID;		/*  AppliEventServiceID  */
	USHORT	OccuredTime;	/*    */
	UCHAR	OccurredState;	/*    */
	APM_FACTOR_MSG	EventFactor;	/*  CxgbZ[W  */
};

struct	APPLI_EVENT_IN		/*  Cxghv  */
{
	USHORT	MessageID;		/*  AppliEventInID  */
	USHORT	OccuredTime;	/*    */
	UCHAR	OccurredState;	/*    */
	APM_FACTOR_MSG	EventInFactor;	/*  CxgbZ[W  */
};

struct	APPLI_EVENT_OUT		/*  Cxgnv  */
{
	USHORT	MessageID;		/*  AppliEventOutID  */
	USHORT	OccuredTime;	/*    */
	APLID	ExecAppliName;	/*  vƂȂAvio  */
	APM_FACTOR_MSG	EventOutFactor;	/*  vbZ[W  */
};
#endif H2EQU

struct	APPLI_NAME_REQ		/*  AvP[Vv  */
{
	USHORT	MessageID;		/*  AppliNameReqID  */
	USHORT	OccuredTime;	/*    */
	UCHAR	*AppliName;		/*  AvP[VԂAhX  */
};

#ifndef H2EQU
struct	APPLI_PROC_START	/* vZXNv */
{
	USHORT		MessageID;		/* AppliProcStartID */
	USHORT		OccuredTime;	/*  */
	USHORT		InitLevel;
	APLMAINPROC	AplEntry;
	APLRES		AplRes;
	long		Param;
	USHORT		MaxHeapNum;
	OBJECT_NAME	AplQueueName;
};
#endif H2EQU

struct	ABORT_OCCURRED		/* A{[g */
{
	USHORT	MessageID;			/* AbortOccurredID */
	USHORT	OccuredTime;		/*  */
	USHORT	AbortMessageID;		/* A{[g̃bZ[WID */
};

struct	EVENT_OCCURRED		/* Cxg */
{
	USHORT	MessageID;			/* EventOccurredID */
	USHORT	OccuredTime;		/*  */
	USHORT	EventMessageID;		/* Cxg̃bZ[WID */
};

#ifndef H2EQU
struct	APPLI_RE_EXEC		/* N[hύX */
{
	USHORT	MessageID;			/* AppliReExecID */
	USHORT	OccuredTime;
	USHORT	StartCondition;		/*  VN  */
	USHORT	ExecCondition;		/*  V  */
	APM_FACTOR_MSG	ReExecFactor;	/*  NvbZ[W  */
};

struct	APPLI_SERVICE_IN	/* AvP[VT[rXJn */
{
	USHORT		MessageID;			/* AppliServiceID */
	USHORT		OccuredTime;
	APM_FACTOR_MSG	ServInFactor;	/*  NvbZ[W  */
};

struct	APPLI_SERVICE_OUT	/* AvP[VT[rXI */
{
	USHORT	MessageID;		/*  AppliServiceOutID  */
	USHORT	OccuredTime;	/*    */
	APLID	ExecAppliName;	/*  vƂȂAvio  */
	APM_FACTOR_MSG	ServOutFactor;	/*  vbZ[W  */
};

struct	APPLI_POWER			/* dON/OFFv */
{
	USHORT	MessageID;				/*  AppliPower  */
	USHORT	OccuredTime;			/*    */
	USHORT	PowerMode;				/* [h */
	APM_FACTOR_MSG	PowerFactor;	/*  vbZ[W  */
};
#endif H2EQU

struct	APPLI_VOLUME_UPDATE		/* {[XV */
{
	USHORT	MessageID;				/* AppliVolumeUpdateID */
	USHORT	OccuredTime;			/*  */
	UCHAR	VolumeNo;				/* {[ԍ */
	BOOLEAN	IsAvailable;			/* gp\H */
};

struct	APPLI_PROC_END			/* vZXIv */
{
	USHORT	MessageID;				/* AppliProcEndID */
	USHORT	OccuredTime;			/*  */
};

/*  `olbZ[WiMj	AvLBC */

struct	GLOBAL_SEARCH_REQ	/*  O[oT[`Jnv  */
{
	USHORT	MessageID;		/*  GlobalSearchReqID  */
	USHORT	OccuredTime;	/*    */
	UCHAR	GlobalSearch;	/*  O[o^L[[hT[`w  */
};

struct	DATA_LINK_REQ		/*  ֘AÂJnv  */
{
	USHORT	MessageID;		/*  DataLinkReqID  */
	USHORT	OccuredTime;	/*    */
};

struct	APPLI_EVENT_EXEC_REQ	/*  Cxgsv  */
{
	USHORT	MessageID;		/*  AppliEventExecReqID  */
	USHORT	OccuredTime;	/*    */
};

struct	APPLI_EVENT_END_REQ	/*  CxgsIv  */
{
	USHORT	MessageID;		/*  AppliEventEndReqID  */
	USHORT	OccuredTime;	/*    */
};

struct	APPLI_COMPLETE		/*  I  */
{
	USHORT	MessageID;		/*  AppliCompleteID  */
	USHORT	OccuredTime;	/*    */
};

struct	APPLI_NOT_EXEC		/*  ss\  */
{
	USHORT	MessageID;		/*  AppliNotExecID  */
	USHORT	OccuredTime;	/*    */
};

struct	APPLI_PREVIOUS_REQ	/*  PÕAvP[Vɖ߂v  */
{
	USHORT	MessageID;			/*  AppliPreviousReqID  */
	USHORT	OccuredTime;		/*    */
	APLID	PrevReqAppliName;	/*  vAvP[ṼAvio  */
};

struct	APPLI_PROC_END_REQ	/* vZXIv */
{
	USHORT		MessageID;		/* AppliProcEndReqID */
	USHORT		OccuredTime;
	APLFILTER	AplFilter;		/*  IAv̎w  */
	APLID		AplName;		/*  w̃Avio  */
};

struct	APPLI_PROC_START_REQ	/* vZXNv */
{
	USHORT	MessageID;			/* AppliProcStartReqID */
	USHORT	OccuredTime;
	FCFNAME	AplHFName;
	BOOLEAN	IsStartAndExec;		/* vZXNƓEXEC邩H */
};

#ifndef H2EQU
struct	APPLI_EMBED_EVENT	/* vZXNv */
{
	USHORT		MessageID;		/* AppliEmbedEventID */
	USHORT		OccuredTime;	/*  */
	APLID		DestAplName;	/* ΏۃAv */
	APM_FACTOR_MSG	EventMsg;	/*  vbZ[W  */
};
#endif H2EQU

struct	APPLI_PROC_RESTART_REQ	/* vZXIv */
{
	USHORT		MessageID;		/* AppliProcRestartReqID */
	USHORT		OccuredTime;
	APLFILTER	AplFilter;		/*  IAv̎w  */
	APLID		AplName;		/*  w̃Avio  */
};

/****************************************/
/*	`olbZ[WɊւ萔	*/
/****************************************/


/*  Itv  */

/*  Itv (OffFactor)  */
#define	APPEND_APL_DEL		90	/*  ǉAvP[V̍폜  */

/*  AvNmFv  */
/*  hv  */

/*  N (StartCondition)  */
#define	APPLI_NORMAL_START	0x0000	/* ʏ̋N  */
#define	GS_ONE_SHOT_START	0x0004	/* ŠłONESHOT\ */
#define	RESUME_INFO_START	0x0010	/* ČŎ\N */
#define	NON_ACTIVE_START	0x0040	/* ANeBuԂN */

/*   (ExecCondition)  0x0000 - 0x00ff܂ł̓VXeŗ\ */
#define	APPLI_NORMAL_EXEC	0x0000	/* ʏ̓iNvɂj */
#define	APPLI_SERVICE_EXEC	0x0001	/* ZASsȂ */
/* ȉ͋NRESUME_INFO_START̏ꍇ̂ */
#define	GS_NOT_FOUND		0x0002	/* ŠňꌏȂ */
#define	GS_BREAK			0x0003	/* Š̓rŒ~ꂽ  */
/* ȉ͓GS_ONE_SHOT_START̏ꍇ̂ */
#define	GS_GLOBAL			0x0004	/* Š */
#define	GS_LOCAL			0x0005	/* [J */

#define	SYS_EXEC_MASK		0x00ff	/* VXe}XN */
#define	USER_EXEC_MASK		0xff00	/* [U}XN */


/*  ANeBu^ANeBuؑ֗v  */

/*  ANeBu^ANeBu (Activate)  */
#define	APPLI_ACTIVE		1	/* ANeBu */
#define	APPLI_NON_ACTIVE	0	/* ANeBu */


/*  O[oT[`v  */

/*   (SearchDirection)  */
#define	GS_FROM_TOP		0	/*  擪珇Ɍ  */
#define	GS_FROM_BTM		1	/*  ŌォtɌ  */
#define	GS_NEXT_SEARCH	2	/*  qr`̎f[^珇Ɍ  */
#define	GS_PREV_SEARCH	3	/*  qr`̎f[^tɌ  */


/*  CxgT[rXv  */
/*  Cxghv  */

	/*   (OccuredState)  */
#define	EVENT_CANCEL		0	/*  Cxgsv𒆎~  */
#define	EVENT_STATE_ON		1	/*  IɔCxg  */
#define	EVENT_STATE_OFF		2	/*  ItɔCxg  */

/*  O[oT[`Jnv  */

	/*  O[o^L[[hT[`w (GlobalSearch)  */
#define	GLOBAL_SEARCH		0	/* O[oT[`Jn */
#define	KEY_WORD_SEARCH		1	/* L[[hT[`Jn */
#define	NEXT_APL_SEARCH		2	/* O[oT[` */
#define	PREV_APL_SEARCH		3	/* O[oT[` */
#define	FINISH_SEARCH		4	/* I */
#define	BREAK_SEARCH		5	/* f */

/*  󋵕ὠ`B  */
typedef USHORT	UPDATEINFO;

/*  󋵕ω (UpdateInfo)  */
#define	UD_DATA				0x0001	/* f[^̍XV(폜) */
#define	UD_TIME				0x0002	/* ̕ύXA[Jss̕ύX */
#define	UD_LANG				0x0004	/* ̕ύX */
#define	UD_SECRET			0x0008	/* V[Nbgݒ̕ύX */
#define	UD_12H24H			0x0010	/* PQԁ^QSԐ̕ύX */
#define	UD_FILE				0x0020	/* t@Cx̃f[^XV */
#define	UD_DATA_ADDED		0x0040	/* f[^ǉ */

#define	UD_REAL_TIME		0x0100	/*  A[Jss̕ύXi⏕j  */

/* d[h */
#define	APL_POWER_ON		0x0001	/* dON */
#define	APL_POWER_OFF		0x0000	/* dOFF */

/****************************************/
/*	̑̂`olɊւ`	*/
/****************************************/

	/*  ̃x  */


typedef USHORT SYSINITLEVEL;

#define	APL_ALL_RESET		0	/*  I[Zbg  */
#define	APL_RESET1		1	/*  IԂ̃Zbg  */
#define	APL_RESET2		2	/*  ItԂ̃Zbg  */
#define	APL_ON			3	/*  It̃I  */
#define	APL_APON		4	/*  I[gp[It̃I  */


	/*  ̃Tux  */

#define	CARD_CHANGE_SUB		0x01	/*  J[hꂽ  */
#define	EVENT_START_SUB		0x02	/*  Cxgɂ闧オ  */
#define	APOFF_START_SUB		0x04	/*  `onee̗オ  */
#define	DATA_CHANGE_SUB		0x08	/*  obNAbvAobkhmj  */
#define	DATA_CLEAR_SUB		0x10	/*  NA  */
#define	CARD_CLEAR_SUB		0x20	/*  J[hNA  */

#define	HARD_RESET_SUB		0x40	/*  ZbgXCb`ɂ郊Zbg  */
#define	SYSTEM_ABORT_SUB	0x80	/*  VXeُ킪  */


/****************************************/
/*	`olɊւ`I		*/
/****************************************/
#endif
