/***********************************************************************
<t@C>	c_disp.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/****************************************************************
		\NX̒`
;*****************************************************************/

#ifndef _C_DISP_H_DEFINED
#define _C_DISP_H_DEFINED

#include "zdrawlib.h"

/********************************/
/*@}XNw			*/
/********************************/
typedef	struct	Mask	{
	short		MaskLeftX ;		/*@}XNWij	*/
	short		MaskUpperY ;		/*@}XNWij	*/
	USHORT		MaskSizeX ;		/*@}XNTCYij	*/
	USHORT		MaskSizeY ;		/*@}XNTCYij*/
} MASK ;

typedef struct MASKWORK {
	MASK MaskPos;
	short MCommonStr;
}MASKWORK;

typedef union COMMONWORK {
	MASKWORK MaskWork;
	short CommonStr;
}COMMONWORK;

typedef struct DISPOBJHEAD {
	WINDOWHD	WnHandle;
	UINT		ID;
} DISPOBJHEAD;

/* \tH[}b^ */
typedef struct DISPOBJ {
	DISPOBJHEAD	Header;
	COMMONWORK	CommonWork;
} DISPOBJ,*DISPOBJPTR,**DISPOBJHD;

/* c_disp.c ɂ֐ */
DISPOBJHD DispObjects();
DISPOBJHD MDspObjects();
DISPOBJHD DspLineObj();
DISPOBJHD MDspLineObj();
DISPOBJHD DspLineObjCommon();
DISPOBJHD DspStringObj();
DISPOBJHD MDspStringObj();
DISPOBJHD DspStringObjCommon();
DISPOBJHD DspImageObj();
DISPOBJHD MDspImageObj();
DISPOBJHD DspImageObjCommon();
DISPOBJHD DspString2Obj();
DISPOBJHD MDspString2Obj();
DISPOBJHD DspString3Obj();
DISPOBJHD MDspString3Obj();
DISPOBJHD DspString2ObjCommon();
USHORT GetPropFromRsrc();
HANDLE ConstructResData();
DISPOBJHD DspLinePropertyExec();
DISPOBJHD DspStringPropertyExec();
DISPOBJHD DspImagePropertyExec();
DISPOBJHD DspString2PropertyExec();
DISPOBJHD DspString3PropertyExec();
DISPOBJHD DspFrm1PropertyExec();
DISPOBJHD DspFrm2PropertyExec();
DISPOBJHD DspFrm3PropertyExec();
DISPOBJHD DspFrm4PropertyExec();
DISPOBJHD DspFrm5PropertyExec();
DISPOBJHD DspIconPropertyExec();

/* c_dips2.c ɂ֐ */
DISPOBJHD DspFrm1Obj();
DISPOBJHD MDspFrm1Obj();
DISPOBJHD DspFrm1ObjCommon();
DISPOBJHD DspFrm2Obj();
DISPOBJHD MDspFrm2Obj();
DISPOBJHD DspFrm2ObjCommon();
DISPOBJHD DspFrm3Obj();
DISPOBJHD MDspFrm3Obj();
DISPOBJHD DspFrm3ObjCommon();
DISPOBJHD DspFrm4Obj();
DISPOBJHD MDspFrm4Obj();
DISPOBJHD DspFrm4ObjCommon();
DISPOBJHD DspFrm5Obj();
DISPOBJHD MDspFrm5Obj();
DISPOBJHD DspFrm5ObjCommon();
DISPOBJHD DspIconObj();
DISPOBJHD MDspIconObj();
DISPOBJHD DspIconObjCommon();

DISPOBJHD DspCFrmObj();
DISPOBJHD MDspCFrmObj();
DISPOBJHD DspCFrmPropertyExec();

/***********************************************************************
  Pdlpg
***********************************************************************/
/* { */
typedef struct FRM1_STR {
	short LeftX;
	short UpperY;
	USHORT SizeX;
	USHORT SizeY;
	UCHAR Mode;
	UCHAR LinePattern;
	COLOR FGColor;
	COLOR BGColor;
} FRM1_STR;

/* ʏ */
typedef struct DSP_FRM1 {
	UINT		ID;
	FRM1_STR	Frm1;
} DSP_FRM1;

/* }XN */
typedef struct MDSP_FRM1 {
	UINT		ID;
	MASK		MaskPos;
	FRM1_STR	Frm1;
} MDSP_FRM1;

/***********************************************************************
  Pdlpge
***********************************************************************/
/* { */
typedef struct FRM2_STR {
	short LeftX;
	short UpperY;
	USHORT SizeX;
	USHORT SizeY;
	UCHAR Mode;
	UCHAR ShadowSize;
	COLOR FGColor;
	COLOR BGColor;
	COLOR ShadowColor;
} FRM2_STR;

/* ʏ */
typedef struct DSP_FRM2 {
	UINT		ID;
	FRM2_STR	Frm2;
} DSP_FRM2;

/* }XN */
typedef struct MDSP_FRM2 {
	UINT		ID;
	MASK		MaskPos;
	FRM2_STR	Frm2;
} MDSP_FRM2;

/***********************************************************************
  Pdpێlpg
***********************************************************************/
/* { */
typedef struct FRM3_STR {
	short LeftX;
	short UpperY;
	USHORT SizeX;
	USHORT SizeY;
	UCHAR Mode;
	COLOR FGColor;
	COLOR BGColor;
} FRM3_STR;
 
/* ʏ */
typedef struct DSP_FRM3 {
	UINT		ID;
	FRM3_STR	Frm3;
} DSP_FRM3;

/* }XN */
typedef struct MDSP_FRM3 {
	UINT		ID;
	MASK		MaskPos;
	FRM3_STR	Frm3;
} MDSP_FRM3;

/***********************************************************************
  Qdpێlpg
***********************************************************************/
/* { */
typedef struct FRM4_STR {
	short LeftX;
	short UpperY;
	USHORT SizeX;
	USHORT SizeY;
	UCHAR Mode;
	COLOR FGColor;
	COLOR BGColor;
} FRM4_STR;

/* ʏ */
typedef struct DSP_FRM4 {
	UINT		ID;
	FRM4_STR	Frm4;
} DSP_FRM4;

/* }XN */
typedef struct MDSP_FRM4 {
	UINT		ID;
	MASK		MaskPos;
	FRM4_STR	Frm4;
} MDSP_FRM4;

/***********************************************************************
  g
***********************************************************************/
/* { */
typedef struct FRM5_STR {
	short LeftX;
	short UpperY;
	USHORT SizeX;
	USHORT SizeY;
	UCHAR Mode;
	UCHAR ShadowSize;
	UCHAR PageNo;
	COLOR FGColor;
	COLOR BGColor;
	COLOR ShadowColor;
} FRM5_STR;

/* ʏ */
typedef struct DSP_FRM5 {
	UINT		ID;
	FRM5_STR	Frm5;
} DSP_FRM5;

/* }XN */
typedef struct MDSP_FRM5 {
	UINT		ID;
	MASK		MaskPos;
	FRM5_STR	Frm5;
} MDSP_FRM5;

/***********************************************************************
  
***********************************************************************/
/* { */
typedef struct LINE_STR {
	short StartX;
	short StartY;
	short EndX;
	short EndY;
	UCHAR Mode;
	UCHAR LinePattern;
	UCHAR PointType;
	UCHAR PointSize;
	COLOR FGColor;
	COLOR BGColor;
} LINE_STR;

/* ʏ */
typedef struct DSP_LINE {
	UINT		ID;
	LINE_STR	Line;
} DSP_LINE;

/* }XN */
typedef struct MDSP_LINE {
	UINT		ID;
	MASK		MaskPos;
	LINE_STR	Line;
} MDSP_LINE;

/***********************************************************************
  (obt@^Cv)
***********************************************************************/
/* { */
typedef struct STRING_STR {
	short LeftX;
	short UpperY;
	USHORT SizeX;
	USHORT SizeY;
	UCHAR Mode;
	char CharPitch;
	char LinePitch;
	COLOR FGColor;
	COLOR BGColor;
	USHORT StrLength;
	UCHAR Str[1];
} STRING_STR;

/* ʏ */
typedef struct DSP_STRING {
	UINT		ID;
	STRING_STR	String;
} DSP_STRING;

/* }XN */
typedef struct MDSP_STRING {
	UINT		ID;
	MASK		MaskPos;
	STRING_STR	String;
} MDSP_STRING;

/***********************************************************************
  ACR
***********************************************************************/
/* { */
typedef struct ICON_STR {
	short LeftX;
	short UpperY;
	UCHAR Mode;
	UCHAR IconType;
	USHORT ResourceID;
	UCHAR ResourceName[9];
} ICON_STR;

/* ʏ */
typedef struct DSP_ICON {
	UINT		ID;
	ICON_STR	Icon;
} DSP_ICON;

/* }XN */
typedef struct MDSP_ICON {
	UINT		ID;
	MASK		MaskPos;
	ICON_STR	Icon;
} MDSP_ICON;

/***********************************************************************
  C[W
***********************************************************************/
/* { */
typedef struct IMAGE_STR {
	short LeftX;
	short UpperY;
	UCHAR Mode;
	USHORT ResourceID;
	UCHAR ResourceName[9];
} IMAGE_STR;

/* ʏ */
typedef struct DSP_IMAGE {
	UINT		ID;
	IMAGE_STR	Image;
} DSP_IMAGE;

/* }XN */
typedef struct MDSP_IMAGE {
	UINT		ID;
	MASK		MaskPos;
	IMAGE_STR	Image;
} MDSP_IMAGE;

/***********************************************************************
  (\[X)
***********************************************************************/
/* { */
typedef struct STRING2_STR {
	short LeftX;
	short UpperY;
	USHORT SizeX;
	USHORT SizeY;
	UCHAR Mode;
	char CharPitch;
	char LinePitch;
	USHORT ResourceID;
	UCHAR ResourceName[9];
	COLOR FGColor;
	COLOR BGColor;
} STRING2_STR;

/* ʏ */
typedef struct DSP_STRING2 {
	UINT		ID;
	STRING2_STR	String;
} DSP_STRING2;

/* }XN */
typedef struct MDSP_STRING2 {
	UINT		ID;
	MASK		MaskPos;
	STRING2_STR	String;
} MDSP_STRING2;

/***********************************************************************
  (|C^)
***********************************************************************/
/* { */
typedef struct STRING3_STR {
	short	LeftX;
	short	UpperY;
	USHORT	SizeX;
	USHORT	SizeY;
	UCHAR	Mode;
	char	CharPitch;
	char	LinePitch;
	COLOR	FGColor;
	COLOR	BGColor;
	USHORT	StrLength;
	UCHAR	*Str;
} STRING3_STR;

/* ʏ */
typedef struct DSP_STRING3 {
	UINT		ID;
	STRING3_STR	String;
} DSP_STRING3;

/* }XN */
typedef struct MDSP_STRING3 {
	UINT		ID;
	MASK		MaskPos;
	STRING3_STR	String;
} MDSP_STRING3;

/***********************************************************************
  tlpg
***********************************************************************/
/* { */
typedef struct CFRM_STR {
	short		LeftX;
	short		UpperY;
	USHORT		SizeX;
	USHORT		SizeY;
	GCTABLE		GCTable;
	GCTABLESET	GCTableSet;
	DOTSIZE		DotSize;
	DF_MODE		DFMode;
} CFRM_STR;

/* ʏ */
typedef struct DSP_CFRM {
	UINT		ID;
	CFRM_STR	ColorFrm;
} DSP_CFRM;

/* }XN */
typedef struct MDSP_CFRM {
	UINT		ID;
	MASK		MaskPos;
	CFRM_STR	ColorFrm;
} MDSP_CFRM;

/***********************************************************************
  hԂlpg
***********************************************************************/

typedef struct DSP_PFRM {
	UCHAR	WindowHd;
	BOOLEAN	Visible;
	short	LeftX;
	short	TopY;
	short	RightX;
	short	BottomY;
	MASK	MaskPos;
	UCHAR	Mode;
	COLOR FGColor;
	COLOR BGColor;
	PAINTPAT	Pattern;
} DSP_PFRM,*DSPPFRMPTR,**DSPPFRMHD;

DSPPFRMHD DspPFrmObj(USHORT DummyArg,MESSAGE *Message,DSPPFRMHD DspPFrmHd);
DSPPFRMHD MDspPFrmObj(USHORT DummyArg,MESSAGE *Message,DSPPFRMHD DspPFrmHd);
DSPPFRMHD DspPFrmConstructRes(MESSAGE *Message);
DSPPFRMHD DspPFrmConstructPtr(MESSAGE *Message);
void DspPFrmSetProperty(MESSAGE *Message,DSPPFRMHD DspPFrmHd);
void DspPFrmGetProperty(MESSAGE *Message,DSPPFRMHD DspPFrmHd);

/***********************************************************************
  
***********************************************************************/

typedef struct DSP_CLINE {
	UCHAR	WindowHd;
	BOOLEAN	Visible;
	MASK	MaskPos;
	short	LeftX;
	short	TopY;
	short	RightX;
	short	BottomY;
	GCTABLE		GCTable;
	GCTABLESET	GCTableSet;
} DSP_CLINE,*DSPCLINEPTR,**DSPCLINEHD;

DSPCLINEHD DspCLineObj(USHORT DummyArg,MESSAGE *Message,DSPCLINEHD DspCLineHd);
DSPCLINEHD MDspCLineObj(USHORT DummyArg,MESSAGE *Message,DSPCLINEHD DspCLineHd);
DSPCLINEHD DspCLineConstructRes(MESSAGE *Message);
DSPCLINEHD DspCLineConstructPtr(MESSAGE *Message);
void DspCLineSetProperty(MESSAGE *Message,DSPCLINEHD DspCLineHd);
void DspCLineGetProperty(MESSAGE *Message,DSPCLINEHD DspCLineHd);
void DspCLineRedisp(DSPCLINEHD DspCLineHd,BOOLEAN Mask);

/*@etH[}b^̂hc	*/
#define FDISP_FRAME_ID			1
#define FDISP_SHADOW_FRAME_ID	2
#define FDISP_ROUND_FRAME_ID	3
#define FDISP_D_ROUND_FRAME_ID	4
#define FDISP_MEMO_FRAME_ID		5
#define FDISP_LINE_ID			6
#define FDISP_CHAR_ID			7
#define FDISP_ICON_ID			8
#define FDISP_IMAGE_ID			9
#define FDISP_CHAR_RES_ID		10
#define FDISP_TITLE_BAR_ID		11
#define	FDISP_CHAR_PTR_ID		12
#define	FDISP_COLOR_FRAME_ID	13

#define FDISPM_FRAME_ID			101
#define FDISPM_SHADOW_FRAME_ID	102
#define FDISPM_ROUND_FRAME_ID	103
#define FDISPM_D_ROUND_FRAME_ID	104
#define FDISPM_MEMO_FRAME_ID	105
#define FDISPM_LINE_ID			106
#define FDISPM_CHAR_ID			107
#define FDISPM_ICON_ID			108
#define FDISPM_IMAGE_ID			109
#define FDISPM_CHAR_RES_ID		110
#define FDISPM_TITLE_BAR_ID		111
#define	FDISPM_CHAR_PTR_ID		112
#define	FDISPM_COLOR_FRAME_ID	113

/* VISIBLE Ή
   NX̃xIDMSBĂƕ\Ȃ悤ɂ */
#define	FDISP_VISIBLE_FLAG		(ULONG)0x80

#endif
