/***********************************************************************
<t@C>	dspclib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		\^R[hc[Cu`
***********************************************************************/
#ifndef _DSPC_LIB_H_INCLUDED
#define	_DSPC_LIB_H_INCLUDED

#include <sharpgen.h>

#ifdef	ESRL

UCHAR	JisSjisConv();
UCHAR	SjisJisConv();
UCHAR	Is2byte();
UCHAR	IsZenkaku();
UCHAR	Is2byteDakuon();
UCHAR	IsZenkakuDakuon();
UCHAR	KomojiCheck();
UCHAR	DakutenHenkan();
void	CharPosition();
short	StringCentering();
UCHAR	IsDataKey();
UCHAR	HankakuConv();
UCHAR	HankakuConvLimit();
UCHAR	ZenkakuConv();
UCHAR	ZenkakuConvLimit();
UCHAR	HiraKataStrConv();
UCHAR	HiraKataStrConvLimit();
UCHAR	ZenHanStrConv();
UCHAR	ZenHanStrConvLimit();
void	CharSize();
USHORT	GetWidth();
void	GetLengthFromWidth();
USHORT	GetMojisuu();
USHORT	GetLengthFromMojisuu();
USHORT	GetColumn();
USHORT	GetLengthFromColumn();
void	IconCentering();
UCHAR	StrSjisChk();

#else

UCHAR	JisSjisConv(USHORT, USHORT *);
UCHAR	SjisJisConv(USHORT, USHORT *);
UCHAR	Is2byte(USHORT);
UCHAR	IsZenkaku(USHORT);
UCHAR	Is2byteDakuon(USHORT);
UCHAR	IsZenkakuDakuon(USHORT);
UCHAR	KomojiCheck(USHORT);
UCHAR	DakutenHenkan(USHORT, USHORT *, UCHAR);
void	CharPosition(short, short, USHORT, USHORT, UCHAR, UCHAR, POINT *);
short	StringCentering(USHORT, USHORT);
UCHAR	IsDataKey(USHORT);
UCHAR	HankakuConv(USHORT, USHORT *);
UCHAR	HankakuConvLimit(USHORT, USHORT *);
UCHAR	ZenkakuConv(UCHAR, USHORT *);
UCHAR	ZenkakuConvLimit(UCHAR, USHORT *);
UCHAR	HiraKataStrConv(UCHAR *, UCHAR *, USHORT);
UCHAR	HiraKataStrConvLimit(UCHAR *, UCHAR *, USHORT);
UCHAR	ZenHanStrConv(UCHAR *, UCHAR *, USHORT);
UCHAR	ZenHanStrConvLimit(UCHAR *, UCHAR *, USHORT);
void	CharSize(UCHAR, USHORT *, USHORT *);
USHORT	GetWidth(UCHAR *, USHORT, USHORT);
void	GetLengthFromWidth(UCHAR *, USHORT, USHORT, USHORT, USHORT *, USHORT *);
USHORT	GetMojisuu(UCHAR *, USHORT);
USHORT	GetLengthFromMojisuu(UCHAR *, USHORT, USHORT, USHORT *);
USHORT	GetColumn(UCHAR *, USHORT);
USHORT	GetLengthFromColumn(UCHAR *, USHORT, USHORT, USHORT *, USHORT *);
void	IconCentering(USHORT, USHORT, USHORT, USHORT, POINT *);
UCHAR	StrSjisChk(UCHAR *, USHORT);
UCHAR	KataConvLimit(USHORT, USHORT *);
UCHAR	HiraConvLimit(USHORT, USHORT *);
USHORT	GetLengthFromBytes(UCHAR *, USHORT, USHORT);

#endif

#endif
