/*
		      ANSI C Runtime Library

	    Copyright 1983-1995 Green Hills Software, Inc.

    This program is the property of Green Hills Software, Inc,
    its contents are proprietary information and no part of it
    is to be disclosed to anyone except employees of Green Hills
    Software, Inc., or as agreed in writing signed by the President
    of Green Hills Software, Inc.
*/

/* [edlee] Tue Oct 11 18:34:51 PDT 1994.  Force errno reference to be in .data.
 * This is because we now have sda and zda for some targets, and we don't know
 * which data section errno is in the library.
 */
#pragma ghs startdata
extern int errno;
#pragma ghs enddata

#define EPERM   1
#define ENOENT  2
#define ESRCH   3
#define EINTR   4
#define EIO     5
#define ENXIO   6
#define E2BIG   7
#define ENOEXEC 8
#define EBADF   9
#define ECHILD  10
#define EAGAIN  11
#define ENOMEM  12
#define EACCES  13
#define EFAULT  14
#ifndef _POSIX_SOURCE
#define ENOTBLK 15
#endif
#define EBUSY   16
#define EEXIST  17
#define EXDEV   18
#define ENODEV  19
#define ENOTDIR 20
#define EISDIR  21
#define EINVAL  22
#define ENFILE  23
#define EMFILE  24
#define ENOTTY  25
#ifndef _POSIX_SOURCE
#define ETXTBSY 26
#endif
#define EFBIG   27
#define ENOSPC  28
#define ESPIPE  29
#define EROFS   30
#define EMLINK  31
#define EPIPE   32
#define EDOM    33	/* also #define'd in math.h */
#define ERANGE  34	/* also #define'd in math.h */
#ifndef _POSIX_SOURCE
#define ELOCAL  35
#endif
/* POSIX requires the following, but no one agress on the values */
#ifdef __sun
#define ENAMETOOLONG	63
#define ENOTEMPTY	66
#define EDEADLK	78
#define ENOLCK	79
#define ENOSYS	90
#else	/* sysV.3 */
#define EDEADLK	45
#define ENOLCK	46
#define ENAMETOOLONG	78
#define ENOSYS	89
#define ENOTEMPTY	158
#endif
