/***********************************************************************
***********************************************************************/
#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef _MAILFNCH_
#define _MAILFNCH_

#include <comdvlib.h>
/* #include <pcommlib.h>*/
#include <bcommlib.h>
#include <modemlib.h>
/* #include <fusion.h> */
#include "pimmgr.h"
#include "mail_res.h"
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
/*	Script	Style	*/
#define SCRIPT_NIF_STYLE
/*	WaitTime after script	*/
#define	WAITTIME_SCRIPT	0

/*	NiftyM & MIME ErrortO	*/
#define MAILFLAG ULONG
#define	MIME_NIFTY_BIT	0x00000001
#define	MIME_INET_BIT	0x00000000
#define MIME_SEND_ERR	0x00000010
#define MIME_RECV_ERR	0x00000020
#define	MIME_USASCII	0x00000040
/* T[oُ */
#define SVR_CRAZED_BIT	0x00000040

#define NifFlag(mailflag)	(mailflag & MIME_NIFTY_BIT) /* No.7256 */
/* 1997/04/11 Otake for us-ascii */
#define	IsUsAscii(mailflag)	(mailflag & MIME_USASCII)
#define NIF_INIT	MIME_NIFTY_BIT
#define INET_INIT	MIME_INET_BIT

/* for PPP-Abort */
#define CARRIER_LOST		1	/* Modem disconnected */
#define PPP_TERMINATED		2	/* PPP terminated by remote node */
#define	PPP_CORRUPTED		3	/* PPP connection corrupted */
#define UNKNOWN_REASON		4	/* ? */

/*	Dialing Error	*/
#define	DERR_MDM	1
#define DERR_BUSY	2
#define DERR_NOCON	3
#define DERR_SCR	4
#define	DERR_TOPPP	5
#define	DERR_CONCT  6
#define	DERR_LOGIN  7
#define	DERR_MEM  	8

#define DERR_ABORT 9    /* (fL[)		*/
#define DERR_INNER 10   /* (G[)				*/
#define DERR_CONF  11   /* (ݒl)					*/
#define DERR_PAP   12   /* (o`oF)				*/
#define DERR_PPP   13   /* (oooڑ)				*/
#define DERR_LINE  14   /* (VAC)			*/
#define DERR_SVR   15   /* (T[o̐ؒfv)	*/
#define DERR_OFF   16   /* (dre/OFF)		*/

#define PPP_ABORTMASK		(ABORT_BATT_COVER_OPEN|ABORT_FATAL_LOW_BATT|ABORT_BREAK|ABORT_PCCARD0_ALL)
/* Abortv(؃L[,AutoPowerOFFȂǂ͌Ȃ) */
/* bit 5: drWJ */
/* bit 6: drcʂȂ */
/* bit 7:ufvL[ꂽ*/
/* PC-Card Socket#0 Sv */

/*--- PPP ---*/
#ifndef NOEVENT
#define NOEVENT			-1
#endif

#define COMPLETE		1
#define QTIMEOUT		(-2)
#define STATUS_BUSY		(-3)

#define MSGSV			-1
#define SUCCESS			0
#define	PPP_OPEN	1
#define	PPP_CLOSE	2
#define PPP_DOWN	3	
#define PPP_CLEANUP	4	

#ifndef NOERR
#define NOERR 0
#endif

#ifndef ERR
#define ERR -1
#endif
#define MEMERR			-2
#define RECVZERO		-3

/*	Pop3 O[oƂ߂΍	*/
#define POP3LINEBUF			Pop3InitBuf
#define POP3LINEBUFSIZE		MAX_LINE+4
#define POP3XMITBUF			Pop3InitBuf + POP3LINEBUFSIZE
#define POP3XMITBUFSIZE		MAX_CMD_LINE+4
#define POP3RESPSIZE		512
#define POP3RESP			Pop3InitBuf + POP3LINEBUFSIZE + POP3XMITBUFSIZE
#define POP3BUFSIZE			POP3LINEBUFSIZE + POP3XMITBUFSIZE + 512

#define	SMTPLINEBUF		SmtpInitBuf
#define	SMTPLINEBUFSIZE	MAX_LINE+4
#define	SMTPXMITBUF		SmtpInitBuf + SMTPLINEBUFSIZE
#define	SMTPXMITBUFSIZE	MAX_LINE * 2
#define	SMTPRESP		SMTPXMITBUF + SMTPXMITBUFSIZE
#define	SMTPRESPSIZE	512
#define SMTPBUFSIZE		SMTPLINEBUFSIZE+SMTPXMITBUFSIZE+SMTPRESPSIZE


/*	Mail Buffers	*/
#define MAIL_MAX_RECV	200
#define MAIL_RECV_BUF	MAIL_MAX_RECV*1024
/*	őM 92Kbytes 1996/07/03 90->94	*/
#define MAIL_SEND_BUF	196*1024	/*	ő呗M 90Kbytes	*/
#define	DELIV_MAX		64		/*	zBؖłől	*/
#define	MAX_MAIL_LIST	100		/*  Mꗗ̍ő	*/

#define	MAX_MAIL_BUF	65536
#define	MAX_PART_BUF	128*1024
#define	MAX_PART_ENC	184*1024
#define	MAX_BUF_K	1024
#define MAX_MIMETBL 100
#define	MAX_BUF_2		256
#define	MAX_ATTACH_NO 32
#define MAX_SCRIPT_LINE	64


/*	\[X	*/
#define ZMStrComErrID		40000
#define ZMStrAllSendID		40001
#define ZMStrModemInitID	40002
#define ZMStrNowDialID		40003
#define ZMStrNowConnectID	40004
#define ZMStrNowSendID		40005
#define ZMStrNowReceiveID	40006
#define ZMStrSentID			40007
#define ZMStrRecvID			40008
#define ZMStrNowDiscoID		40009
#define	ZMStrDerrMdmID		40010
#define	ZMStrDerrBusyID		40011
#define	ZMStrDerrNocID		40012
#define	ZMStrDerrScrID		40013
#define	ZMStrDerrTopppID	40014
#define	ZMStrDerrConnectID	40015
#define	ZMStrDerrLoginID	40016
#define	ZMStrIsRecvID		40017
#define	ZMStrIsSelectID		40018
#define	ZMStrRecvZeroID		40019
#define	ZMStrNoMemID		40020
#define	ZMStrIsDisConID		40021
/* 1996/06/25 */
#define ZMStrIntRptID		40022
#define ZMStrConfErrID		40023
#define ZMStrSvrErrID		40024
/* 1996/07/06 */
#define ZMStrMimeSErrID		40025
#define ZMStrMimeRErrID		40026
/* 1996/07/16 for Attach Error */
#define ZMStrAtSizeID		40027
#define ZMStrAtNumID		40028
#define ZMStrAtMaxID		40029

/*	BoxFile ڔԍ	*/
/*	SENDMAIL.BOX	*/
#define	SendBox_MLTO	1	/*	To:	*/
#define	SendBox_SBJT	2	/*	Subject:	*/
#define	SendBox_MEM1	3	/*	TextPart	*/
#define	SendBox_RCCK	4	/*	Check of sent	*/
#define	SendBox_MLID	5	/*	Mail ID	*/
#define	SendBox_ECTD	6	/*	Attach Data	*/
#define	SendBox_MLCC	7	/*	Cc:	*/
#define	SendBox_MLBC	8	/*	Bcc:	*/
#define	SendBox_PRBD	9	/*	Send Path (probider)	*/
#define	SendBox_MMFG	10	/*	MIME Switch	*/
#define	SendBox_EDTM	11	/*	Edit Time	*/
#define	SendBox_SDTM	12	/*	Sent Time	*/
#define	SendBox_NAME	13	/*	Full-name	*/

/*	Item Number	*/
#define	SEND_ITEM_MLTO	4
#define	SEND_ITEM_SBJT	5
#define	SEND_ITEM_MEM1	6
#define	SEND_ITEM_RCCK	7
#define	SEND_ITEM_MLID	8
#define	SEND_ITEM_ECDT	9
#define	SEND_ITEM_MLCC	10
#define	SEND_ITEM_MLBC	11
#define	SEND_ITEM_PRBD	12
#define	SEND_ITEM_MMFG	13
#define	SEND_ITEM_EDTM	14
#define	SEND_ITEM_STTM	15
#define	SEND_ITEM_NAME	SEND_ITEM_MLTO	
#define	SEND_ITEM_ADRS	SEND_ITEM_MLTO

#define	RECV_ITEM_MLTO	4
#define	RECV_ITEM_MLFM	5
#define	RECV_ITEM_SBJT	6
#define	RECV_ITEM_RVTM	7
#define	RECV_ITEM_MEM1	8
#define	RECV_ITEM_RDCK	9
#define	RECV_ITEM_MLID	10
#define	RECV_ITEM_ECDT	11
#define	RECV_ITEM_MLCC	12
#define	RECV_ITEM_MLRP	13
#define	RECV_ITEM_SDDT	14

/*	zBؖ\	v 1Kbyte ɂĂ	*/
typedef struct DELIVSTR{
	char	To[256];
	char	Body[768];
	char	Flag;
} DELIVSTR;

#ifndef SCRIPT_NIF_STYLE
typedef struct se_sequence
{
    UCHAR send[80];
    UCHAR expect[14];
    UCHAR timeout;
    UCHAR trys;
} SE_SEQUENCE;
#else
typedef struct se_sequence
{
    UCHAR *send;
    UCHAR *expect;
    UCHAR timeout;
    UCHAR trys;
} SE_SEQUENCE;
#endif

typedef	struct	PPPConfigType{	
		COMMDEVNAME		name;
		COMMDEV			*pDev;
/*		PCOM			*pPCom;*/
		BCOM			*pBCom;

		MDM				*MDMStr;		/* MDM\̂ւ̃|C^	*/

		UINT			ModemDriver;
		int				dataLength;
		int				stopBit;
		int				parity;
/* 		int				baudrate; */

		ULONG				UARTSpeed;
		MDMCONNECTSPD_E		ConnectSpeed;
		MDMDETECTDIALTONE_E	DialTone;
		MDMDIALTYPE_E		DialType;
		MDMSPKCTRL_E		SpkSwitch;
		MDMSPKVOL_E			SpkVol;
		MDMDSRMODE_E		DSR;
		MDMDTEFLOWCTRL_E	DTEFlow;
		MDMMODEMFLOWCTRL_E	MDMFlow;
		MDMCOMPRESSMODE_E	MNP;
		MDMECCMODE_E		ErrCorrect;

		UCHAR				*UserInitStr;	/* [U`	*/

		char		TellNumber[MDM_TEL_NUM_MAX];
		char		UserID[SIZE_OF_CONID];
		char		PassWord[SIZE_OF_PSWD];
		int			IsCryptPass;
#ifdef SCRIPT_NIF_STYLE
		char		*LoginScript;
#else
		SE_SEQUENCE	*LoginScript;	/*	Tsugi-style script	*/
#endif

		UCHAR				ErrorCode;			/*	G[R[h for ZPPP	*/
		
	}PPPConfigType;
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif /* _MAILFNCH_ */
