/****************************************************************
 <pdbapi.h>
							V[v
							Sharp Corporation

		p[\if[^x[XAPI`

		1998/04/14	created
*****************************************************************/
#ifndef	_PDBAPI_H_INCLUDED
#include <sharpgen.h>
#include <dtmlib.h>

/*======================================================================
  		f[^x[XtH[`
======================================================================*/
#define	PDB_ITEM_NAME_LEN	20		/*	ږ̒			*/
#define	PDB_ITEM_MAX		25		/*	Pf[^̍ő區ڐ	*/

/*	ڂ̃^Cv̒`	*/
#define	PDBITYPE_FREE		(0)		/* t[ */
#define	PDBITYPE_YOMI		(1)		/* ǂ */
#define	PDBITYPE_DIGIT		(2)		/* l	*/
#define	PDBITYPE_ALPHABET	(3)		/* p */
#define	PDBITYPE_PICT		(4)		/* ʐ^ */
#define	PDBITYPE_DATE		(5)		/* t	*/
#define	PDBITYPE_OWNER		(6)		/* Lҏ */

/*	t̃Tu	*/
#define	PDBSTYPE_YMD		(0)		/* t(N)	*/
#define	PDBSTYPE_YM			(1)		/* t() */
#define	PDBSTYPE_YMDHS		(2)		/* t(N)	*/
#define	PDBSTYPE_HMS		(3)		/* (b) */
#define	PDBSTYPE_HM			(4)		/* () */

/*	l̃Tu	*/
#define	PDBSTYPE_NO_COMMA	(0)		/* l(R})	*/
#define	PDBSTYPE_COMMA		(1)		/* l(R}L)	*/

/*	Lҏ̃Tu	*/
#define	PDBSTYPE_NAME		(0)		/*	l		        */
#define	PDBSTYPE_OFCE_TEL	(1)		/*	Гdbԍ		*/   
#define	PDBSTYPE_OFCE_FAX	(2)		/*	FAXԍ			*/
#define	PDBSTYPE_HOME_TEL	(3)		/*	dbԍ		*/
#define	PDBSTYPE_HOME_FAX	(4)		/*	FAXԍ			*/
#define	PDBSTYPE_MOVE_TEL	(5)		/*	gѓdbԍ		*/
#define	PDBSTYPE_BELL		(6)		/*	|Pxԍ		*/
#define	PDBSTYPE_EMAIL		(7)		/*	[AhX		*/
#define	PDBSTYPE_OFFICE		(8)		/*	Ж				*/
#define	PDBSTYPE_SECTION	(9)		/*					*/
#define	PDBSTYPE_POST		(10)	/*	E				*/
#define	PDBSTYPE_OFCE_ZIP	(11)	/*	ЗX֔ԍ		*/
#define	PDBSTYPE_OFCE_ADR	(12)	/*	ЏZ			*/
#define	PDBSTYPE_HOME_ZIP	(13)	/*	X֔ԍ		*/
#define	PDBSTYPE_HOME_ADR	(14)	/*	Z			*/
#define	PDBSTYPE_BIRTHDAY	(15)	/*	a				*/
#define	PDBSTYPE_NOTE		(16)	/*	l				*/

/*	ڂ̑	*/
typedef	struct	{
	UCHAR			ItemName[PDB_ITEM_NAME_LEN+1];	/*	ږ			*/
	UCHAR			ItemID;							/*	ڂhc		*/
	UCHAR			ItemType;						/*	ڑ		*/
	UCHAR			SubItemType;					/*	Tuڑ	*/
} PDBITEM;

/*	BOXt@C̍ڏ		*/
typedef	struct	{
	UCHAR			Version;				/*	t@Co[W	*/
	UCHAR			Reserved;				/*  gp              */
	USHORT			ItemCount;				/*	ڐ				*/
	PDBITEM			Item[PDB_ITEM_MAX];	/*	ڏ			*/
} PDBBOXITEMINFO;

/*======================================================================
  		PDB AccessCX^X`
======================================================================*/
typedef struct PDBACCESS {
	BOXHANDLE	dataBoxHdl;			/* BOXt@Cnh */
	USHORT		formId;
	INDEXNO		startIdxNo;
	INDEXNO		endIdxNo;
	DTMFNAME	dataBoxName;
	DTMFNAME	dataIdxName;
	PDBBOXITEMINFO	formInfo;
	UCHAR		volumeNo;			/* 1: main,2: card */
} PDBACCESS;

/*======================================================================
  		֐`
======================================================================*/
PDBACCESS*
PdbNew(const STRING dbFName,UCHAR volumeNo);
void
PdbDispose(PDBACCESS *pdbAcs);
DTMERR
PdbReadCardItem(PDBACCESS *pdbAcs,
				const STRING dbItemName,UCHAR itemType,
				CARDID cardId,void *buf,DATALEN *len);
BOOLEAN
PdbNextPrevCard(PDBACCESS *pdbAcs,CARDID *cardId,BOOLEAN isNext);
void
PdbUpdateInfo(PDBACCESS *pdbAcs);

#define	_PDBAPI_H_INCLUDED
#endif	/* _PDBAPI_H_INCLUDED */
