/***********************************************************************
<t@C>	pio.h

	Copyright (c) 1995-1999 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-EX1
***********************************************************************/
#include <zcppcmn.h>        /* C++ support  99/9/8 */
#ifndef	_PIO_H_INCLUDED

#include <sharpgen.h>
#include <dtmlib.h>
#include <zdam.h>
#include <file.h>
#include <lcdzdm.h>
#include <pioinfo.h>
//#include <su_afile.h>
BEGIN_NAMESPACE_ZAURUS      /* C++ support  99/9/8 */
/*======================================================================
		{^`
======================================================================*/
#ifndef DTMFNAMEL
typedef UCHAR DTMFNAMEL[LONG_DFNAME_LEN];
#endif

/*======================================================================
		CfbNXe[u̐
======================================================================*/
#define	MAX_IDX_NUM			6

/*======================================================================
		gp\[g̍ő咷
======================================================================*/
#define	MAX_SORT_EXP_LEN	50

/*======================================================================
		PIOG[R[h
======================================================================*/
typedef enum PIOERR {
	PIO_NO_ERR = 0,
	PIO_DTM_ERR,			/* DTMG[Ԃ */
	PIO_HEAP_ERR,			/* q[vȂ */
	PIO_ALREADY_EDITING,	/* ҏWȂ̂ŎsłȂ */
	PIO_NOT_EDITING,		/* ҏWłȂΎsłȂ */
	PIO_IDX_TBL_ERR,		/* CfbNXe[uȂ */
	PIO_FILENAME_FULL,		/* Vȃt@C蓖ĂȂ */
	PIO_NO_ITEM,			/* ڂȂ */
	PIO_NO_GEO_INFO,		/* ʒu񂪂Ȃ */
	PIO_NO_ICON,			/* ACRȂ */
	PIO_DATA_EMPTY,			/* f[^ł */
	PIO_NOT_SUPPORTED,		/* T|[gĂȂ */
	PIO_FATAL_ERR,			/* ̑vIȃG[ */
	PIO_DATA_ERR,			/* f[^ُ */
	PIO_BREAK				/* fꂽ */
} PIOERR;

/*======================================================================
		PIO폜[h
======================================================================*/
typedef enum PIODELMODE {
	PIODM_ONE_CARD = 1,		/* Pf[^폜 */
	PIODM_CURRENT_INDEX,	/* ݂̃CfbNXɉč폜 */
	PIODM_ALL_CARD			/* SẴJ[h폜 */
} PIODELMODE;

/*======================================================================
		PIOACR^Cv
======================================================================*/
typedef enum PIOICONTYPE {
	PIOIC_DEFAULT = 0,		/* ʏ̃ACR */
	PIOIC_LANDMARK			/* n}ɕ\ACR */
} PIOICONTYPE;

/*======================================================================
		PIOf[^x[X쐬pf[^QƏ
======================================================================*/
typedef UCHAR	PIODBREFTYPE;

#define	PIODBREFTYPE_BUF		1
#define	PIODBREFTYPE_RESOURCE	2

typedef struct PIODBREF {
	PIODBREFTYPE	type;
	union PIODBREFINF {
		RESOURCE	resource;
		void		*buf;
	} info;
} PIODBREF;

/*======================================================================
		PIOf[^x[X\[g
======================================================================*/
typedef	enum PIODBSORT {
	PIODBS_NOT_SORT = 0,	/* \[gĂȂ */
	PIODBS_BOXFILE,			/* BOXt@C */
	PIODBS_DATE,			/* DB쐬 */
	PIODBS_DBNAME,			/* f[^x[X */
	PIODBS_DBCODE			/* f[^x[Xʖ */
} PIODBSORT;

/*======================================================================
		PIOf[^x[XXgێt@C`
======================================================================*/
#define	PIODB_LIST_FVER		0x0001
#define	PIODB_LIST_FNAME	"ZPIOLIST.ZDB"
#define	PIODB_LIST_MAXITEM	255				/* f[^x[Xő吔 */
typedef struct PIODBLISTFILE {
	PIODBID		dbId;						/* 8oCgŒ */
	UCHAR		dbName[PIODBTITLE_LEN];		/* Ō'\0' */
	UCHAR		boxFName[13];				/* Ō'\0' */
	PIODBATTR	dbAttr;
} PIODBLISTFILE;

/*======================================================================
		PIOf[^x[XXg
======================================================================*/
typedef	USHORT	PIODBLISTID;

typedef struct PIODBLIST {
/* public: */
	PIODBLISTID		dbNum;			/* Xg̃f[^x[X */
	UCHAR			driveName[DRIVENAME_LEN+1];
/* private: */
	UCHAR			deleted1;		/* gp */
	struct PIODBLIST	*self;
	UCHAR			*tdxFName;		/* i荞łꍇ */
	PIODBLISTFILE	*dbListFItem;	/* Ă */
	BOXHANDLE		dbListBoxHdl;	/* DBXgBOXt@C̃nh */
	CARDID			readCardId;		/* LbVĂJ[hID */
	USHORT			reserved2;
/*	ULONG			reserved2; */
	ULONG			reserved3;
} PIODBLIST;

/*======================================================================
		\[gCfbNX\
		\[g͕KōsB~ɂƂ̓CfbNX͕ύX
		PIOō~ɂȂ悤ɂB
======================================================================*/
typedef struct PIOSORTINFO {
	PIOITEMNO	keyItemNo;		/* \[gL[ID(1-) */
	DTMFNAME	idxFName;		/* CfbNXt@C */
								/* x[X̂ */
	UCHAR		isSticky;		/* sCfbNX(}X^CfbNX) */
	UCHAR		unUsedCounter;	/* gȂJE^ */
	UCHAR		isValid;		/* Lǂ */
	CATEGORYID	categoryId;		/* i荞݃JeS[ID(0̓}X^) */
	UCHAR		isAscendent;	/* \[g */
/*	ULONG		reserved1;	*/	/* JeS[ȂǂɎg\ */
	USHORT		reserved12;
	ULONG		reserved2;		/* JeS[ȂǂɎg\ */
} PIOSORTINFO;

/*======================================================================
		PIO\
======================================================================*/
/* t@C͑Săx[X̂݊i[ */
/* pXʃoŕێĂ */
typedef struct PIO {
	UCHAR		version;
	UCHAR		reserved1;
	UCHAR		reserved2;
	UCHAR		reserved3;
	UCHAR		path[LONG_DFNAME_LEN];	/* PIOt@C̃pX */
	DTMFNAME	boxFName;		/* BOXt@C */
	UCHAR		isSelectEnable;	/* ICfbNXLH */
	DTMFNAME	selectIdxName;	/* IpCfbNX */
	BOXHANDLE	boxHandle;		/* BOXt@CI[vnh */
	PIOSORTINFO	*crntIdxInfo;	/* ڃCfbNX */
								/* i荞݂sꍇɕς */
	PIOSORTINFO	*masterIdxInfo;	/* }X^CfbNX */
								/* ΂ɕςȂ */
	DTMERR		dtmErrCode;		/* DTMG[R[h */
	UCHAR		isAscendent;	/* \[gǂ */
								/* (ascendent):true */
								/* ~(descendent):false */
	UCHAR		isEditing;		/* ҏWǂ */
	UCHAR		isModified;		/* ҏWɍXVꂽH */
	CARDID		editCardId;		/* ҏW̏ꍇ̃VXeJ[h */
	UCHAR		idxInfoNum;
	PIOSORTINFO	*idxInfoTbl;
	PIOEXTINFO	*extInfo;
	/* ȉJvpeB */
	HANDLE		ctgrTbl;
	ULONG		reserved4;
	ULONG		reserved5;
} PIO;

/*======================================================================
		PIO-API`
======================================================================*/
/* PIOCX^XgAPI */
BEGIN_EXTERN_C              /* C++ support  99/9/8 */
PIO*
PioNew(DTMFNAMEL *boxFName);
void
PioDispose(PIO *pio);
BOOLEAN
PioIsBoxOpened(PIO *pio);
BOOLEAN
PioOpen(PIO *pio);
void
PioClose(PIO *pio);
PIOERR
PioGetCardNum(PIO *pio,ULONG *resultNum);
PIOERR
PioReadItem(PIO *pio,ZDFIELD *field,CARDID cardId);
PIOERR
PioWriteItem(PIO *pio,ZDFIELD *field);
PIOERR
PioWriteBitItem(PIO *pio,CARDID cardId,
				UCHAR bitData,BOOLEAN isSet);
PIOERR
PioStartEditCard(PIO *pio,CARDID cardId);
PIOERR
PioCancelEditCard(PIO *pio);
PIOERR
PioFinishEditCard(PIO *pio,CARDID *cardId);
PIOERR
PioDeleteCard(PIO *pio,PIODELMODE mode,CARDID *cardId);
PIOERR
PioGetCardIdFromNumber(PIO *pio,CARDID *cardId,USHORT number);
PIOERR
PioGetNumberFromCardId(PIO *pio,USHORT *number,CARDID cardId);
PIOERR
PioDrawItem(PIO *pio,CARDID cardId,PIOITEMNO itemNo,ZDRAW *zdraw);
PIOERR
PioGetNextCard(PIO *pio,CARDID *cardId);
PIOERR
PioGetPrevCard(PIO *pio,CARDID *cardId);
PIOERR
PioSort(PIO *pio,PIOITEMNO keyItemNo,BOOLEAN isAscendent);
PIOERR
PioCreateSelectIndex(PIO *pio);
PIOERR
PioAddToSelectIndex(PIO *pio,CARDID cardId);
PIOERR
PioRemoveFromSelectIndex(PIO *pio,CARDID cardId);
PIOERR
PioDeleteSelectIndex(PIO *pio);
PIOERR
PioEnableSelectIndex(PIO *pio);
PIOERR
PioDisableSelectIndex(PIO *pio);
PIOERR
PioDeleteDb(PIO *pio);
PIOERR
PioGeoSearch(PIO *pio,CARDID *num,CARDID *foundList,
			 UCHAR *ltLtStr,UCHAR *ltLgStr,UCHAR *rbLtStr,UCHAR *rbLgStr);
PIOERR
PioGetIconResource(PIO *pio,CARDID cardId,
				   RESOURCE *iconRes,PIOICONTYPE type);
PIOERR
PioDuplicateCard(PIO *pio,CARDID *cardId);
PIOERR
PioSearch(PIO *pio,CARDID *card,UCHAR *serCond,BOOLEAN isNext,
		  UCHAR attrMask,UCHAR attrCond,UCHAR attrFlag);
PIOERR
PioSimpleSearch(PIO *pio,UCHAR *str,ULONG strLen,
				ITEMNAME item,CARDID *cardId,UCHAR searchMode);

/* PIOCX^XgȂ(1)g񂾂gAPI */
PIOEXTINFO*
PioNewExtBoxInfo(DTMFNAMEL *boxFName,BOXHANDLE boxHdl);
void
PioDisposeExtBoxInfo(PIOEXTINFO *extInfo);
PIOITEMNO
PioExtGetItemNo(PIOEXTINFO *extInfo,ITEMNAME itemName);
PIOITEMNO
PioExtGetYomiPairItemNo(PIOEXTINFO *extInfo,PIOITEMNO itemNo);
UCHAR
PioExtGetTimeFormat(PIOEXTINFO *extInfo,PIOITEMNO itemNo);
PIOITEMNO
PioExtGetZipPairItemNo(PIOEXTINFO *extInfo,PIOITEMNO itemNo);
BOOLEAN
PioExtGetIconResName(PIOEXTINFO *extInfo,UCHAR *resName,
					 ITEMNAME iconItem,PIOICONTYPE type);

/* PIOCX^XgȂ(2)DBXgɊւAPI */
PIODBLIST*
PioDbListNew(UCHAR *driveName,PIODBATTR type);
void
PioDbListDispose(PIODBLIST *dbList);
void
PioDbListSort(PIODBLIST *dbList,PIODBSORT sortType,BOOLEAN isAscendent);
PIODBLISTFILE*
PioDbListGetItemPtr(PIODBLIST *dbList,PIODBLISTID itemNo);
PIODBLISTID
PioDbListSearchDb(PIODBLIST *dbList,PIODBID dbId,
				  UCHAR *dbName,ULONG dbNameLen,PIODBLISTID startIdx);
PIOERR
PioCreateDbFile(DTMFNAMEL *boxFName,
				PIODBREF *itemData,PIODBREF *extInfo);
PIOERR
PioCreateDbFileFromPof(UCHAR *drive,UCHAR *pofFName);
PIOERR
PioDbListReadItem(PIODBLIST *dbList,PIODBLISTID itemNo,ZDFIELD *field);
PIOERR
PioDbListWriteItem(PIODBLIST *dbList,PIODBLISTID itemNo,ZDFIELD *field);
PIODBLISTID
PioDbListSearchFromBoxFName(PIODBLIST *dbList,UCHAR *boxFName);
UCHAR*
PioDbListGetMenuList(PIODBLIST *dbList,ULONG *menuNum);

/* BCD[eBeB */
int
PioBcdInternalToStr(UCHAR *str,UCHAR *internal);
void
PioBcdStrToInternal(UCHAR* internal,UCHAR *str);

/* PIOCX^XgȂ(3)ʒu񃆁[eBeB */

PIOERR
PioCtgrFilterEnable(PIO *pio,CATEGORYID categoryId);
PIOERR
PioCtgrFilterDisable(PIO *pio,BOOLEAN isIdxDelete);
PIOERR
PioAddCardToCtgr(PIO *pio,CARDID cardId,
				 CATEGORYID categoryId,PIODELMODE mode,
				 BOOLEAN isAlert);
PIOERR
PioRemoveCardFromCtgr(PIO *pio,CARDID cardId,
					  CATEGORYID categoryId,PIODELMODE mode,
					  BOOLEAN isAlert);
PIOERR
PioDbListCategoryUpdate(PIO *pio,
						UCHAR *driveName,UCHAR *serCond,UCHAR direction,
						CATEGORYID categoryId,BOOLEAN isAdd,USHORT *count);
void
PioDbListUpdate(PIODBLIST *dbList);

void
PioInitVolume(UCHAR *driveName);
void
PioSimpleInitVolume(UCHAR *driveName);
END_EXTERN_C                /* C++ support  99/9/8 */

#define	_PIO_H_INCLUDED
END_NAMESPACE_ZAURUS        /* C++ support  99/9/8 */
#endif	_PIO_H_INCLUDED
