/***********************************************************************
<t@C>	pioimage.h

	Copyright (c) 1995-1999 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-EX1
***********************************************************************/
#ifndef _PIO_IMAGE_H_INCLUDED

#include <pio.h>
#include <drfio.h>
#include <offscrn.h>

/*======================================================================
		`
======================================================================*/
/* C[W̘_ڔԍێ^ */
typedef UCHAR	PIOIMGITEMNO;

/* C[WAPI̋ʃG[R[h */
typedef enum PIOIMGERR {
	PIOIMGERR_NONE = 0,
	PIOIMGERR_MEMORY,
	PIOIMGERR_BAD_PARAM,
	PIOIMGERR_SUB_MODULE	/* ʃW[̃G[ */
} PIOIMGERR;

/*======================================================================
		t@CvCx[gTu[`
======================================================================*/
/*======================================================================
		t@COJ֐
======================================================================*/
PIOERR
PioImgGetInfo(PIO *pio,PIOIMGITEMNO imgItemNo,CARDID cardId,
			  PIOIMAGETYPE *imgType,ITEMNAME imgItemName,
			  DATALEN *imgLen);
PIOERR
PioImgGetItemName(PIOEXTINFO *extInfo,PIOIMGITEMNO imgItemNo,
				  PIOIMAGETYPE imgType,ITEMNAME imgItemName);
PIOIMGERR
PioImgGetImageSize(DRFFILE *drfFile,PIOIMAGETYPE imgType,
				   ULONG *width,ULONG *height,ULONG *subErr);
PIOERR
PioImgReadToOffscreen(DRFFILE *drfFile,PIOIMAGETYPE imgType,
					  RECTANGLE *srcRect,WINDOWHD osHandle,
					  RECTANGLE *dstRect,ULONG *subErr);
void
PioImgSetupDrf(DRFFILE *drfFile,
			   PIO *pio,CARDID cardId,ITEMNAME imgItemName);
PIOERR
PioImgWriteImageType(PIO *pio,PIOIMGITEMNO imgItemNo,PIOIMAGETYPE imgType);
PIOERR
PioImgGetImageTitle(PIO *pio,PIOIMGITEMNO imgItemNo,UCHAR *title);

#define	_PIO_IMAGE_H_INCLUDED
#endif	/* _PIO_IMAGE_H_INCLUDED */
