/***********************************************************************
<t@C>	privenv.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		ϐɊւ郉Cu̒`
***********************************************************************/

#ifndef _PRIVENV_H_INCLUDED
#define _PRIVENV_H_INCLUDED

#include <ioercode.h>

/*======================================================================
		SH^G[R[h
======================================================================*/

#define	EC_PRIVENV_ALREADY_EXIST (PRIVENV_EC_BASE+0x01) /* O̕ϐ݂ */
#define	EC_PRIVENV_NO_SPACE		 (PRIVENV_EC_BASE+0x02) /* ϐ̈悪t */
#define	EC_PRIVENV_NOT_EXIST	 (PRIVENV_EC_BASE+0x03) /* ϐ݂͑Ȃ */


/*======================================================================
		^錾A\
======================================================================*/

/* ϐ̖O */
typedef unsigned long PRIVENVNAME;

/* ϐ̒l */
typedef unsigned long PRIVENVVALUE;
/* lێ */
/* AhXێ */


/*======================================================================
		Cu֐vg^Cv錾
======================================================================*/

int NewPrivEnv( PRIVENVNAME EnvName );
int DestroyPrivEnv( PRIVENVNAME EnvName );
int WriteValuePrivEnv( PRIVENVNAME EnvName, PRIVENVVALUE Value );
PRIVENVVALUE ReadValuePrivEnv( PRIVENVNAME EnvName );
int SetBitPrivEnv( PRIVENVNAME EnvName, PRIVENVVALUE Value );
int ClearBitPrivEnv( PRIVENVNAME EnvName, PRIVENVVALUE Value );
int ReverseBitPrivEnv( PRIVENVNAME EnvName, PRIVENVVALUE Value );
PRIVENVVALUE *GetAdrPrivEnv( PRIVENVNAME EnvName );


/*======================================================================
		IOCSϐ̃t@NVԍ	trapa #PRIVENV_IOCS
======================================================================*/

#define	NEW_PRIVENV			0x41	/* ϐ𐶐 */
#define	DESTROY_PRIVENV		0x42	/* ϐP */
#define	WRITE_VALUE_PRIVENV	0x43	/* ϐ̒l */
#define	READ_VALUE_PRIVENV	0x44	/* ϐ̒lǂݏo */
#define	SET_BIT_PRIVENV		0x45	/* ϐ̃rbg𗧂Ă */
#define	CLEAR_BIT_PRIVENV	0x46	/* ϐ̃rbgQ */
#define	REVERSE_BIT_PRIVENV	0x47	/* ϐ̃rbg𔽓] */
#define	GET_ADR_PRIVENV		0x48	/* ϐ̒li[ĂAhX𓾂 */


/***********************************************************************
ymacroz BOOLEAN IsTherePrivEnv( const PRIVENVNAME EnvName )
y@  \z  EnvNameŎw肵ϐ݂邩ǂ𒲂ׂ
			ReadValuePrivEnv()ŁAϐ݂^Ȃł
			̂ŁÃ}Nő݂mF邱
yz  EnvName		ϐ
y߂lz  == true		݂
			== false	݂Ȃ

***********************************************************************/

#ifndef NULL
#define NULL ((void*)0)
#endif

#define IsTherePrivEnv(EnvName) ( GetAdrPrivEnv(EnvName)!=NULL )


#endif /* _PRIVENV_H_INCLUDED */

