/***********************************************************************
<t@C>	searchpad.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

#ifndef	_SEARCHPAD_H_INCLUDED
#define	_SEARCHPAD_H_INCLUDED
/*
;;****************************************************************
;	菑F̃XgN`
;;****************************************************************
*/
#ifndef H2EQU
#include	<inputpad.h>
#include	<c_edit.h>
#include	<c_bmenu.h>
#include	<aplgsrch.h>


#define	Secret_ON_BtnID		1		/* v */
#define	Secret_OFF_BtnID	2		/*  */

/* pbhԕۑp\ */
typedef struct SPADSTATUS {
    UCHAR   IsSecretOn;
    UINT    ActiveNo;
    UCHAR   SearchStr[GS_SERSTR_BUF];
} SPADSTATUS;


/* ʏGfB^pXgN`[N */
#ifndef	_SEARCHNORMEDIT_DEFINED
typedef struct SearchNormEdit
{
	EDITWORK	NormalED ;
		/* GfB^[N */
	UCHAR		LineTable[4] ;
		/* GfB^se[u(Ps) */
	UCHAR		EditTable[13] ;
		/* GfB^[N */

} SEARCHNORMEDIT;
#define	_SEARCHNORMEDIT_DEFINED
#endif

/* titH[}bgjGfB^pXgN`[N */
#ifndef	_SEARCHFORMEDIT_DEFINED
typedef struct SearchFormEdit
{
	FORMATEDITWORK	FormatED;
		/* tH[}bgGfB^[N */
	ITEMWORK	*ItemYearPtr ;
		/* uNvڏւ̃|C^ */
	ITEMWORK	*ItemMonthPtr ;
		/* uvڏւ̃|C^ */
	ITEMWORK	*ItemDayPtr ;
		/* uvڏւ̃|C^ */
	ITEMWORK	*NullPtr ;
		/* mtkk|C^ */
	ITEMWORK	YearWork ;
		/* uNvڏ񃏁[N */
	ITEMWORK	MonthWork ;
		/* uvڏ񃏁[N */
	ITEMWORK	DayWork	;
		/* uvڏ񃏁[N */
	UCHAR		YearGuide[5] ;
		/* uNvړ^ڔ^NA */
	UCHAR		MonthGuide[5] ;
		/* uvړ^ڔ^NA */
	UCHAR		DayGuide[11] ;
		/* uvړ^ڔ^NA */

} SEARCHFORMEDIT ;
#define	_SEARCHFORMEDIT_DEFINED
#endif


/*@wKp̃XgN`@*/
#ifndef	_SEARCHPADSTUDY_DEFINED
typedef	struct	SearchStudy
{
	UCHAR		Secret ;
		/* V[NbgOn/Off(=SecretMode) */
	UCHAR		ListNo;
	USHORT		ActiveMenuID ;
		/* ANeBuȃj[hc */
	UCHAR		FormatDate[8];
		/* tGfB^wKobt@ */
	UCHAR		NormalEdit[10*2];
		/* ʏGfB^wKobt@ */

} SEARCH_STUDY ;
#define	_SEARCHPADSTUDY_DEFINED
#endif


/*yӁz}[Ño[̂݃[U[ɂ鏉lݒ肪Kv */

#endif H2EQU

	/* V[Nbĝnm^neemSecretModen*/
#define	SECRET_SEARCH_OFF	0x00		/* V[Nbgnee */
#define	SECRET_SEARCH_ON	0x01		/* V[Nbgnm */
#define	YOMI_SEARCH_MODE	0x02		/* ǂ݌[h */
#define	SECRET_SEARCH_NONE	0x04		/* V[Nbg{^\ */


	/* GfB^^Cv */
#define	NORMAL_EDITOR		0x00		/* ʏGfB^[ */
#define	FORMAT_EDITOR		0x02		/* tGfB^[ */


	/* eɑ΂gpGfB^w胏[N */
/*
@@̂Pڂɑ΂APoCgŒʏ^tGfB^̂ǂgp邩
@w肷B
@PڂPoCgɑΉAQڈȍ~QCRCDDDɑΉB
@GfB^̎w͂aOikrajōsȂAaOÔƂʏGfB^
@AaOP̂ƂtGfB^gpBaOȊO͑SĂOɂĂ
@ƁB
*/

#ifndef H2EQU

/* pbhpi[XgN` */
#ifndef	_SEARCHINFO_DEFINED

typedef struct	FormInfo {
	UCHAR		SelectModeOn;
		/* tH[}bgGfB^[SelectModeOn]Ɠ */
	ITEMINFO	*ItemYearPointer; 
	ITEMINFO	*ItemMonthPointer;
	ITEMINFO	*ItemDayPointer;
	ITEMINFO	ItemYear;
	ITEMINFO	ItemMonth;
	ITEMINFO	ItemDay;
	UCHAR		YBdata[5];
	UCHAR		YCdata[8+1];
	UCHAR		MBdata[5];
	UCHAR		MCdata[8+1];
	UCHAR		DBdata[5];
	UCHAR		DCdata[8+1];
} FORMINFO;

typedef struct SearchInfo
{
	UCHAR		EditType;	/* GfB^^CvƓ NORMAL_EDITOR or FORMAT_EDITOR */
	union SEARCHEDIT {	
		EDITINFO	NormalEdit;
		FORMINFO	FormEdit;
	} SearchEdit;
} SEARCHINFO;
#define	_SEARCHINFO_DEFINED
#endif


#define	StopBtnID	2001
#define	EntBtnID	2000
#define	PracticeBtnID	2000
#define	SIODataReachID	1234
#define	SPadWindowStructID	1234
#define	SPadItemYearStrcID	1234
#define	SPadItemMonthStrcID	1234
#define	SPadItemDayStrcID	1234
#define	SPadYearGuideStrID	1234
#define	SPadMonthGuideStrID	1234
#define	SPadDayGuideStrID	1234
#define	SPadGp2BtnID	1234
#define	SPad2OnBtnID	1234
#define	SPad2OffBtnID	1234
#define	SPadTitleID				((USHORT)40000)
#define	SPadInputTitleID		(SPadTitleID+1)
#define	SPadTypeStrID			(SPadInputTitleID+1)
#define	SPadInputPadID			(SPadTypeStrID+1)
#define	SPadBtnMenuID			(SPadInputPadID+1)
#define	SPadNEditID				(SPadBtnMenuID+1)
#define	SPadFEditID				(SPadNEditID+1)
#define	SPadGp1BtnID			(SPadFEditID+1)
#define	SPadLineID				(SPadGp1BtnID+1)
#define	SPadLine2ID				(SPadLineID+1)
#define	SPadYomiTitleID			(SPadLine2ID+1)
#define	SPadYomiInputTitleID	(SPadYomiTitleID+1)
#define	SPadYomiMessStrID		(SPadYomiInputTitleID+1)
#define	SPadSecretBtnID			(SPadYomiMessStrID+1)
#define	SPadSecretMessID		(SPadSecretBtnID+1)


/*** ψ̐錾	***/
short	SearchPadObj( MESSAGE *, void *,... );
short	YomiSearchObj( MESSAGE *, void *,... );
short	SrchPadObj( UCHAR, MESSAGE *, void *,... );

/* NXŊmۂobt@̃TCY` */
#define	SP_EDIT_BUF_SIZE_PATCH	24
#define	SP_EDIT_BUF_SIZE		20
#define	SP_FEDIT_BUF_SIZE		10
#define	SP_RES_WORK_SIZE		28
#define SP_EDIT_TYPE_SIZE		100

/* vg^Cv錾 */
short	SearchPad( MESSAGE *MessPtr, void *PadWorkPtr,... );


void	SecretMess_Disp(void *PadWorkPtr);
USHORT	SPadCheckMenuID(void *PadWorkPtr);

UCHAR	SetSPadStatus(SPADSTATUS *,UCHAR);
UCHAR	ReadSPadStatus(SPADSTATUS *,UCHAR);


#endif H2EQU
#endif
