/***********************************************************************
<t@C>	stdiozrs.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		Xg[o͊֘Ãwb_t@C
		y`tqtrdl
***********************************************************************/

#ifndef	_STDIOZRS_H_INCLUDED
#define	_STDIOZRS_H_INCLUDED

#include<file.h>

/***********************************************************************
  萔錾
***********************************************************************/

/* END of FILE */
#define	EOF				(-1)

/* Null Pointer */
#ifndef NULL
#define NULL			((void *)0)
#endif

/* Wo͈͂Ȃ */
#if !defined(USE_NEWLIB)&&!defined(USE_LOCAL_LIBC)
#define	stdin		NULL
#define	stdout		NULL
#define	stderr		NULL
#endif

/* fseek start point */
#ifndef SEEK_SET
#define SEEK_CUR		1
#define SEEK_END		2
#define SEEK_SET		0
#endif

/***********************************************************************
  ehkd\
***********************************************************************/

/* Xg[̃G[ */
typedef	ERRORCODE	FERROR;	/* Ƃ肠t@CRg[̃G[ */

/* ehkd\ */

typedef struct FILE {
	FILEHD		FileHandle;	/* t@Cnh */
	BOOLEAN		IsEOF;		/* Xg[I[ǂ\tO */
	FERROR		FError;		/* Xg[̃G[Ԃ\ */
} FILE;


/***********************************************************************
  stat.h 납ȁH
***********************************************************************/


#if !defined(USE_NEWLIB)&&!defined(USE_LOCAL_LIBC)
typedef	long	off_t;
typedef	ULONG	time_t;

/* stat p̏i[\ */
struct stat {
	off_t	st_size;		/* t@CTCY (P : bytes) */
	time_t	st_mtime;		/* W 1970/01/01 00:00:00 o߂ (P : b) */
};
#else 
struct stat {
  long	st_size;		/* t@CTCY (P : bytes) */
  ULONG	st_mtime;		/* W 1970/01/01 00:00:00 o߂ (P : b) */
};
#endif

/***********************************************************************
  J֐
***********************************************************************/

#define rename	zrename
#define unlink	zunlink

FILE *fopen(char *,char *);
int fclose(FILE *);
int fread(char *,int,int,FILE *);
int fwrite(char *,int,int,FILE *);
int feof(FILE *);
int ferror(FILE *);
void clearerr(FILE *);
int fgetc(FILE *);
int fputc(char c,FILE *);
int fseek(FILE *,long,int);
void rewind(FILE *);
int rename(char *,char *);
int unlink(char *);
int stat(char *,struct stat *);
long ftell(FILE *);

/***********************************************************************
  ʓIłȂ֐  nlĂgp邱
***********************************************************************/

FILE *sys_fopen(char *,char *);
int sys_fclose(FILE *);

FILE *fopen_a(char *,char *);

/* p */
FILE *ker_fopen(char *,char *);
int ker_fclose(FILE *);

/***********************************************************************
  Tu[` in system
***********************************************************************/

typedef enum ACC_MEMORY {
	Heap,		/* NewHeapPtrS() , DisposeHeapPtr() */
	sys_,		/* sys_malloc() , sys_free() */
	Sys			/* SysMalloc() , SysFree() */
} ACC_MEMORY;

FILE *FOpenSubU(char *,char *,FILEATR,ACC_MEMORY);
int FCloseSubU(FILE *,ACC_MEMORY);

/***********************************************************************
  stat Ɋւ tmp
***********************************************************************/

/* PERIODɊւ邱ƂłŒ`H */

#define GetPeriodFlag(pPeriod)	( ((pPeriod)->PArray[4] & 0x80) == 0x80 )
#define GetPeriodSecond(pPeriod)	((ULONG)( (pPeriod)->PArray[0] & 0x3f ))
#define GetPeriodMinute(pPeriod)	((ULONG)( (pPeriod)->PArray[1] & 0x3f ))
#define GetPeriodHour(pPeriod)	((ULONG)( ((pPeriod)->PArray[1] >> 6) + (((pPeriod)->PArray[2] & 0x07) << 2) ))
#define GetPeriodDate(pPeriod)	((ULONG)( ((pPeriod)->PArray[2] >> 3) + ((pPeriod)->PArray[3] << 5) + (((pPeriod)->PArray[4] & 0x7f) << 13) ))


#endif
