/***********************************************************************
<t@C>	sysiolib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		SH^VXeIOCSCCu֐wb_t@C
***********************************************************************/

#ifndef _SYSIOLIB_H_INCLUDED
#define _SYSIOLIB_H_INCLUDED
#include <ioercode.h>
#include <sharpgen.h>


/*======================================================================
		SH^IOCS G[R[h
======================================================================*/

#define	EC_SYSIO_BAD_FUNC_ADR	(SYSIO_EC_BASE+0x00)	/*  */
#define	EC_SYSIO_IRQ_ENTRY_FULL	(SYSIO_EC_BASE+0x01)	/*  */
#define	EC_SYSIO_ERROR	(SYSIO_EC_BASE+0xFFFF)


/*======================================================================
		Cu֐vg^Cv錾
======================================================================*/

ULONG GetMicroSecCount( void );
void WaitNus( ULONG waitTime );
int Add10msIRQFunc( PROC pFunc, void *pWork );
int Remove10msIRQFunc( PROC pFunc );
int AddSystemTickFunc( PROC pFunc, void *pWork );
int RemoveSystemTickFunc( PROC pFunc );
void SetPcmciaAccessTime( UCHAR accessTime );
void ControlPowerMode( int powerMode );
UCHAR GetInitLevel( void );
UCHAR GetInitCondition( void );
BOOLEAN GetACAdaptorCondition( void );
BOOLEAN CheckACAdaptor( void );
UCHAR GetBatteryCondition( void );
UCHAR SysGetBatterPerRest( void );
void SysIOActivate( UCHAR request );
void SystemOffEntry( void );
void SoftResetEntry( void );
void ClearBlOffCount( void );
void ClearApOffCount( void );
void SetApOffCount ( UCHAR ac_info ,USHORT ap_time );
USHORT GetApOffCount ( UCHAR ac_info );
void SystemInitTool( UCHAR initlevel );
UCHAR GetONCondition( void );
void SystemOffResetEntry( UCHAR );
void RTCSetCheckData( void );
char RTCCheck( void );
void StopApOff( void );
void StopApOff( void );
void StopApOff( void );
void ModifyInitCondition( UCHAR );
BOOLEAN CheckInitSwitch( void );
void AdlCmnFuncTblUnmap( void );
void WaitNTimeSlice( ULONG );
BOOLEAN  CheckStartPort( void );
ULONG  GetTMU2Count( void );
int GetProcCreateSpace( void );
void ControlSleepMode( int );
UCHAR GetPcmciaAccessTime( UCHAR );
BOOLEAN SPhpdDetectCheck( void );
int SPhpdEnableV42bisCompression(void);

/*  GetBatteryCondition(),SysGetBatterPerRest() gpꍇ́A
        battlib.h K include ĉB						  */

/*======================================================================
		萔̐錾
======================================================================*/

/* oblbh`̂v`hsݒ̒` */
#define	PCMCIA_DSPEED100		0		/* ۂɂ 204ns */
#define	PCMCIA_DSPEED150		1		/* ۂɂ 340ns */
#define PCMCIA_DSPEED200		2		/* ۂɂ 340ns */
#define	PCMCIA_DSPEED250		3		/* ۂɂ 408ns */
#define	PCMCIA_DSPEED300		4		/* ۂɂ 476ns */
#define	PCMCIA_DSPEED350		5		/* ۂɂ 544ns */
#define	PCMCIA_DSPEED400		6		/* ۂɂ 544ns */
#define	PCMCIA_DSPEED450		7		/* ۂɂ 612ns */
#define	PCMCIA_DSPEED500		8		/* ۂɂ 748ns */
#define	PCMCIA_DSPEED550		9		/* ۂɂ 816ns */
#define	PCMCIA_DSPEED600		10		/* ۂɂ 816ns */
#define	PCMCIA_DSPEED650		11		/* ۂɂ 884ns */

/* p[[h̐ݒ̒` */
#define	POWER_MODE_IR			0x00000001	/* IR ʐM[ĥߐݒ */
#define	POWER_MODE_SIO			0x00000002	/* SIO ʐM[ĥߐݒ */
#define	POWER_MODE_MODEM		0x00000004  /* MODEM ʐM[ĥߐݒ */
#define	POWER_MODE_PCMCIA0		0x00000008	/* PCMCIA(Socket 0) ̒ʐM[ĥߐݒ */
#define	POWER_MODE_PCMCIA1		0x00000010	/* PCMCIA(Socket 1) ̒ʐM[ĥߐݒ */
#define	POWER_MODE_TOUCH		0x00000020	/* ^b`pl쒆̂ߐݒ */
#define	POWER_MODE_KEY			0x00000040	/* L[쒆̂ߐݒ */
#define	POWER_MODE_RECOG		0x00000080	/* F쒆̂ߐݒ */
#define	POWER_MODE_SOUND		0x00000100	/* 쒆̂ߐݒ */
#define	POWER_MODE_DIAG			0x00000200	/* ch`f쒆̂ߐݒ */
#define	POWER_MODE_FAST_TICK	0x00000400	/* shbjL̂ߐݒ */
#define	POWER_MODE_EXT0			0x00000800	/* ̗̑v̂ߐݒ */
#define	POWER_MODE_EXT1			0x00001000	/* ̗̑v̂ߐݒ */

/* x̒` */
#define SYSTEM_RESET_LEVEL			0
#define	SYSTEM_OFF_LEVEL			2
#define SYSTEM_ON_LEVEL				3

/* ̒` */
#define	SYSTEM_NORMAL				0	/* m[}ȋN */
#define SYSTEM_DELETE_USER_DATA		1	/* [U[f[^v */
#define SYSTEM_INIT_CLOCK			2	/* v̏Kv */
#define SYSTEM_DATA_AND_CLOCK		3	/* [U[f[^v̏Kv */
#define SYSTEM_DIAG_PRODUCT			4	/* Yp_CAŐN */
#define SYSTEM_DIAG_REMOTE			5	/* [g_CAŐN */
#define SYSTEM_DIAG_SERVICE			6	/* T[rXp_CAŐN */

/* nm̒` */
#define SYSTEM_ON_OTHER		0x00000000		/* ̗v ON */
#define SYSTEM_ON_TOUCH		0x00000001		/* ^b`ON */
#define SYSTEM_ON_ALARM		0x00000002		/* A[ */
#define SYSTEM_ON_CRADLE	0x00000004		/* N[hON */
#define SYSTEM_ON_TOUCH_WITH_SWITCH	0x81	/* ^b`ON + XCb` */

/* `bA_v^[̏ */
#define AC_ADAPTOR_IN			1		/* `bA_v^[ */
#define AC_ADAPTOR_OUT			0		/* `bA_v^[Ȃ */

/* VXe Activate p */
#define	SYS_ALL_ENABLE			0		/* Sċ */
#define	SYS_ALL_DISABLE			1		/* Sċ֎~ */
#define SYS_BATTERY_ENABLE		2		/* drj^[ */
#define	SYS_BATTERY_DISABLE		3		/* drj^[֎~ */
#define	SYS_AC_ADAPTOR_ENABLE	4		/* `bA_v^[j^[ */
#define	SYS_AC_ADAPTOR_DISABLE	5		/* `bA_v^[j^[֎~ */
#define	SYS_BACKLIGHT_ENABLE	6		/* obNCgj^[ */
#define	SYS_BACKLIGHT_DISABLE	7		/* obNCgj^[֎~ */

/* dr^`bA_v^[̃j^[֌W */
#define	SYS_BATTERY_MON_DISABLE		0xaa
#define	SYS_AC_ADAPTOR_MON_DISABLE	0x55
#define	BATTERY_CHECK_COUNT			0x1

/* I[gp[It֌W̒` */
#define	APOFF_BATTERY_MODE			0
#define APOFF_ACADAPTOR_MODE		1
#define	DEFAULT_APOFF_COUNT					3600	/* lU */
#define DEFAULT_APOFF_COUNT_ADAPTOR			3600	/* lU */

/* obNCgPx֌W̒` */
#define	BKLIGHT_BATTERY_MODE			0
#define BKLIGHT_ACADAPTOR_MODE			1
#define	DEFAULT_BACKLIGHT_COUNT				1200	/* lQ */
#define	DEFAULT_BACKLIGHT_COUNT_ADAPTOR		1200	/* lQ */

#endif /* #ifndef _SYSIOLIB_H_INCLUDED */
