/***********************************************************************
<t@C>	timelib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/****************************************************************
	^C}l[W`
*****************************************************************/

#include <sharpgen.h>
#ifndef _TIME_DEFINED
#define	_TIME_DEFINED

/*
 * tԃf[^\ 
 * drq[kpbRpCł̓rbgtB[h
 * QoCgPʂ܂Ē`邱ƂłȂ
 * SH3 łACgɍڂȂBoANZX͋֎~B
 */

/* typedef struct { */
/* 	UCHAR 	Second; */
/* 	unsigned 	Minute		:6, */
/* 			Hour		:5, */
/* 			Day		:5, */
/* 			Month		:4, */
/* 			Year		:8, */
/* 			Null4Bit	:4; */
/* 	} TIME; */

typedef struct TIME {
	UCHAR	TArray[5];
} TIME;
/* typedef	UCHAR	TIME[5]; */
#endif

/*
 * ԃf[^\
 * rbgtB[hł̃ANZX͕s
 */

#ifndef	_PERIOD_DEFINED
#define	_PERIOD_DEFINED
typedef struct PERIOD {
	UCHAR	PArray[5];
} PERIOD;
/* typedef unsigned char	PERIOD[5]; */
#endif

/*
 * Tjf[^\
 * rbgtB[hł̃ANZX͕s
 */

#ifndef	_WEEK_DAY_DEFINED
#define	_WEEK_DAY_DEFINED
typedef struct WEEK_DAY {
	UCHAR	WArray[3];
} WEEK_DAY;
/* typedef unsigned char	WEEK_DAY[3]; */
#endif



#ifndef _TIME_LIB_DEFINED
#define	_TIME_LIB_DEFINED

/* j */

#define	SUNDAY			0
#define	MONDAY			1
#define	TUESDAY			2
#define	WEDNESDAY		3
#define	THURSDAY		4
#define	FRIDAY			5
#define	SATURDAY		6
#define DAY_OF_WEEK_ERR	7

/* P */

#define	PART_YEAR		0
#define	PART_MONTH		1
#define	PART_DAY		2
#define	PART_HOUR		3
#define	PART_MINUTE		4
#define	PART_SECOND		5
#define	PART_WEEK		2
#define	PART_DAY_WEEK	3

/* G[R[h */

#define	BAD_COMMAND_ERR		0x41
#define	PART_OVER_ERR		0x42
#define	PARAMETER_ERR		0x43
#define	CALC_TYPE_ERR		0x44
#define	CALCULATION_ERR		0x45

/* ݂̓ssID	*/
#define CURRENT_CITY_ID	0

/* Z[h */
typedef UCHAR TIME_ADD_MODE;
#define	A_TM_PD_TM	1	/* {ԁ */
#define	A_PD_TM_TM	2	/* ԁ{ */
#define	A_PD_PD_PD	3	/* ԁ{ԁ */

/* Z[h */
typedef UCHAR TIME_SUB_MODE;
#define	S_TM_TM_PD	0	/* [ */
#define	S_TM_PD_TM	1	/* [ԁ */
#define	S_PD_PD_PD	3	/* ԁ[ԁ */

/* r[h */
typedef UCHAR TIME_CMP_MODE;
#define	CMP_TIME	0
#define	CMP_PERIOD	3

/* ChJ[hf[^ݒ */

#define	PAST		0
#define	FUTURE		1

/*  */
typedef UCHAR TIME_MODE;
#define	MODE_24			0
#define	MODE_12			1

#define	CHANGE_TO_24	0
#define	CHANGE_TO_12	1

typedef UCHAR HMS_MODE;
#define	MODE_HMS_ERR	0
#define	MODE_24_ASC		1
#define	MODE_12_AM_ASC	2
#define	MODE_12_PM_ASC	3

/* lrcnrtH[}bgϊ̕ */

#define	TO_DOS		0
#define	TO_RTC		1

/* TimeDayChangeϊ̕ */

#define	TIME_TO_DAY		0
#define	DAY_TO_TIME	1

/* TimeHourChangeϊ̕ */

#define	TIME_TO_HOUR	0
#define	HOUR_TO_TIME	1

/* TimeMinuteChangeϊ̕ */

#define	TIME_TO_MINUTE	0
#define	MINUTE_TO_TIME	1

/* TimeSecondChangeϊ̕ */

#define	TIME_TO_SECOND	0
#define	SECOND_TO_TIME	1

/* G[R[h */

#define	BAD_COMMAND_ERR		0x41
#define	PART_OVER_ERR		0x42
#define	PARAMETER_ERR		0x43
#define	CALC_TYPE_ERR		0x44
#define	CALCULATION_ERR		0x45

/* OjbWW߂邽߂̓ssID */
#define	GMT_CITY_ID			234		/* h - ssIDύXɒ */

/* OjbWW߂邽߂̃}N */
#define	GMTTimeRead(time)		LocalTimeRead(time,GMT_CITY_ID)
#define	GMTTimeReadLtd(time)	LocalTimeReadLtd(time,GMT_CITY_ID)

/* ssf[^֘A */
#define	MAX_CITY_NUM		250
#define	MAX_CITY_NAME_LEN	46
#define CityResTopID		1000

/* ssf[^ */
typedef struct CITYDATA {
	UCHAR	CityID;
	UCHAR	DiffTimeLo;
	UCHAR	DiffTimeHi;
	UCHAR	CityName[MAX_CITY_NAME_LEN];
} CITYDATA;

#define	JISAFILE	"JISATMTL"

/* ֐` */

UCHAR		LocalTimeSet(TIME *);
void		LocalTimeRead(TIME *, UCHAR);
void		LocalTimeReadLtd(TIME *, UCHAR);
UCHAR 		CalcDayOfWeek(TIME *);
UCHAR		TimeDataAdd(void *, void *, TIME_ADD_MODE, void *);
UCHAR		TimeDataSub(void *, void *, TIME_SUB_MODE, void *);
UCHAR		LastDayOfMonth(TIME *);
char		TimeDataCmp(void *, void *, TIME_CMP_MODE);
UCHAR		WildcardDataClr(TIME *, UCHAR);
TIME_MODE	IsTimeMode();
void		ChangeTimeMode(UCHAR);
UCHAR		CityTableRead(UCHAR, UCHAR *);
UCHAR		CountryTableRead(UCHAR, UCHAR *);
UCHAR		WildcardNearest(TIME *, TIME *, TIME *);
UCHAR		PartWeekFromAsc(WEEK_DAY *, UCHAR, UCHAR *);
UCHAR		PartWeekToAsc(WEEK_DAY *, UCHAR, UCHAR *);
void		AlarmTimeRead(TIME *);
void		AlarmTimeSet(TIME *);
UCHAR		FormatRtcToMsdos(void *, void *, UCHAR);
USHORT		CalcPassedDays(TIME *);
UINT		DayOfYear(TIME *);
UCHAR		YmdToAsc(TIME *, UCHAR *);
HMS_MODE	HmsToAsc(TIME *, UCHAR *, TIME_MODE);
UCHAR		YmdFromAsc(UCHAR *, TIME *);
UCHAR		HmsFromAsc(UCHAR *, TIME *, HMS_MODE);
UCHAR		LocalTimeChange(TIME *, TIME *);
UCHAR		ChangeLocalTime(TIME *, TIME *, UCHAR);
void		AlarmTimeClear();
void		JisaTableRead(UCHAR, PERIOD *);
void		CityIDSet(UCHAR);
UCHAR		CityIDRead(USHORT *);
void		TimeDayChange(void *, void *, UCHAR);
UCHAR		TimeHourChange(void *, void *, UCHAR);
UCHAR		TimeMinuteChange(void *, void *, UCHAR);
UCHAR		TimeSecondChange(void *, void *, UCHAR);
#endif



