/***********************************************************************
<t@C>	toolmlt.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/****************************************/
/*	c[bZ[WXg		*/
/****************************************/

/*@c[ʃbZ[W@*/
	struct	TOOL_INIT				ToolInit ;
	struct	TOOL_SYSTEM_INIT		ToolSystemInit;
	struct	TOOL_CONSTRUCT_RES		ToolConstructRes ;
	struct	TOOL_CONSTRUCT_PTR		ToolConstructPtr ;
	struct	TOOL_DESTRUCT			ToolDestruct ;
	struct	TOOL_EXEC				ToolExec ;
	struct	TOOL_ALL_EXEC			ToolAllExec ;
	struct	TOOL_EXIT				ToolExit ;
	struct	TOOL_OPEN				ToolOpen ;
	struct	TOOL_CLOSE				ToolClose ;
	struct	SET_NORMAL				SetNormal ;
	struct	SET_HILITE				SetHilite ;
	struct	SET_ACTIVE				SetActive ;
	struct	SET_PAGE				SetPage ;
	struct	REVERSE					Reverse ;
	struct	WAIT_REVERSE			WaitReverse ;
	struct	NORMAL_REPEAT_REVERSE	NormalRepeatReverse ;
	struct	HILITE_REPEAT_REVERSE	HiliteRepeatReverse ;
	struct	CHECK_PART				CheckPart ;
	struct	CHECK_STATUS			CheckStatus ;
	struct	CHECK_ACTIVE			CheckActive ;
	struct	REDISP					Redisp ;
	struct	PART_REDISP				PartRedisp ;
	struct	NEXT_PAGE				NextPage ;
	struct	PREV_PAGE				PrevPage ;
	struct	NEXT_ITEM				NextItem ;
	struct	PREV_ITEM				PrevItem ;
	struct	SCROLL_UP				mScrollUp ;
	struct	SCROLL_DOWN				mScrollDown ;
	struct	SCROLL_UPDATE			ScrollUpdate ;
	struct	EDIT_CHAR				EditChar ;
	struct	SCROLL_LEFT				ScrollLeft ;
	struct	SCROLL_RIGHT			ScrollRight ;
	struct	TEXT_SELECT				TextSelect ;
	struct	TEXT_NORMAL				TextNormal ;
	struct	TEXT_CUT				TextCut ;
	struct	TEXT_COPY				TextCopy ;
	struct	TEXT_PASTE				TextPaste ;
	struct	IMAGE_SELECT			ImageSelect ;
	struct	IMAGE_CUT				ImageCut ;
	struct	IMAGE_COPY				ImageCopy ;
	struct	IMAGE_PASTE				ImagePaste ;
	struct	CHANGE12_24				Change12_24 ;
	struct	SET_SELECT				SetSelect ;
	struct	RESET_SELECT			ResetSelect ;
	struct	IMAGE_NORMAL			ImageNormal ;
	struct	WINDOW_HANDLE_SET		WindowHandleSet;
	struct	CURSOR_LEFT				CursorLeft ;
	struct	CURSOR_RIGHT			CursorRight ;
	struct	CURSOR_UP				CursorUp ;
	struct	CURSOR_DOWN				CursorDown ;
	struct	SET_DATA				SetData ;
	struct	GET_DATA				GetData ;
	struct	SET_PROPERTY			SetProperty ;
	struct	GET_PROPERTY			GetProperty ;
	struct	RESUME_REDISP			ResumeRedisp ;
	struct	GET_RESUME_INFO			GetResumeInfo ;
	struct	TOOL_DATA_CLEAR			ToolDataClear ;
	struct	BUTTON_FLASH_START		ButtonFlashStart ;
	struct	BUTTON_FLASH_END		ButtonFlashEnd ;
	struct	BUTTON_FLASH_CANCEL		ButtonFlashCancel ;

	struct	TOOL_INIT_ERROR			ToolInitError ;
	struct	TOOL_DISP_OVER			ToolDispOver ;
	struct	TOOL_DROP				ToolDrop ;
	struct	DROP_CANCEL				DropCancel ;
	struct	TOOL_DATA_OVER			ToolDataOver ;
	struct	TOOL_ERROR				ToolError ;
	struct	SLIDER_SET				SliderSet ;
	struct	AREA_PRESS				AreaPress ;
	struct	TOOL_CMD_COMPLETED		ToolCmdCompleted ;
	struct	TOOL_CMD_CANCELED		ToolCmdCanceled ;
	struct	FILE_SELECT				FileSelect;
	struct	TOOL_DRAG_START			ToolDragStart;

/* {^bZ[W */
	struct	BUTTON_PRESS_START			ButtonPressStart ;
	struct	BUTTON_PRESS				ButtonPress ;
	struct	LIGHT_BUTTON_PRESS			LightButtonPress ;
	struct	BUTTON_SELECT				ButtonSelect ;
	struct	LIGHT_BUTTON_SELECT			LightButtonSelect ;
	struct	BUTTON_STILL_SELECT			ButtonStillSelect ;
/* struct	LIGHT_BUTTON_STILL_SELECT	LightButtonStillSelect ; */


/* ̓pbhbZ[W */
	struct	BOARD_CHANGE			BoardChange ;
	struct	HENKAN_MODE_SET			HenkanModeSet ;
	struct	NINSHIKI_MODE_SET		NinshikiModeSet ;
	struct	PUSH_KEY				PushKey ;
	struct	SET_PAD_BUF				SetPadBuf ;
	struct	CLEAR_PAD_BUF			ClearPadBuf ;
	struct	CHANGE_TIME_PAD_MODE	ChangeTimePadMode ;
	struct	GET_PAD_DATA			GetPadData ;
	struct	PAD_MODE_CHANGE			PadModeChange ;
	struct	PAD_KUSEJI_NOT_USE		PadKusejiNotUse ;
	struct	SELECT_NINSHIKI_DIC		SelectNinshikiDic ;

	struct	RESULT_EXIST			ResultExist ;
	struct	RESULT_NON				ResultNon ;
	struct	PAD_ALREADY_CLEAR		PadAlreadyClear;

/* pbhbZ[W */
	struct	SET_SEARCH_PAD			SetSearchPad ;
	struct	SET_SEARCH_BUF			SetSearchBuf ;
	struct	CLEAR_SEARCH_BUF		ClearSearchBuf ;

	struct	SEARCH_INPUT_OK			SearchInputOK ;
	struct	SEARCH_BREAK			SearchBreak ;
	struct	SECRET_CHANGE			SecretChange ;


/* A[g{bNXbZ[W */
	struct	ALBOX_TOOL				AlboxTool ;
	struct	ALBOX_DISP_OPEN			AlboxDispOpen ;
	struct	ALBOX_DISP_CLOSE		AlboxDispClose ;
	struct	ALBOX_WAIT_DISP_OPEN	AlboxWaitDispOpen ;

	struct	ALBOX_FINISH			AlboxFinish ;
	struct	ALBOX_ERROR				AlboxError ;


/* GfB^bZ[W */
	struct	EDITOR_CHANGE_ACTIVE_FRAME		EditorChangeActiveFrame ;
	struct	EDITOR_SCROLL_UPDATE			EditorScrollUpdate ;
	struct	EDITOR_SCROLL_UP				EditorScrollUp ;
	struct	EDITOR_SCROLL_DOWN				EditorScrollDown ;
	struct	EDITOR_SCROLL_LEFT				EditorScrollLeft ;
	struct	EDITOR_SCROLL_RIGHT				EditorScrollRight ;
	struct	EDITOR_AUTO_SCROLL_UPDATE		EditorAutoScrollUpdate ;
	struct	EDITOR_AUTO_SCROLL_UP			EditorAutoScrollUp ;
	struct	EDITOR_AUTO_SCROLL_DOWN			EditorAutoScrollDown ;
	struct	EDITOR_AUTO_SCROLL_LEFT			EditorAutoScrollLeft ;
	struct	EDITOR_AUTO_SCROLL_RIGHT		EditorAutoScrollRight ;
	struct	EDITOR_CURSOR_DATA_TOP			EditorCursorDataTop ;
	struct	EDITOR_CURSOR_DATA_END			EditorCursorDataEnd ;
	struct	EDITOR_CURSOR_UP_OVER			EditorCursorUpOver ;
	struct	EDITOR_CURSOR_LOW_OVER			EditorCursorLowOver ;
	struct	EDITOR_PRESS					EditorPress ;
	struct	EDITOR_SELECT					EditorSelect ;
	struct	EDITOR_DISP_OVER				EditorDispOver ;
	struct	EDITOR_TEXT_SELECT				EditorTextSelect ;
	struct	EDITOR_TEXT_NORMAL				EditorTextNormal ;
	struct	EDITOR_TEXT_CUT					EditorTextCut ;
	struct	EDITOR_TEXT_COPY				EditorTextCopy ;
	struct	EDITOR_ITEM_MOVE				EditorItemMove ;

	struct	EDITOR_CORE_CLEAR				EditorCoreClear ;
	struct	EDITOR_GET_TABLE_SIZE			EditorGetTableSize ;
	struct	EDITOR_GET_MAX_COLUMN			EditorGetMaxColumn ;
	struct	EDITOR_GET_MAX_LINE				EditorGetMaxLine ;
	struct	EDITOR_GET_FRAME_SIZE_X			EditorGetFrameSizeX ;
	struct	EDITOR_GET_FRAME_SIZE_Y			EditorGetFrameSizeY ;
	struct	EDITOR_GET_LINE_PITCH			EditorGetLinePitch ;
	struct	EDITOR_GET_DISP_LINE			EditorGetDispLine ;
	struct	EDITOR_GET_ALL_LINE				EditorGetAllLine ;
	struct	EDITOR_SCROLL_LEFT_CURSOR		EditorScrollLeftCursor ;
	struct	EDITOR_SCROLL_RIGHT_CURSOR		EditorScrollRightCursor ;
	struct	EDITOR_GET_CHR_ADDRESS			EditorGetChrAddress ;
	struct	EDITOR_GET_CHR_POSITION			EditorGetChrPosition ;
	struct	EDITOR_MOVE_CURSOR				EditorMoveCursor ;
	struct	EDITOR_MOVE_FRAME				EditorMoveFrame ;
	struct	EDITOR_DISP_TOP					EditorDispTop ;
	struct	EDITOR_DISP_CHR_ADDRESS			EditorDispChrAddress ;
	struct	EDITOR_DISP_CHR_POSITION		EditorDispChrPosition ;
	struct	EDITOR_DISP_CURSOR_TOP			EditorDispCursorTop ;
	struct	EDITOR_DISP_CURSOR_ADDRESS		EditorDispCursorAddress ;
	struct	EDITOR_DISP_CURSOR_POSITION		EditorDispCursorPosition ;
	struct	EDITOR_GET_DRAW_POINT			EditorGetDrawPoint ;
	struct	EDITOR_CLEAR_LINE_SPACE			EditorClearLineSpace ;
	struct	EDITOR_GET_TOUCH_POSITION		EditorGetTouchPosition ;
	struct	EDITOR_CURSOR_OFF				EditorCursorOff ;
	struct	EDITOR_CURSOR_ON				EditorCursorOn ;
	struct	FEDIT_CHECK_STATUS				FEditCheckStatus;

/* 菑GfB^bZ[W */
	struct	HAND_DATA_READ		HandDataRead ;
	struct	HAND_DATA_GET		HandDataGet ;
	struct	HAND_TOOL			HandTool ;

	struct	HAND_EDIT_DRAW		HandEditDraw ;
	struct	HAND_EDIT_PRESS		HandEditPress ;
	struct	HAND_EDIT_DRAW_END	HandEditDrawEnd ;


/* ꗗ\bZ[W */
	struct	LIST_ACTIVE_REDISP	ListActiveRedisp ;
	struct	LIST_SET_ACTIVE		ListSetActive ;
	struct	LIST_DATA_DELETE	ListDataDelete ;
	struct	LIST_ACTIVE_NODISP	ListActiveNodisp;

	struct	LIST_PRESS				ListPress ;
	struct	LIST_CHANGE_PRESS		ListChangePress ;
	struct	LIST_SELECT				ListSelect ;
	struct	LIST_CHANGE_ACTIVE		ListChangeActive ;
	struct	LIST_SCROLL_UP			ListScrollUp ;
	struct	LIST_SCROLL_DOWN		ListScrollDown ;
	struct	LIST_PRESS_AREA			ListPressArea ;
	struct	LIST_CHANGE_PRESS_AREA	ListChangePressArea ;
	struct	LIST_SELECT_AREA		ListSelectArea ;
	struct	LIST_UPDATE				ListUpdate ;

/* XN[o[bZ[W */
	struct	BAR_SLIDER_MOVE		BarSliderMove ;
	struct	BAR_SCROLL_DOWN		BarScrollDown ;
	struct	BAR_SCROLL_UP		BarScrollUp ;
	struct	BAR_NEXT_PAGE		BarNextPage ;
	struct	BAR_PREV_PAGE		BarPrevPage ;

	struct	BAR_UPDATE				BarUpdate ;
	struct	BAR_SLIDER_PRESS		BarSliderPress ;
	struct	BAR_BUTTON_STILL_SELECT	BarButtonStillSelect ;
	struct	BAR_BUTTON_SELECT		BarButtonSelect ;
	struct	BAR_BUTTON_PRESS		BarButtonPress ;
	struct	BAR_BUTTON_PRESS_START		BarButtonPressStart ;
	struct	BAR_NOT_FROM_START_PRESS	BarNotFromStartPress ;
	struct	BAR_NOT_FROM_START_SELECT	BarNotFromStartSelect ;


/* CfbNXj[bZ[W */
	struct	IDX_TACK_PRESS		IdxTackPress ;
	struct	IDX_TACK_SELECT		IdxTackSelect ;
	struct	IDX_NEXT_PAGE		IdxNextPage ;
	struct	IDX_PREV_PAGE		IdxPrevPage ;
	struct	IDX_NON_TACK		IdxNonTack ;
	struct	IDX_DEAD_TACK		IdxDeadTack ;


/* j[bZ[W */
	struct	MENU_BUTTON_NORMAL		MenuButtonNormal ;
	struct	MENU_BUTTON_HILITE		MenuButtonHilite ;
	struct	MENU_BUTTON_REVERSE		MenuButtonReverse ;
	struct	MENU_BUTTON_W_REVERSE	MenuButtonWReverse ;
	struct	MENU_BUTTON_HR_REVERSE	MenuButtonHRReverse ;
	struct	MENU_BUTTON_NR_REVERSE	MenuButtonNRReverse ;
	struct	MENU_SUBMENU_CLOSE		MenuSubmenuClose ;
	struct	MENU_CHANGE_MENU_ATR	MenuChangeMenuAtr ;

	struct	MENU_SELECT			MenuSelect ;
	struct	MENU_SUB_OPEN		MenuSubOpen ;
	struct	MENU_CLOSE			MenuClose ;
	struct	MENU_SUB_CLOSE		MenuSubClose ;
	struct	MENU_PAGE_CHANGE	MenuPageChange ;
	struct	MENU_PRESS			MenuPress ;
	struct	MENU_BUTTON_PRESS	MenuButtonPress ;
	struct	LIGHT_MENU_PRESS	LightMenuPress ;
	struct	LIGHT_MENU_SELECT	LightMenuSelect ;


/* 菑Fc[bZ[W */
	struct	NINSHIKI_CONTINUE	NinshikiContinue ;
	struct	NINSHIKI_SEL_DIC	NinshikiSelDic ;
	struct	NINSHIKI_CLR_FRAME	NinshikiClrFrame ;
	struct	USER_PAT_COND_READ	UserPatCondRead ;
	struct	USER_PAT_DEL		UserPatDel ;
	struct	USER_PAT_DISP		UserPatDisp ;
	struct	USER_PAT_INIT		UserPatInit ;

	struct	NINSHIKI_COMPLETE		NinshikiComplete ;
	struct	NINSHIKI_URGENT			NinshikiUrgent ;
	struct	NINSHIKI_ERR			NinshikiErr ;
	struct	USER_PAT_NO_MATCH		UserPatNoMatch ;
	struct	USER_PAT_MEM_FULL_ERR	UserPatMemFullErr ;
	struct	USER_PAT_STRK_OVER_ERR	UserPatStrkOverErr ;
	struct	USER_PAT_ERR			UserPatErr ;

/* IvVAʋ@\bZ[W */
	struct	OPT_SEND			OptSend ;
	struct	OPT_RECEIVE			OptReceive ;
	struct	OPT_GKN_SEND		OptGknSend ;
	struct	OPT_GKN_RECEIVE		OptGknReceive ;
	struct	OPT_PRINT			OptPrint  ;
	struct	OPT_CONTROL			OptControl  ;
	struct	OPT_TRANS			OptTrans  ;

	struct	OPT_FINISHED		OptFinished ;
	struct	OPT_STOPPED			OptStopped ;
	struct	OPT_SYSTEM_ERROR	OptSystemError ;
	struct	OPT_RETURNED		OptReturned ;

	struct	BK_SEND				BK_Send ;
	struct	BK_RECEIVE			BK_Receive ;
	struct	BK_CARD				BK_Card ;
	struct	PC_START			PC_Start ;

	struct	BK_FINISHED			BK_Finished ;
	struct	BK_STOPPED			BK_Stopped ;
	struct	PC_FINISHED			PC_Finished ;
	struct	PC_STOPPED			PC_Stopped ;

/* R}hf[^NG[^ */
	struct	C_D_BUNDLECREATE		C_D_BundleCreate;
	struct	C_D_DATACOMPLETE		C_D_DataComplete;
	struct	C_D_CMDCOMPLETE			C_D_CmdComplete;
	struct	C_D_BUNDLEMAKING		C_D_BundleMaking;
	struct	C_D_BUNDLEREQUEST		C_D_BundleRequest;

/* nCubheLXgGfB^ */
	struct	BUNDLE_DATA_OPEN		BundleDataOpen ;
	struct	BUNDLE_DATA_STORE		BundleDataStore ;
	struct	FREE_AREA_AWAY			FreeAreaAway ;
	struct	FREE_AREA_GET			FreeAreaGet ;
	struct	BUF_TOP_MOVE			BufTopMove ;
	struct	BUNDLE_DATA_SET			BundleDataSet ;
	struct	CTM_CURSOR_DISP			CTMCursorDisp ;
	struct	CTM_SCALE_CHANGE		CTMScaleChange ;
	struct	CTS_TO_CLIP				CTSToClip ;
	struct	CTS_FROM_CLIP			CTSFromClip ;
	struct	CTS_STATUS_GET			CTSStatusGet ;
	struct	CTS_DROP				CTSDrop ;
	struct	CTS_REDISP				CTSRedisp ;
	struct	CTS_DRAG_DISP			CTSDragDisp ;
	struct	GET_NEXT_CONTENTS		GetNextContents ;
	struct	GET_DISP_WIDTH			GetDispWidth ;
	struct	GET_NEXT_SAME_CONTENTS	GetNextSameContents ;
	struct	CTM_SET_STYLE			CTMSetStyle;
	struct	CTM_MOJI_CONV			CTMMojiConv;
	struct	START_ATONINSIKI		StartAtoninsiki;
	struct	MOVE_SELECT_AREA		MoveSelectArea;
	struct	SET_NINSIKI_CHAR		SetNinsikiChar;
	struct	REPL_SPACE_CHAR			ReplSpaceChar;
	struct	GET_CHANGEABLE_CHAR		GetChangeableChar;
	struct	FIT_SCREEN				FitScreen;
	struct	SELECT_TOP_CHAR			SelectTopChar;
	struct	END_ATONINSIKI			EndAtoninsiki;

	struct	BUNDLE_DATA_OPEN_FIN	BundleDataOpenFin;
	struct	BUNDLE_DATA_STORE_FIN	BundleDataStoreFin;
	struct	FREE_AREA_AWAY_FIN		FreeAreaAwayFin;

/* r[}l[WbZ[W */
	struct	VMAN_SCROLL	VManScroll ;
	struct	VMAN_AUTO_SCROLL_UP		VManAutoScrollUp;
	struct	VMAN_AUTO_SCROLL_DOWN	VManAutoScrollDown;
	struct	VMAN_AUTO_SCROLL_UPDATE	VManAutoScrollUpdate;
	struct	VCONT_AUTO_SCROLL_UP	VContAutoScrollUp;
	struct	VCONT_AUTO_SCROLL_DOWN	VContAutoScrollDown;
	struct	VCONT_AUTO_SCROLL_UPDATE	VContAutoScrollUpdate;
	struct	CHECK_POSITION			CheckPosition;
	struct	VMAN_DISP_OVER			VManDispOver;
	struct	FRAME_SIZE_CHANGE		FrameSizeChange;
	struct	VMAN_ITEM_SELECT		VManItemSelect;
	struct	VMAN_ITEM_CHANGE		VManItemChange;
	struct	VMAN_YOMI_SET			VManYomiSet;
    struct	VMAN_EDIT_CHAR			VManEditChar;

/* J_[ */
	/* [IN] */
	struct	CLN_DAY_REDISP		CalendarDayRedisp;
    struct	CLN_WINDOW_REDISP	CalendarWindowRedisp ;

	/* [OUT] */
	struct	CLN_DAY_BUTTON_PRESS_START	CalendarDayButtonPressStart;
	struct	CLN_DAY_BUTTON_SELECT		CalendarDayButtonSelect;
	struct	CLN_DATE_UPDATE			CalendarDateUpdate;

    /* R\[bZ[W */
    struct CNS_ACTIVE          CnsActive ;
    struct CNS_NON_ACTIVE      CnsNonActive ;
    struct CNS_CHAR            CnsChar ;
    struct CNS_CLEAR           CnsClear ;
    struct CNS_DISP_END        CnsDispEnd ;
    struct CNS_LINES_RENEW     CnsLinesRenew ;
    struct CNS_CHECK_SCROLL    CnsCheckScroll ;

    /* ʐMObZ[W */
    struct LOG_ADD_CHAR      LogAddChar ;
    struct LOG_BACK_SPACE    LogBackSpace ;
    struct LOG_CHECK_LIST	 LogCheckList ;

/* WebRg[bZ[W */
   struct	WEB_NORMAL_END			WebNormalEnd;
   struct	WEB_CHANGE_STATE		WebChangeState;
   struct	WEB_URI_GET_ERROR		WebUriGetError;
   struct	WEB_EXT_VIEWER			WebExtViewer;
   struct	WEB_START_DATA_DOWN		WebStartDataDown;
   struct	WEB_HISTORY_BACK_ERROR	WebHistoryBackError;
   struct	WEB_HISTORY_FORW_ERROR	WebHistoryForwError;
   struct	WEB_AUTO_MAIN_NEXT_HTML	WebAutoMainNextHTML;
   struct	WEB_TEXT_INPUT			WebTextInput;
   struct	WEB_AUTHORIZATION		WebAutho;
   struct	WEB_HISTORY_BACK		WebHistoryBack;
   struct	WEB_HISTORY_FORW		WebHistoryForw;
   struct	WEB_ERROR				WebError;

