/***********************************************************************
<t@C>	winlib.h

	Copyright (c) 1995-1997 Sharp Corporation.
	All rights reserved.

	Ver.1.0	for MI-10
***********************************************************************/

/***********************************************************************
		EBhE}l[WCu`
***********************************************************************/

#ifndef _WIN_LIB_H_INCLUDED
#define	_WIN_LIB_H_INCLUDED
#include <sharpgen.h>
#include <xtaltypes.h>
#include <zdrawlib.h>

#ifdef VGA_140DPI_APL
/* EBhE[N\̒` */

typedef struct WIN_WORK_EXT {
	UCHAR	userID;
	UCHAR	WinRsvd1;			/* WinRsvd1 \ (1) */
	POINT	CrLocPoint;
	UPOINT	CrSize;
	UCHAR	WinType;
	UCHAR	PileMode;
	UCHAR	DestWinNo;
	UCHAR	OpenPosition;
	UCHAR	AutoAdjMode;
	UCHAR	WinPointSize;
	USHORT	WinDPI;
	UCHAR	ScreenType;
	UCHAR	WinRsvd2;			/* WinRsvd2 \ (2) */
	COLOR	Color;
	ULONG	WinRsvd3;			/* WinRsvd2 \ (3) */
} WIN_WORK_EXT;

/* ʃTCY (ScreenType) */
#define	QVGA_SCREEN		0
#define	VGA_SCREEN		1

/* fXNgbvEChE̎ */
typedef UCHAR DESKWINTYPE;
#define	QVGA_70DPI_QP	0
#define	VGA_140DPI_QP	1

/* VGAʗpEChE쐬}N */
#define	MakeWindowVGA(pwinwk)			\
(										\
	(pwinwk)->WinDPI = DPI_140,			\
	(pwinwk)->WinPointSize = 4,			\
    (pwinwk)->ScreenType = VGA_SCREEN,	\
	(pwinwk)->WinRsvd1 = 0,				\
	(pwinwk)->WinRsvd2 = 0,				\
	(pwinwk)->WinRsvd3 = 0,				\
	MakeWindowExt((pwinwk))				\
)

#define	OpenPadWindowVGA(pwinwk)		\
(										\
	(pwinwk)->WinDPI = DPI_140,			\
	(pwinwk)->WinPointSize = 4,			\
    (pwinwk)->ScreenType = VGA_SCREEN,	\
	(pwinwk)->WinRsvd1 = 0,				\
	(pwinwk)->WinRsvd2 = 0,				\
	(pwinwk)->WinRsvd3 = 0,				\
	OpenPadWindowExt((pwinwk))			\
)

#define	OpenWindowVGA(pwinwk)			\
(										\
	(pwinwk)->WinDPI = DPI_140,			\
	(pwinwk)->WinPointSize = 4,			\
    (pwinwk)->ScreenType = VGA_SCREEN,	\
	(pwinwk)->WinRsvd1 = 0,				\
	(pwinwk)->WinRsvd2 = 0,				\
	(pwinwk)->WinRsvd3 = 0,				\
	OpenWindowExt((pwinwk))				\
)

#define	PushOpenWindowVGA(pwinwk)		\
(										\
	(pwinwk)->WinDPI = DPI_140,			\
	(pwinwk)->WinPointSize = 4,			\
    (pwinwk)->ScreenType = VGA_SCREEN,	\
	(pwinwk)->WinRsvd1 = 0,				\
	(pwinwk)->WinRsvd2 = 0,				\
	(pwinwk)->WinRsvd3 = 0,				\
	PushOpenWindowExt((pwinwk))			\
)

#define	OpenStadWindowVGA(pwinwk)		\
(										\
	(pwinwk)->WinDPI = DPI_140,			\
	(pwinwk)->WinPointSize = 4,			\
    (pwinwk)->ScreenType = VGA_SCREEN,	\
	(pwinwk)->WinRsvd1 = 0,				\
	(pwinwk)->WinRsvd2 = 0,				\
	(pwinwk)->WinRsvd3 = 0,				\
	OpenStadWindowExt((pwinwk))			\
)

#define	OpenNormWindowVGA(pwinwk)		\
(										\
	(pwinwk)->WinDPI = DPI_140,			\
	(pwinwk)->WinPointSize = 4,			\
    (pwinwk)->ScreenType = VGA_SCREEN,	\
	(pwinwk)->WinRsvd1 = 0,				\
	(pwinwk)->WinRsvd2 = 0,				\
	(pwinwk)->WinRsvd3 = 0,				\
	OpenNormWindowExt((pwinwk))			\
)

#endif /* VGA_140DPI_APL */

/* EBhE[N\̒` */

typedef struct WIN_WORK {
	UCHAR	userID;
	POINT	CrLocPoint;
	UPOINT	CrSize;
	UCHAR	WinType;
	UCHAR	PileMode;
	UCHAR	DestWinNo;
	UCHAR	OpenPosition;
	UCHAR	AutoAdjMode;
	COLOR	Color;
} WIN_WORK;

/* EBhEe[u */
typedef struct wn {
	UCHAR		ctrl;			/* Rg[pbit */
	UCHAR		dummy1;			/* _~[f[^ */
	short		cr_loc_x;		/* Reg[W΍WX */
	short		cr_loc_y;		/*                                 Y */
	USHORT		cr_size_x;		/* Reg[WTCYX */
	USHORT		cr_size_y;		/*                           Y */
	UCHAR		type;			/* EBhẼ^Cv */
	UCHAR		option;			/* EBhE̕t */
	char		strct_x1;		/* XgNg[WItZbg */
	char		strct_y1;		/* XgNg[WItZbg */
	char		strct_x2;		/* XgNg[WEItZbg */
	char		strct_y2;		/* XgNg[WItZbg */
	USHORT		dst_size_x;		/* fXeBl[VTCYX */
	USHORT		dst_size_y;		/*                         Y */
	short		view_ofs_x;		/* r[ItZbgX */
	short		view_ofs_y;		/*                 Y */
	USHORT		cnt_min_x;		/* Reg[WminTCYX */
	USHORT		cnt_min_y;		/*                              Y */
	USHORT		cnt_max_x;		/*                     maxTCYX */
	USHORT		cnt_max_y;		/*                              Y */
	ULONG		owner_proc_name;	/* EBhẼI[i[vZX */
	ULONG		redisp_proc_name;	/* ĕ\̃vZX */
	void		(*redisp_entry)();	/* ĕ\R[obNAhX */
	void		*redisp_work;		/* ĕ\R[obNf[^ */
	void		*push_data;			/* PUSH OPENޔf[^AhX */
	long		color;			/* EBhE̐F */
	USHORT		crs_type;
	UCHAR		crs_status;
	UCHAR		crs_enable;
	short		crs_x;
	short		crs_y;
	USHORT		crs_size_x;
	USHORT		crs_size_y;
	long		crs_fc;
	long		crs_bc;

	USHORT		dpi;
	UCHAR		dot_size;
	UCHAR		origin;
	short		origin_ofs_x;
	short		origin_ofs_y;
	short		mask_x;	
	short		mask_y;	
	USHORT		mask_size_x;
	USHORT		mask_size_y;

	char		table_size;		/* Ŝ̃TCY - oƂĂ͂Ȃ */
} wn;

/* ֐` */

#ifdef	ESRL

WINDOWHD	MakeWindow();
WINDOWHD	OpenWindow();
WINDOWHD	PushOpenWindow();
WINDOWHD	OpenStadWindow();
WINDOWHD	OpenNormWindow();
void	AdjustWindow();
void	ShowWindow();
void	HideWindow();
void	DisposeWindow();
void	CloseWindow();
void	PopCloseWindow();
UCHAR	GetWindowLoc();
UCHAR	GetWindowBound();
UCHAR	SetWindowBound();
UCHAR	CheckWindow();
UCHAR	EntryRedispFunc();
UCHAR	MoveWindow();
UCHAR	ResizeWindow();
UCHAR	RelevelWindow();
UCHAR	RelevelAplWindow();
void	ResizeFrameMessage();
void	ResizeFrameTrace();
void	MoveFrameMessage();
void	MoveFrameTrace();
void	RedispStruct();
USHORT 	GetBlock();
WINDOWHD	FrontWindow();

#else

WINDOWHD	MakeWindow(WIN_WORK *);
WINDOWHD	OpenWindow(WIN_WORK *);
WINDOWHD	PushOpenWindow(WIN_WORK *);
WINDOWHD	OpenStadWindow(WIN_WORK *);
WINDOWHD	OpenNormWindow(WIN_WORK *);
void		AdjustWindow(WINDOWHD, UCHAR, UCHAR);
void		ShowWindow(WINDOWHD, UCHAR, UCHAR);
void		HideWindow(WINDOWHD);
void		DisposeWindow(WINDOWHD);
void		CloseWindow(WINDOWHD);
void		PopCloseWindow(WINDOWHD);
UCHAR		GetWindowLoc(WINDOWHD, POINT *, UPOINT *);
UCHAR		GetWindowBound(WINDOWHD, UPOINT *, UPOINT *);
UCHAR		SetWindowBound(WINDOWHD, UPOINT *, UPOINT *);
UCHAR		CheckWindow(WINDOWHD, WIN_WORK *);
UCHAR		EntryRedispFunc(WINDOWHD, OBJECT_NAME,
							void (*)(void *,WINDOWHD), void *);
UCHAR		MoveWindow(WINDOWHD, short, short);
UCHAR		ResizeWindow(WINDOWHD, USHORT, USHORT);
UCHAR		RelevelWindow(WINDOWHD, UCHAR, WINDOWHD);
UCHAR		RelevelAplWindow(WINDOWHD);
void		ResizeFrameMessage(void *, WINDOWHD, UPOINT *);
void		ResizeFrameTrace(void *, WINDOWHD, UPOINT *);
void		MoveFrameMessage(void *, WINDOWHD, POINT *, POINT *, POINT *);
void		MoveFrameTrace(void *, WINDOWHD, POINT *, POINT *, POINT *);
void		RedispStruct(WINDOWHD);
USHORT 		GetBlock(void);
WINDOWHD	FrontWindow(void);
WINDOWHD	FindWindow(POINT *, POINT *);
WINDOWHD	GetLevelWindow(UCHAR *Level);

void		ChangePhisXY(WINDOWHD,POINT*);
void		ChangeWinXY(WINDOWHD,POINT*);

void		ResetRedispArea(void);
#ifdef VGA_140DPI_APL
WINDOWHD	OpenDeskTopWindow(DESKWINTYPE);
#endif VGA_140DPI_APL
BOOLEAN		CloseDeskTopWindow(WINDOWHD);

#ifdef VGA_140DPI_APL
/* L̊֐͎gp֎~BL}N(xxxxVGA)gpĉ */
WINDOWHD	MakeWindowExt(WIN_WORK_EXT *);
WINDOWHD	OpenPadWindowExt(WIN_WORK_EXT *);
WINDOWHD	OpenWindowExt(WIN_WORK_EXT *);
WINDOWHD	PushOpenWindowExt(WIN_WORK_EXT *);
WINDOWHD	OpenStadWindowExt(WIN_WORK_EXT *);
WINDOWHD	OpenNormWindowExt(WIN_WORK_EXT *);
#endif /* VGA_140DPI_APL */

typedef UCHAR WMMODE;
#define	WM_LU_ORIGIN	0x01	/* }XN̍EChE_Ƃ */
BOOLEAN SetWinMask(WINDOWHD,RECTANGLE *,WMMODE);
BOOLEAN ResetWinMask(WINDOWHD);
BOOLEAN GetWinMask(WINDOWHD,RECTANGLE *,WMMODE *);

BOOLEAN SetWinOrigin(WINDOWHD,POINT *);
BOOLEAN ResetWinOrigin(WINDOWHD);

#endif

#ifndef H2EQU
/* ChangePhisXYƂChangeWinXỸGCAX */
#define	WinLocalToGlobal	ChangePhisXY
#define	WinGlobalToLocal	ChangeWinXY

/* ĕ\֐𖳌ɂ}N */
#define	KillRedispFunc(w)	EntryRedispFunc(w,0,NULL,NULL)
#endif H2EQU

/* [Uhc */
#define	APL_WIN			1	/* AvP[ṼEBhE */
#define	APM_WIN			2
#define	APL_SUB_WIN		3
#define	FEP_WIN			4
#define IOCS_WIN		5
#define	TOOL_WIN		6

/* dȂ */
#define	TOP				0			/* ԏ */
#define	BOTTOM			0x80		/* ԉ */
#define	OVER			0x40		/* wEBhȄ */
#define	UNDER			0xc0		/* wEBhẺ */

/* EBhE^Cv */
#define	WN_WITH_SHADOW	0x80		/* 10000000 et */
#define	WN_TRANSPARENT	0x40		/* 01000000  - crimsonŒǉ */
#define	WN_DARK			0x20		/* 00100000 Ó] - crimsonŒǉ */
#define	WN_NO_FRAME		0			/*	    	gȂ */
#define WN_SINGLE_FRAME	1			/* 00000001 dg */
#define	WN_DOUBLE_FRAME	2			/* 00000010 dg */
#define	WN_WHITE_FRAME	3			/* 00000011 g - crimsonŔp~ */
#define	WN_ROUND_FRAME	4			/* 00000100	ۘg */

#define	WN_TYPE_MASK	0x0f

/* EBhEIvV */
#define	WN_CLOSE_UP_BOX	1
#define	WN_SIZE_BOX		2
#define	WN_CLOSE_BOX	4
#define	WN_RIGHT_BAR	16
#define	WN_LOWER_BAR	32


/* Tʒu */
#define	ON_LINE			0x04	/* I(AUTO)̎͂ */
#define	BY_LINE			0x08	/* ꂩݒI   */

#define	CENTER			0		/*  */
#define	ON_RU_CORNER	0x04	/* E㉏ */
#define	ON_LU_CORNER	0x05	/* ㉏ */
#define	ON_RD_CORNER	0x06	/* E */
#define	ON_LD_CORNER	0x07	/*  */
#define	BY_RU_CORNER	0x08	/* E㉏t */
#define	BY_LU_CORNER	0x09	/* ㉏t */
#define	BY_RD_CORNER	0x0a	/* Et */
#define	BY_LD_CORNER	0x0b	/* t */
#define	ON_UP_CENTER	0x14	/* ㉏ */
#define	ON_DW_CENTER	0x16	/*  */
#define	BY_UP_CENTER	0x18	/* ㉏ */
#define	BY_DW_CENTER	0x1a	/*  */

/* TʒuIvV */
#define	APPOINT		0	/* Tʒu̎wǂJ */
				/* ̏ꍇOpenPositon */
				/* CENTER-BY_DW_CENTER̒lZbg  */
				/* ̏ꍇCrLocPoint͖ӖɂȂ */

#define	AUTO		1	/* I[ṽEBhE */
				/* ̏ꍇOpenPositonON_LINEBY_LINE */
				/* ̒lZbg */
				/* ̏ꍇCrLocPoint͖ӖɂȂ */

#define	NONE		0xff	/* EBhE̎Ȃ */
				/* CrLocPointŎw肵ʂɊJ */
				/* ̏ꍇOpenPosition͖ӖɂȂ */

/* ȃEBhEnh */
#define	WNHANDLE_NULL	0

#endif

